{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }


unit CommonCtrl;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  ExtCtrls, StdCtrls, Forms, ComCtrls;

type

  { TCheckLabel}

  TSndEvent = (seClick, seOver, seDone, seBreak);
  TCheckState = (csBefore, csCurrent, csAfter);

  TCheckLabel = class(TGraphicControl)
  private
    FBulbImg: TBitmap;
    FAlignment: TAlignment;
    FAutoSize: Boolean;
    FLayout: TTextLayout;
    FWordWrap: Boolean;
    FImageSpacing: Integer;
    FCheckState: TCheckState;
    FNormalColor: TColor;
    FActiveColor: TColor;
    FBulbCellCount: Integer;
    FBulbCellWidth: Integer;
    FBulbCellHeight: Integer;
    FFrame: integer;
    procedure DoDrawText(var Rect: TRect; Flags: Word);
    function  GetTransparent: Boolean;
    procedure SetBulbImg(Value:Tbitmap);
    procedure SetAlignment(Value: TAlignment);
    procedure SetAutoSizeInt(Value: Boolean);
    procedure SetLayout(Value: TTextLayout);
    procedure SetTransparent(Value: Boolean);
    procedure SetWordWrap(Value: Boolean);
    procedure SetImageSpacing(const Value: Integer);
    procedure SetNormalColor(const Value: TColor);
    procedure SetActiveColor(const Value: TColor);
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure DrawBulb(X,Y:integer; AState:TCheckState);

  protected
    { protected declarations }
    procedure SetCheckState(const Value: TCheckState);
    procedure AdjustBounds;
    function  GetDefaultFontColor: TColor; virtual;
    function  GetLabelCaption: string; virtual;
    procedure Paint; override;

  public
    { public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Canvas;
    procedure LoadBulbImgFromRes(Instance: THandle; Name:string);
    procedure LoadBulbImgFromFile(FileName:string);

  published
    { published declarations }
    property BulbImg:TBitmap read FBulbImg write SetBulbImg;
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property AutoSize: Boolean read FAutoSize write SetAutoSizeInt default True;
    property Layout: TTextLayout read FLayout write SetLayout default tlTop;
    property Transparent: Boolean read GetTransparent write SetTransparent default False;
    property WordWrap: Boolean read FWordWrap write SetWordWrap default False;
    property ImageSpacing: Integer read FImageSpacing write SetImageSpacing;
    property CheckState: TCheckState  read FCheckState write SetCheckState;
    property ActiveColor: TColor read FActiveColor write SetActiveColor;
    property NormalColor: TColor read FNormalColor write SetNormalColor;
    property Align;
    property Caption;
    property Color;
    property Enabled;
    property Font;
    property Visible;
  end;

  {TProgressImage}

  TProgressImage = class(TGraphicControl)
  private
   { private declarations }
    FPictImg: TBitmap;
    FPictCount:Cardinal;
    FActivePictUp:Cardinal;
    FActivePictUpState:Cardinal;
    FActivePictDown:Cardinal;
    FActivePictDownState:Cardinal;
    FPictSpacing:Cardinal;
    FPictFrames:Cardinal;
    FTimer:TTimer;
    procedure OnTimer(Sender: TObject);
    procedure SetActive(Value:boolean);
    function  GetActive:boolean;
    procedure SetInterval(Value:Cardinal);
    function  GetInterval:Cardinal;
    procedure SetPictCount(Value:Cardinal);
    procedure SetPictSpacing(Value:Cardinal);
    procedure SetPictImg(Value:TBitmap);
  protected
    { protected declarations }
    procedure Paint; override;
    procedure AdjustBounds;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure LoadPictImgFromRes(Instance: THandle; Name:string);
    procedure LoadPictImgFromFile(FileName:string);
  published
    { Public declarations }
    property PictImg: TBitmap read FPictImg write SetPictImg;
    property Active: boolean read GetActive write SetActive;
    property Interval: Cardinal read GetInterval write SetInterval;
    property PictCount: Cardinal read FPictCount write SetPictCount;
    property PictSpacing: Cardinal read FPictSpacing write SetPictSpacing;
  end;

  {TCoolButton}

  TCoolButtonState = (cbUp, cbDown, cbDisabled);
  TCoolButtonMode = (cmButton, cmCheckBox, cmRadioButton);

  TCoolButton = class(TGraphicControl)
  private
    FDown: Boolean;
    FChecked:boolean;
    FMode:TCoolButtonMode;
    FSpacing: Integer;
    FCaption: string;
    FActivateSnd: string;
    FClickSnd: string;
    FDragging: Boolean;
    FMouseInControl: Boolean;
    FTimer:TTimer;
    FGlyph: TBitmap;
    FGlyphCellWidth:integer;
    FGlyphCellHeight:integer;
    FActiveUnderline:boolean;
    FActiveColor: TColor;
    function MouseInControl: Boolean;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
    procedure SetGlyph(Value: TBitmap);
    procedure SetCaption(Value: String);
    procedure SetChecked(Value: boolean);
    procedure SetMode(Value: TCoolButtonMode);
    procedure OnMouseTimer(Sender: TObject);
    procedure AdjustBounds;

  protected
    FState: TCoolButtonState;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure Paint; override;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
    procedure LoadGlyphFromRes(Instance: THandle; Name:string);
    procedure LoadGlyphFromFile(FileName:string);
  published
    property Enabled;
    property Glyph : TBitmap write SetGlyph;
    property Caption: string read FCaption write SetCaption;
    property ActiveColor: TColor read FActiveColor write FActiveColor;
    property ActivateSnd: string read FActivateSnd write FActivateSnd;
    property ActiveUnderline: boolean read FActiveUnderline write FActiveUnderline;
    property ClickSnd: string read FClickSnd write FClickSnd;
    property Checked: boolean read FChecked write SetChecked default true;
    property Mode: TCoolButtonMode read FMode write SetMode default cmButton;
    property ParentShowHint;
    property ParentBiDiMode;
    property Font;
    property ShowHint;
    property Visible;
    property OnClick;
  end;

  {TShadowLabel}

  TShadowPosition = (spLeftTop, spLeftBottom, spRightBottom, spRightTop);

  TShadowLabel = class(TGraphicControl)
  private
    FAlignment: TAlignment;
    FAutoSize: Boolean;
    FLayout: TTextLayout;
    FShadowColor: TColor;
    FShadowSize: Byte;
    FShadowPos: TShadowPosition;
    FWordWrap: Boolean;
    procedure DoDrawText(var Rect: TRect; Flags: Word);
    function GetTransparent: Boolean;
    procedure SetAlignment(Value: TAlignment);
    procedure SetAutoSizeInt(Value: Boolean);
    procedure SetLayout(Value: TTextLayout);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowSize(Value: Byte);
    procedure SetShadowPos(Value: TShadowPosition);
    procedure SetTransparent(Value: Boolean);
    procedure SetWordWrap(Value: Boolean);
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;

  protected
    procedure AdjustBounds;
    function GetDefaultFontColor: TColor; virtual;
    function GetLabelCaption: string; virtual;
    procedure Paint; override;

  public
    constructor Create(AOwner: TComponent); override;
    property Canvas;

  published
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property AutoSize: Boolean read FAutoSize write SetAutoSizeInt default True;
    property Layout: TTextLayout read FLayout write SetLayout default tlTop;
    property ShadowColor: TColor read FShadowColor write SetShadowColor default clBtnHighlight;
    property ShadowSize: Byte read FShadowSize write SetShadowSize default 1;
    property ShadowPos: TShadowPosition read FShadowPos write SetShadowPos default spLeftTop;
    property Transparent: Boolean read GetTransparent write SetTransparent default False;
    property WordWrap: Boolean read FWordWrap write SetWordWrap default False;
    property Align;
    property Caption;
    property Color;
    property Enabled;
    property Font;
    property Visible;
  end;

  {TMyProgress}

  TProgressKind = (pkHorizontalBar, pkVerticalBar);

  TMyProgress = class(TGraphicControl)
  private
    FMinValue: Longint;
    FMaxValue: Longint;
    FCurValue: Longint;
    FKind: TProgressKind;
    FShowText: Boolean;
    FBorderStyle: TBorderStyle;
    FForeColor: TColor;
    FBackColor: TColor;
    procedure PaintBackground(AnImage: TBitmap);
    procedure PaintAsText(AnImage: TBitmap; PaintRect: TRect);
    procedure PaintAsBar(AnImage: TBitmap; PaintRect: TRect);
    procedure SetGaugeKind(Value: TProgressKind);
    procedure SetShowText(Value: Boolean);
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetForeColor(Value: TColor);
    procedure SetBackColor(Value: TColor);
    procedure SetMinValue(Value: Longint);
    procedure SetMaxValue(Value: Longint);
    procedure SetProgress(Value: Longint);
    function GetPercentDone: Longint;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure AddProgress(Value: Longint);
    property PercentDone: Longint read GetPercentDone;
  published
    property Align;
    property Anchors;
    property BackColor: TColor read FBackColor write SetBackColor default clWhite;
    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsSingle;
    property Color;
    property Constraints;
    property Enabled;
    property ForeColor: TColor read FForeColor write SetForeColor default clBlack;
    property Font;
    property Kind: TProgressKind read FKind write SetGaugeKind default pkHorizontalBar;
    property MinValue: Longint read FMinValue write SetMinValue default 0;
    property MaxValue: Longint read FMaxValue write SetMaxValue default 100;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property Progress: Longint read FCurValue write SetProgress;
    property ShowHint;
    property ShowText: Boolean read FShowText write SetShowText default True;
    property Visible;
  end;

  {TCoolImage}

  TStretchType = (stRealSize, stReduce, stEnlarge, stAlwas);

  TCoolImage = class(TGraphicControl)
  private
    FPicture: TPicture;
    FStretch: TStretchType;
    FCenter: Boolean;
    FIncrementalDisplay: Boolean;
    FTransparent: Boolean;
    FDrawing: Boolean;
    FProportional: Boolean;
    FClickable: boolean;
    FClickSnd: string;
    procedure PictureChanged(Sender: TObject);
    procedure SetCenter(Value: Boolean);
    procedure SetPicture(Value: TPicture);
    procedure SetTransparent(Value: Boolean);
    procedure SetProportional(Value: Boolean);
    procedure SetStretch(Value: TStretchType);
    procedure SetClickable(Value: Boolean);
  protected
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    function DestRect: TRect;
    function DoPaletteChange: Boolean;
    function GetPalette: HPALETTE; override;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure LoadImgFromRes(Instance: THandle; Name:string);
    procedure LoadImgFromFile(FileName:string);
    procedure Click; override;
  published
    property Align;
    property AutoSize;
    property Center: Boolean read FCenter write SetCenter default False;
    property Enabled;
    property IncrementalDisplay: Boolean read FIncrementalDisplay write FIncrementalDisplay default False;
    property ParentShowHint;
    property Picture: TPicture read FPicture write SetPicture;
    property Proportional: Boolean read FProportional write SetProportional default false;
    property ShowHint;
    property Stretch: TStretchType read FStretch write SetStretch default stRealSize;
    property Transparent: Boolean read FTransparent write SetTransparent default False;
    property Clickable: Boolean read FClickable write SetClickable default False;
    property ClickSnd: string read FClickSnd write FClickSnd;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TUrlLabel = class (TLabel)
  private
    FActiveColor:TColor;
    FInActiveColor:TColor;
    FActiveUnderline:boolean;
    FActiveBold:boolean;
    FActivateSnd: string;
    FClickSnd: string;
    FDragging: Boolean;
    FMouseInControl: Boolean;
    FTimer:TTimer;
    function MouseInControl: Boolean;
    procedure OnMouseTimer(Sender: TObject);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
  protected
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property ActiveColor: TColor read FActiveColor write FActiveColor;
    property InActiveColor: TColor read FInActiveColor write FInActiveColor;
    property ActivateSnd: string read FActivateSnd write FActivateSnd;
    property ClickSnd: string read FClickSnd write FClickSnd;
    property ActiveUnderline: boolean read FActiveUnderline write FActiveUnderline;
    property ActiveBold: boolean read FActiveBold write FActiveBold;
  end;


  {TSmartMemo}

  TSmartMemo = class (TRichEdit)
  private
   aFontName:string;
   aFontColor:TColor;
   aFontSize: integer;
  protected
   procedure SetFontColor(value:TColor);
   procedure SetFontName(value:string);
   procedure SetFontSize(value:integer);
  public
   procedure UpdateText(IsRtf:boolean);
   procedure LoadText(FileName:string);
   constructor Create(AOwner: TComponent); override;
  published
   property FontName:string  read  aFontName write SetFontName;
   property FontColor:TColor read  aFontColor write SetFontColor;
   property FontSize: integer read aFontSize write  SetFontSize;
  end;

  THackControl = class(TControl)
  public
    property Font;
  end;

  type
   TDirection = (bdUp, bdDown, bdLeft, bdRight, bdHorzIn,
                 bdHorzOut, bdVertIn, bdVertOut, bdTiledImage, bdStretchImage);
   TOneWayType = (Up, Down, DLeft, DRight);
   TTwoWayType = (DIn, DOut);
   TTwoWayDir = (Horz, Vert);


type
  TBackDrop = class(TGraphicControl)
   private
    { Private declarations }
   fDir: TDirection;
   ftop:integer;
   fClrIn: TColor;
   fClrOut: TColor;
   fPicture : Graphics.TBitmap;
   fOldWndProc : pointer;
   fGradCount: byte;
   fActive:boolean;
   procedure ImageChange(Sender:TObject);
   procedure HookWndProc;
   procedure UnHookWndProc;
   procedure NewWndProc(var Message : TMessage);
   procedure StretchDrawImage;
   procedure TiledDrawImage;
   procedure SetDir(Value: TDirection);
   procedure SetColorIn(Value: TColor);
   procedure SetColorOut(Value: TColor);
   procedure SetPicture(Value : TBitmap);
   procedure SetGradientCount(Value : byte);
   procedure SetActive(Value : boolean);
   procedure FillOneWay(WType: TOneWayType; ClrIn, ClrOut: TColor);
   procedure FillTwoWay(WType: TTwoWayType; WDir: TTwoWayDir; ClrIn, ClrOut: TColor);
   function  LocalCheckImage:boolean;
  protected
    { Protected declarations }
   procedure SetParent(AParent : TWinControl); override;
   procedure Paint; override;
  public
    { Public declarations }
   constructor Create(AOwner: TComponent); override;
   procedure LoadPictureFromRes(Instance: THandle; Name:string);
   procedure LoadPictureFromFile(FileName:string);
   destructor  Destroy; override;
  published
   { Published declarations }
   property Direction: TDirection read FDir write SetDir default bdUp;
   property ColorIn: TColor read FClrIn write SetColorIn default clBlue;
   property ColorOut: TColor read FClrOut write SetColorOut default clBlack;
   property GradientCount: byte read FGradCount write SetGradientCount default $ff;
   property Wallpaper : TBitmap read FPicture write SetPicture;
   property Active: boolean read FActive write SetActive default true;
   property OnClick;
   property OnDblClick;
   property OnDragDrop;
   property OnDragOver;
   property OnEndDrag;
   property OnMouseDown;
   property OnMouseMove;
   property OnMouseUp;
   property OnStartDrag;
  end;




procedure PlaySnd(SoundFilename:String; Wait:boolean);

  var
   AlphaLevel:byte = 255;
   GlobalPlaySound:boolean = true;
   CommonFont:string ='Arial';

implementation

uses
  Themes, MMSystem;//, GlobalConst, CommonProc;
   
var
  AnimateWindowProc: TAnimateWindowProc = nil;


function Min(A,B:integer):Integer;
begin
  if A > B then result:= B else  result:= A;
end;

function Max(A,B:integer):Integer;
begin
  if A < B then result:= B else  result:= A;
end;

function WidthOf(R: TRect): Integer;
begin
  Result := R.Right - R.Left;
end;

function HeightOf(R: TRect): Integer;
begin
  Result := R.Bottom - R.Top;
end;

procedure Delay(MSecs: Longint);
var
  FirstTickCount, Now: Longint;
begin
  FirstTickCount := GetTickCount;
  repeat
    Application.ProcessMessages;
    Sleep(10);
    Now := GetTickCount;
  until (Now - FirstTickCount >= MSecs) or (Now < FirstTickCount) or Application.Terminated;
end;

procedure PlaySnd(SoundFilename:String; Wait:boolean);
var
  Flag:integer;
  WaveCaps:TWaveOutCaps;
begin
 if not GlobalPlaySound then exit;
 if WaveOutGetNumDevs = 0 then exit;
 if WaveOutGetDevCaps(WAVE_MAPPER, @WaveCaps, sizeof(WaveCaps)) <> MMSYSERR_NOERROR then exit;
 Flag:= SND_FILENAME or SND_NOWAIT or SND_NODEFAULT or SND_APPLICATION or SND_NOSTOP;
 if Wait then Flag:= Flag or SND_SYNC else  Flag:= Flag or SND_ASYNC;
 if FileExists(SoundFilename) then PlaySound(PChar(SoundFilename),0,Flag);
end;

const
  cHotkeyPrefix = '&';

function GetHotkey(const Text: string): string;
var
  I, L: Integer;
begin
  Result := '';
  I := 1;
  L := Length(Text);
  while I <= L do
  begin
    if Text[I] in LeadBytes then
      Inc(I)
    else if (Text[I] = cHotkeyPrefix) and
            (L - I >= 1) then
    begin
      Inc(I);
      if Text[I] <> cHotkeyPrefix then
        Result := Text[I]; // keep going there may be another one
    end;
    Inc(I);
  end;
end;

function IsAccel(VK: Word; const Str: string): Boolean;
begin
  Result := AnsiCompareText(Char(VK), GetHotKey(Str)) = 0;
end;

{------------------------ Gradient fill routunes ------------------------------}

procedure HorzOneWay(ACanvas:TCanvas; ARect:Trect; Clr1, Clr2: TColor; GradCount:byte);
var
  RGBFrom   : array[0..2] of Byte;    { from RGB values                     }
  RGBDiff   : array[0..2] of integer; { difference of from/to RGB values    }
  ColorBand : TRect;                  { color band rectangular coordinates  }
  I         : Integer;                { color band index                    }
  R         : Byte;                   { a color band's R value              }
  G         : Byte;                   { a color band's G value              }
  B         : Byte;                   { a color band's B value              }
begin
   { extract from RGB values}
   RGBFrom[0] := GetRValue (ColorToRGB (Clr1));
   RGBFrom[1] := GetGValue (ColorToRGB (Clr1));
   RGBFrom[2] := GetBValue (ColorToRGB (Clr1));
   { calculate difference of from and to RGB values}
   RGBDiff[0] := GetRValue (ColorToRGB (Clr2)) - RGBFrom[0];
   RGBDiff[1] := GetGValue (ColorToRGB (Clr2)) - RGBFrom[1];
   RGBDiff[2] := GetBValue (ColorToRGB (Clr2)) - RGBFrom[2];
   { set pen sytle and mode}
   ACanvas.Pen.Style := psSolid;
   ACanvas.Pen.Mode := pmCopy;
   { set color band's left and right coordinates}
   ColorBand.Left := ARect.Left;
   ColorBand.Right := ARect.Right;
   //for I := 0 to $ff do
   for I := 0 to GradCount do
   begin
       { calculate color band's top and bottom coordinates}
       ColorBand.Top    := MulDiv (I , ARect.Bottom - ARect.Top, GradCount+1);
       ColorBand.Bottom := MulDiv (I + 1, ARect.Bottom - ARect.Top, GradCount+1);
       { calculate color band color}
       R := RGBFrom[0] + MulDiv (I, RGBDiff[0], GradCount);
       G := RGBFrom[1] + MulDiv (I, RGBDiff[1], GradCount);
       B := RGBFrom[2] + MulDiv (I, RGBDiff[2], GradCount);
       { select brush and paint color band}
       ACanvas.Brush.Color := RGB (R, G, B);
       ACanvas.FillRect (ColorBand);
   end;
end;


procedure VertOneWay(ACanvas:TCanvas;  ARect:Trect; Clr1, Clr2: TColor; GradCount:byte);
var
  RGBFrom   : array[0..2] of Byte;    { from RGB values                     }
  RGBDiff   : array[0..2] of integer; { difference of from/to RGB values    }
  ColorBand : TRect;                  { color band rectangular coordinates  }
  I         : Integer;                { color band index                    }
  R         : Byte;                   { a color band's R value              }
  G         : Byte;                   { a color band's G value              }
  B         : Byte;                   { a color band's B value              }
begin
   { extract from RGB values}
   RGBFrom[0] := GetRValue (ColorToRGB (Clr1));
   RGBFrom[1] := GetGValue (ColorToRGB (Clr1));
   RGBFrom[2] := GetBValue (ColorToRGB (Clr1));
   { calculate difference of from and to RGB values}
   RGBDiff[0] := GetRValue (ColorToRGB (Clr2)) - RGBFrom[0];
   RGBDiff[1] := GetGValue (ColorToRGB (Clr2)) - RGBFrom[1];
   RGBDiff[2] := GetBValue (ColorToRGB (Clr2)) - RGBFrom[2];
   { set pen sytle and mode}
   ACanvas.Pen.Style := psSolid;
   ACanvas.Pen.Mode := pmCopy;
   { set color band's left and right coordinates}
   ColorBand.Top := ARect.Top;
   ColorBand.Bottom := ARect.Bottom;
   for I := 0 to GradCount do
   begin
       { calculate color band's top and bottom coordinates}
       ColorBand.Left    := MulDiv (I    , ARect.Right - ARect.Left, GradCount+1);
       ColorBand.Right := MulDiv (I + 1, ARect.Right - ARect.Left, GradCount+1);
       { calculate color band color}
       R := RGBFrom[0] + MulDiv (I, RGBDiff[0], GradCount);
       G := RGBFrom[1] + MulDiv (I, RGBDiff[1], GradCount);
       B := RGBFrom[2] + MulDiv (I, RGBDiff[2], GradCount);
       { select brush and paint color band}
       ACanvas.Brush.Color := RGB (R, G, B);
       ACanvas.FillRect (ColorBand);
   end;
end;


procedure HorzTwoWay(ACanvas:TCanvas;  ARect:Trect; Clr1, Clr2: TColor; GradCount:byte);
var
  RGBFrom   : array[0..2] of Byte;    { from RGB values                     }
  RGBDiff   : array[0..2] of integer; { difference of from/to RGB values    }
  ColorBand : TRect;                  { color band rectangular coordinates  }
  j, I      : Integer;                { color band index                    }
  R         : Byte;                   { a color band's R value              }
  G         : Byte;                   { a color band's G value              }
  B         : Byte;                   { a color band's B value              }
begin
   { extract from RGB values}
   RGBFrom[0] := GetRValue (ColorToRGB (Clr1));
   RGBFrom[1] := GetGValue (ColorToRGB (Clr1));
   RGBFrom[2] := GetBValue (ColorToRGB (Clr1));
   { calculate difference of from and to RGB values}
   RGBDiff[0] := GetRValue (ColorToRGB (Clr2)) - RGBFrom[0];
   RGBDiff[1] := GetGValue (ColorToRGB (Clr2)) - RGBFrom[1];
   RGBDiff[2] := GetBValue (ColorToRGB (Clr2)) - RGBFrom[2];
   { set pen sytle and mode}
   ACanvas.Pen.Style := psSolid;
   ACanvas.Pen.Mode := pmCopy;
   { set color band's left and right coordinates}
   ColorBand.Left := ARect.Left;
   ColorBand.Right := ARect.Right;
   for I := 0 to (GradCount div 2) do
   begin
       { calculate color band's top and bottom coordinates}
       ColorBand.Top    := MulDiv (I    , ARect.Bottom - ARect.Top, GradCount);
       ColorBand.Bottom := MulDiv (I + 1, ARect.Bottom - ARect.Top, GradCount);
       { calculate color band color}
       R := RGBFrom[0] + MulDiv (I * 2, RGBDiff[0], GradCount);
       G := RGBFrom[1] + MulDiv (I * 2, RGBDiff[1], GradCount);
       B := RGBFrom[2] + MulDiv (I * 2, RGBDiff[2], GradCount);
       { select brush and paint color band}
       ACanvas.Brush.Color := RGB (R, G, B);
       ACanvas.FillRect (ColorBand);
   end;
   j := I-1;
   for I := (GradCount div 2) to GradCount  do
   begin
       ColorBand.Top    := MulDiv (I    , ARect.Bottom - ARect.Top, GradCount);
       ColorBand.Bottom := MulDiv (I + 1, ARect.Bottom - ARect.Top, GradCount);
       R := RGBFrom[0] + MulDiv (j * 2, RGBDiff[0], GradCount);
       G := RGBFrom[1] + MulDiv (j * 2, RGBDiff[1], GradCount);
       B := RGBFrom[2] + MulDiv (j * 2, RGBDiff[2], GradCount);
       ACanvas.Brush.Color := RGB (R, G, B);
       ACanvas.FillRect (ColorBand);
       Dec(j);
   end;
end;


procedure VertTwoWay(ACanvas:TCanvas;  ARect:Trect; Clr1, Clr2: TColor; GradCount:byte);
var
  RGBFrom   : array[0..2] of Byte;    { from RGB values                     }
  RGBDiff   : array[0..2] of integer; { difference of from/to RGB values    }
  ColorBand : TRect;                  { color band rectangular coordinates  }
  j, I      : Integer;                { color band index                    }
  R         : Byte;                   { a color band's R value              }
  G         : Byte;                   { a color band's G value              }
  B         : Byte;                   { a color band's B value              }
begin
   { extract from RGB values}
   RGBFrom[0] := GetRValue (ColorToRGB (Clr1));
   RGBFrom[1] := GetGValue (ColorToRGB (Clr1));
   RGBFrom[2] := GetBValue (ColorToRGB (Clr1));
   { calculate difference of from and to RGB values}
   RGBDiff[0] := GetRValue (ColorToRGB (Clr2)) - RGBFrom[0];
   RGBDiff[1] := GetGValue (ColorToRGB (Clr2)) - RGBFrom[1];
   RGBDiff[2] := GetBValue (ColorToRGB (Clr2)) - RGBFrom[2];
   { set pen sytle and mode}
   ACanvas.Pen.Style := psSolid;
   ACanvas.Pen.Mode := pmCopy;
   { set color band's left and right coordinates}
   ColorBand.Top := ARect.Top;
   ColorBand.Bottom := ARect.Bottom;
   for I := 0 to (GradCount div 2) do
   begin
      { calculate color band's top and bottom coordinates}
       ColorBand.Left  := MulDiv (I    , ARect.Right - ARect.Left, GradCount);
       ColorBand.Right := MulDiv (I + 1, ARect.Right - ARect.Left, GradCount);
       { calculate color band color}
       R := RGBFrom[0] + MulDiv (I * 2, RGBDiff[0], GradCount);
       G := RGBFrom[1] + MulDiv (I * 2, RGBDiff[1], GradCount);
       B := RGBFrom[2] + MulDiv (I * 2, RGBDiff[2], GradCount);
       { select brush and paint color band}
       ACanvas.Brush.Color := RGB (R, G, B);
       ACanvas.FillRect (ColorBand);
   end;
   j := I-1;
   for I := (GradCount div 2) to GradCount do
   begin
       ColorBand.Left  := MulDiv (I    , ARect.Right - ARect.Left, GradCount);
       ColorBand.Right := MulDiv (I + 1, ARect.Right - ARect.Left, GradCount);
       R := RGBFrom[0] + MulDiv (j * 2, RGBDiff[0], GradCount);
       G := RGBFrom[1] + MulDiv (j * 2, RGBDiff[1], GradCount);
       B := RGBFrom[2] + MulDiv (j * 2, RGBDiff[2], GradCount);
       ACanvas.Brush.Color := RGB (R, G, B);
       ACanvas.FillRect (ColorBand);
       Dec(j);
   end;
end;



{********* Common pictures procs ****************************************}

function MyTransparentBlt(ACanvas:TCanvas;X,Y,W,H:integer;ABmp:Tbitmap;XS,YS,WS,HS:integer):boolean;
var
  BlendFunc: TBlendFunction;
  SaveDC,MaskDC : HDC;
begin
  if (ABmp.PixelFormat = pf32bit) then  begin
     {Bimap is 32 bit}
     BlendFunc.BlendOp:=AC_SRC_OVER;
     BlendFunc.BlendFlags:=0;
     BlendFunc.SourceConstantAlpha:=AlphaLevel;
     BlendFunc.AlphaFormat:=  AC_SRC_ALPHA;

     result:= AlphaBlend(ACanvas.Handle,
                         X, Y, W, H,
                         ABmp.Canvas.Handle,
                         XS,YS,WS,HS,
                         BlendFunc);
  end else begin
      {bitmap les 32 bit}
      SaveDC := 0;
      MaskDC := 0;
      try
        MaskDC := CreateCompatibleDC(0);
        SaveDC := SelectObject(MaskDC, ABmp.MaskHandle);
        result:= TransparentStretchBlt(ACanvas.Handle,
                                       X, Y, W, H,
                                       ABmp.Canvas.Handle,
                                       XS,YS,WS,HS,
                                       MaskDC,
                                       XS,YS);
      finally
          if SaveDC <> 0 then SelectObject(MaskDC, SaveDC);
          if MaskDC <> 0 then DeleteDC(MaskDC);
      end;
    {TransparentBlt - resource leaks in Win 98/me}
    { Result:=TransparentBlt(ACanvas.Handle,
                             X, Y, W, H,
                             ABmp.Canvas.Handle,
                             XS,YS,WS,HS,
                             ABmp.Canvas.Pixels[0,0]);}
  end;
end;

{********* TCheckLabel **************************************************}

const
 Alignments: array [TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
 WordWraps: array[Boolean] of Word = (0, DT_WORDBREAK);

constructor TCheckLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csOpaque];
  ControlStyle := ControlStyle + [csReplicatable];
  Width := 65;
  Height := 17;
  FAutoSize := True;
  FBulbImg:=TBitmap.Create;
  //FBulbCellCount:=3;
  //FBulbCellWidth:= 15;
  //FBulbCellHeight:=15;
  //WordWrap:=true;
  FFrame:=0;
  FImageSpacing := 5;
  FCheckState:= csBefore;
  Transparent:=true;
  FNormalColor:= clWhite;
  FActiveColor:= $0080ff;
  ParentFont:=false;
  Font.Color:= FNormalColor;
  Font.Name:=CommonFont;
end;

destructor TCheckLabel.Destroy;
begin
  FBulbImg.Free;
  inherited Destroy;
end;


function TCheckLabel.GetLabelCaption: string;
begin
  Result := Caption;
end;

function TCheckLabel.GetDefaultFontColor: TColor;
begin
  Result := Font.Color;
end;

procedure TCheckLabel.DoDrawText(var Rect: TRect; Flags: Word);
var
  Text: string;
begin
  Text := GetLabelCaption;
  if (Flags and DT_CALCRECT <> 0) and (Text = '')  then Text := Text + ' ';
  Flags := Flags or DT_NOPREFIX;
  if FCheckState in [csCurrent, csAfter] then Font.Style:=Font.Style + [fsBold] else Font.Style:=Font.Style - [fsBold];
  if FCheckState = csCurrent then Font.Color := FActiveColor else Font.Color:= FNormalColor;
  Canvas.Font := Font;
  SetTextColor(Canvas.Handle, Canvas.Font.Color);
  DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
end;

procedure  TCheckLabel.DrawBulb(X,Y:integer; AState:TCheckState);
  var
    ImgId:integer;
begin
ImgId:=Ord(AState) + FFrame;
MyTransparentBlt(Canvas, X, Y, FBulbCellWidth , FBulbCellHeight,
                 BulbImg, ImgId * FBulbCellWidth, 0, FBulbCellWidth, FBulbCellHeight);
end;


procedure TCheckLabel.Paint;
var
  ARect: TRect;
  DrawStyle: Integer;
begin
  with Canvas do begin
    if not Transparent then begin
      Brush.Color := Self.Color;
      Brush.Style := bsSolid;
      FillRect(ClientRect);
    end;
    Brush.Style := bsClear;
    ARect := ClientRect;
    InflateRect(ARect, -1, 0);

    if BulbImg <> nil then
       if FAlignment <> taRightJustify then Inc(ARect.Left,FBulbCellWidth + FImageSpacing)
                                       else Dec(ARect.Right,FBulbCellWidth + FImageSpacing);

    DrawStyle := DT_EXPANDTABS or WordWraps[FWordWrap] or Alignments[FAlignment];
    { Calculate vertical layout }
    if FLayout <> tlTop then begin
      DoDrawText(ARect, DrawStyle or DT_CALCRECT);
      ARect.Left := ClientRect.Left;
      ARect.Right := ClientRect.Right;
      if FLayout = tlBottom then OffsetRect(ARect, 0, Height - ARect.Bottom)
      else OffsetRect(ARect, 0, (Height - ARect.Bottom) div 2);
    end;
    DoDrawText(ARect, DrawStyle);
    if BulbImg <> nil then begin
       if FAlignment <> taRightJustify then begin
            Dec(ARect.Left,FBulbCellWidth + FImageSpacing);
            DrawBulb(ARect.Left, ARect.Top, FCheckState);
          end else begin
            Inc(ARect.Right,FBulbCellWidth+ FImageSpacing);
            DrawBulb(ARect.Right - FBulbCellWidth, ARect.Top, FCheckState);
          end;
    end;
  end;
end;

procedure TCheckLabel.AdjustBounds;
var
  DC: HDC;
  X,H: Integer;
  Rect: TRect;
  AAlignment: TAlignment;
begin
  if AutoSize then begin
    Rect := ClientRect;
    InflateRect(Rect, -1, 0);
    DC := GetDC(0);
    Canvas.Handle := DC;
    DoDrawText(Rect, DT_EXPANDTABS or DT_CALCRECT or WordWraps[FWordWrap]);
    Canvas.Handle := 0;
    ReleaseDC(0, DC);
    InflateRect(Rect, 1, 0);
    X := Left;
    AAlignment := FAlignment;
    if AAlignment = taRightJustify then begin
       Inc(X, Width - Rect.Right);
      { if BulbImg <> nil then begin
         Dec(X,BulbCellWidth + FImageSpacing);
         H:=Max(BulbCellHeight,Rect.Bottom-Rect.Top);
         Rect.Bottom:=Rect.Top+H;
       end; }
    end else
    if BulbImg <> nil then begin
       Inc(Rect.Right,FBulbCellWidth + FImageSpacing);
       H:=Max(FBulbCellHeight,Rect.Bottom-Rect.Top);
       Rect.Bottom:=Rect.Top+H;
    end;
    SetBounds(X, Top, Rect.Right, Rect.Bottom);
  end;
end;

procedure TCheckLabel.SetBulbImg(Value:TBitmap);
begin
 if Value <> nil then begin
   FBulbImg.Assign(Value);
   FBulbCellCount:=FBulbImg.Width div FBulbImg.Height;
   if FBulbCellCount < 3 then FBulbCellCount:=3;
   FBulbCellWidth:= FBulbImg.Width div FBulbCellCount;
   FBulbCellHeight:=FBulbImg.Height;
   AdjustBounds;
 end;
end;

procedure TCheckLabel.LoadBulbImgFromRes(Instance: THandle; Name:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    TmpBitmap.LoadFromResourceName(Instance, Name);
    if not TmpBitmap.Empty then SetBulbImg(TmpBitmap);
  finally
    TmpBitmap.Free;
  end;
end;

procedure TCheckLabel.LoadBulbImgFromFile(FileName:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    if FileExists(FileName) then begin
     TmpBitmap.LoadFromFile(FileName);
     if not TmpBitmap.Empty then SetBulbImg(TmpBitmap);
    end;
  finally
    TmpBitmap.Free;
  end;
end;

procedure TCheckLabel.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then begin
    FAlignment := Value;
    Invalidate;
  end;
end;

procedure TCheckLabel.SetAutoSizeInt(Value: Boolean);
begin
  if AutoSize <> Value then begin
    FAutoSize := Value;
    AdjustBounds;
  end;
end;

procedure TCheckLabel.SetLayout(Value: TTextLayout);
begin
  if FLayout <> Value then begin
    FLayout := Value;
    Invalidate;
  end;
end;

function TCheckLabel.GetTransparent: Boolean;
begin
  Result := not (csOpaque in ControlStyle);
end;

procedure TCheckLabel.SetTransparent(Value: Boolean);
begin
  if Transparent <> Value then begin
    if Value then ControlStyle := ControlStyle - [csOpaque]
    else ControlStyle := ControlStyle + [csOpaque];
    Invalidate;
  end;
end;

procedure TCheckLabel.SetWordWrap(Value: Boolean);
begin
  if FWordWrap <> Value then begin
    FWordWrap := Value;
    AdjustBounds;
  end;
end;

procedure TCheckLabel.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
  AdjustBounds;
end;

procedure TCheckLabel.CMFontChanged(var Message: TMessage);
begin
  inherited;
  AdjustBounds;
end;


procedure TCheckLabel.SetImageSpacing(const Value: Integer);
begin
  if FImageSpacing <> Value then begin
    FImageSpacing := Value;
    AdjustBounds;
  end;
end;

procedure TCheckLabel.SetNormalColor(const Value: TColor);
begin
 if Value<>FNormalColor then begin
  FNormalColor:=Value;
  Invalidate;
 end
end;

procedure TCheckLabel.SetActiveColor(const Value: TColor);
begin
 if Value<>FActiveColor then begin
  FActiveColor:=Value;
  Invalidate;
 end
end;

procedure TCheckLabel.SetCheckState(const Value: TCheckState);
begin
 if Value<>FCheckState then begin
  FCheckState:=Value;
  if (FCheckState = csAfter) and (FBulbCellCount >3) then
  begin
   FFrame:=1;
   while  FFrame <> 0 do begin
   inc(FFrame);
   if FFrame +3  > FBulbCellCount then FFrame:=0;
   Delay(50);
   Paint;
   //invalidate; {Prevent flicker}
  end
  end else begin
    FFrame:=0;
  end;
  Invalidate;
 end
end;


{********* TProgressImage ***********************************************}

constructor TProgressImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle - [csOpaque] + [csFixedWidth, csFixedHeight];
  FPictFrames:=4;
  FPictImg:=TBitmap.Create;
  FPictImg.Width:=10*FPictFrames;
  FPictImg.Height:=10;
  FPictCount:=6;
  FActivePictUp:=1;
  FActivePictUpState:=0;
  FActivePictDown:=0;
  FActivePictDownState:=3;
  FPictSpacing:=11;
  Height:=FPictImg.Height;
  Width:= FPictImg.Width div FPictFrames * FPictCount + (FPictCount-1) * FPictSpacing;
  FTimer:=TTimer.Create(self);
  FTimer.Interval:=50;
  FTimer.OnTimer:= OnTimer;
end;

destructor TProgressImage.Destroy;
begin
  FTimer.Enabled:=false;
  FTimer.Free;
  FPictImg.Free;
  inherited Destroy;
end;

procedure TProgressImage.Paint;
var
 i:integer;
 PictNum:Cardinal;
begin
  with inherited Canvas do
	begin
	  for i:= 0 to FPictCount -1 do begin
       if i = FActivePictUp then
          PictNum:=FActivePictUpState else
       if i = FActivePictDown then
          PictNum:=FActivePictDownState else
          PictNum:=0;
          MyTransparentBlt(Canvas,
                          I*(FPictImg.Width div FPictFrames + FPictSpacing),0,FPictImg.Width div FPictFrames, FPictImg.Height,
                          FPictImg,
                          FPictImg.Width div FPictFrames * PictNum,0,FPictImg.Width div FPictFrames, FPictImg.Height);
    end;
 	end;
end;

procedure TProgressImage.OnTimer(Sender: TObject);
begin
 if FActivePictUpState < FPictFrames - 1 then inc(FActivePictUpState)
 else begin
   FActivePictUpState:=0;
   inc(FActivePictUp);
   if FActivePictUp > FPictCount-1 then FActivePictUp:=0;
   inc(FActivePictDown);
   if FActivePictDown > FPictCount-1 then FActivePictDown:=0;
 end;
 FActivePictDownState:= FPictFrames - 1 - FActivePictUpState;
 if Visible then Paint;
end;

procedure TProgressImage.SetActive(Value:boolean);
begin
  FTimer.Enabled:=Value;
end;

function  TProgressImage.GetActive:boolean;
begin
  result:=FTimer.Enabled;
end;

procedure TProgressImage.SetInterval(Value:Cardinal);
begin
   if Value <> FTimer.Interval then begin
    if Value < 50 then FTimer.Interval:=50
                  else FTimer.Interval:=Value;
   end;
end;

function  TProgressImage.GetInterval:Cardinal;
begin
   result:=FTimer.Interval;
end;

procedure TProgressImage.SetPictImg(Value:TBitmap);
begin
 if Value <> nil then begin
   FPictImg.Assign(Value);
   FPictFrames:= FPictImg.Width div FPictImg.Height;
   AdjustBounds;
 end;
end;

procedure TProgressImage.LoadPictImgFromRes(Instance: THandle; Name:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    TmpBitmap.LoadFromResourceName(Instance, Name);
    if not TmpBitmap.Empty then SetPictImg(TmpBitmap);
  finally
    TmpBitmap.Free;
  end;
end;

procedure TProgressImage.LoadPictImgFromFile(FileName:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    if FileExists(FileName) then begin
     TmpBitmap.LoadFromFile(FileName);
     if not TmpBitmap.Empty then SetPictImg(TmpBitmap);
    end;
  finally
    TmpBitmap.Free;
  end;
end;

procedure TProgressImage.SetPictCount(Value:Cardinal);
begin
 if Value <> FPictCount then begin
    if Value < 3 then FPictCount:=3
                 else FPictCount:=Value;
    AdjustBounds;
 end;
end;


procedure TProgressImage.SetPictSpacing(Value:Cardinal);
begin
 if Value <> FPictSpacing then begin
    if Value < 1 then FPictSpacing:=1
                 else FPictSpacing:=Value;
    AdjustBounds;
 end;
end;

procedure TProgressImage.AdjustBounds;
begin
 Height:=FPictImg.Height;
 Width:= FPictImg.Width div FPictFrames *FPictCount + (FPictCount-1)* FPictSpacing;
 //Paint;
 Invalidate;
end;



{********* TCoolButton **************************************************}

constructor TCoolButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FGlyph:= TBitmap.Create;
  FGlyphCellWidth:=22;
  FGlyphCellHeight:=22;
  FMode:= cmButton;
  FChecked:= true;
  SetBounds(0, 0, 22, 22);
  ControlStyle := [csCaptureMouse,csOpaque];
  ParentFont:=false;
  Font.Name:=CommonFont;
  FActiveColor:= clHotLight;
  FActiveUnderline:=true;
  FSpacing:=5;
  Cursor:=crHandPoint;
end;
    
destructor TCoolButton.Destroy;
begin
  inherited Destroy;
  FGlyph.free;
end;

procedure TCoolButton.Paint;
var
  ARect:TRect;
  ImgId:integer;
  DrawParam: DWord;
begin
  DrawParam:= DT_LEFT or DT_VCENTER or DT_SINGLELINE;
  if not Enabled then begin
                        FState := cbDisabled;
                        DrawParam:= DrawParam or DT_HIDEPREFIX;
                      end
                 else if FState = cbDisabled then FState := cbUp;
  case FState of
    cbUp: if FMouseInControl then ImgId:=1
                             else ImgId:=0;
    cbDown: ImgId:=2;
    cbDisabled: ImgId:=3;
  else
    ImgId:=0;
  end;
  if (FMode <> cmButton) and not FChecked then ImgId:=ImgId+4;
  MyTransparentBlt(Canvas,0,0,FGlyphCellWidth , FGlyphCellHeight,
                   FGlyph,ImgId * FGlyphCellWidth, 0, FGlyphCellWidth, FGlyphCellHeight);
  ARect:=ClientRect;
  ARect.Left:= ARect.Left + FGlyphCellWidth + FSpacing;
  Canvas.Brush.Style := bsClear;
  Canvas.Font := Font;
  if FMouseInControl and
     (FState <> cbDisabled) then begin
                        if FActiveUnderline then Canvas.Font.Style:=Canvas.Font.Style + [fsUnderline];
                        Canvas.Font.Color:=FActiveColor;
                     end else begin
                        if FActiveUnderline then Canvas.Font.Style:=Canvas.Font.Style - [fsUnderline];
                        Canvas.Font.Color:=Font.Color;
                     end;
  if FState = cbDown then OffsetRect( ARect,1,1);
  if FCaption <> '' then begin
    if not Enabled then
     begin
      OffsetRect(ARect, +1, +1);
      Canvas.Font.Color := Font.Color;
      DrawText(Canvas.Handle, PChar(FCaption), Length(FCaption), ARect, DrawParam);
      OffsetRect(ARect, -1, -1);
      Canvas.Font.Color := clBtnShadow;
      DrawText(Canvas.Handle, PChar(FCaption), Length(FCaption), ARect, DrawParam);
     end
    else DrawText(Canvas.Handle, PChar(FCaption), Length(FCaption), ARect, DrawParam);
  end;
end;

function TCoolButton.MouseInControl: Boolean;
var
  P: TPoint;
begin
 GetCursorPos(P);
 result:= Enabled and(FindDragTarget(P, True) = Self);
end;

procedure TCoolButton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if (Button = mbLeft) and Enabled then
  begin
    if not FDown then
    begin
      FState := cbDown;
      Invalidate;
    end;
    FDragging := True;
  end;
end;
    
procedure TCoolButton.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
  if not FMouseInControl and MouseInControl then Perform(CM_MOUSEENTER, 0, 0);
end;
    
procedure TCoolButton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  DoClick: Boolean;
begin
  inherited MouseUp(Button, Shift, X, Y);
  if FDragging then
  begin
    FDragging := False;
    DoClick := (X >= 0) and (X < ClientWidth) and (Y >= 0) and (Y <= ClientHeight);
    FState := cbUp;
    FMouseInControl:= MouseInControl;
    Invalidate;
    if DoClick then  begin
                      PlaySnd(FClickSnd, false);
                      Click;
                     end;
  end;
end;

procedure TCoolButton.Click;
begin
  inherited Click;
end;

procedure TCoolButton.SetGlyph(Value: TBitmap);
var
 ClCount:integer;
begin
  if Value <> nil then begin
   case  FMode of
    cmButton: ClCount:=4;
    cmCheckBox: ClCount:=8;
    cmRadioButton: ClCount:=8;
   else
      ClCount:=8;
   end;
   FGlyph.Assign(Value);
   FGlyphCellWidth:=FGlyph.Width div ClCount;
   FGlyphCellHeight:=FGlyph.Height;
   FGlyph.Transparent:=true;
   FGlyph.TransparentMode:= tmAuto;
   AdjustBounds;
  end else
  Invalidate;
end;

procedure TCoolButton.LoadGlyphFromRes(Instance: THandle; Name:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    TmpBitmap.LoadFromResourceName(Instance, Name);
    SetGlyph(TmpBitmap);
  finally
    TmpBitmap.Free;
  end;
end;

procedure TCoolButton.LoadGlyphFromFile(FileName:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    if FileExists(FileName) then begin
     TmpBitmap.LoadFromFile(FileName);
     if not TmpBitmap.Empty then SetGlyph(TmpBitmap);
    end;
  finally
    TmpBitmap.Free;
  end;
end;

procedure TCoolButton.SetCaption(Value: String);
begin
  if Value <> FCaption then begin
    FCaption:= Value;
    AdjustBounds;
  end;
end;


procedure TCoolButton.SetChecked(Value: boolean);
begin
  if Value <> FChecked then begin
    FChecked:= Value;
    Invalidate;
  end;
end;

procedure TCoolButton.SetMode(Value: TCoolButtonMode);
begin
  if Value <> FMode then begin
    FMode:= Value;
    Invalidate;
  end;
end;

procedure TCoolButton.AdjustBounds;
const
  WordWraps: array[Boolean] of Word = (0, DT_WORDBREAK);
var
  DC: HDC;
  Tw,Th: Integer;
  Rect: TRect;
begin
  Tw:=FGlyphCellWidth;
  Th:=FGlyphCellHeight;
  Rect:=ClientRect;
  if FCaption <>'' then begin
    DC := GetDC(0);
    Canvas.Handle := DC;
    Canvas.Font := Font;
    DrawText(Canvas.Handle, PChar(FCaption), Length(FCaption), Rect, DT_CALCRECT);
    Canvas.Handle := 0;
    ReleaseDC(0, DC);
    Tw:= FGlyphCellWidth + Rect.Right - Rect.Left + FSpacing;
    Th:=Max(FGlyphCellHeight,Rect.Bottom-Rect.Top);
  end;
  SetBounds(Left, Top, Tw, Th);
end;

procedure TCoolButton.CMTextChanged(var Message: TMessage);
begin
  AdjustBounds;
end;

procedure TCoolButton.CMFontChanged(var Message: TMessage);
begin
  inherited;
  AdjustBounds;
end;


procedure TCoolButton.CMEnabledChanged(var Message: TMessage);
begin
  FDragging := False;
  FMouseInControl := False;
  Invalidate;
end;

procedure TCoolButton.CMMouseEnter(var Message: TMessage);
var
  NeedRepaint: Boolean;
begin
  inherited;
  NeedRepaint := not FMouseInControl and Enabled  and (GetCapture = 0);
  if NeedRepaint  then
  begin
    FMouseInControl := True;
    if FTimer = nil then begin
      FTimer:=TTimer.Create(Self);
      FTimer.Interval:=50;
      FTimer.OnTimer:=OnMouseTimer;
      FTimer.Enabled:=true;
    end;
    PlaySnd(FActivateSnd,false);
    if Enabled then Invalidate;
  end;
end;

procedure TCoolButton.CMMouseLeave(var Message: TMessage);
var
  NeedRepaint: Boolean;
begin
  inherited;
  NeedRepaint :=  FMouseInControl and Enabled and not FDragging;
  if NeedRepaint then
  begin
    FMouseInControl := False;
    if FTimer <> nil then begin
     FTimer.Free;
     FTimer:=nil;
    end;
    if Enabled then Invalidate;
  end;
end;

procedure TCoolButton.CMDialogChar(var Message: TCMDialogChar);
begin
  if Enabled and Visible and IsAccel(Message.CharCode, Caption) then  begin
        FState := cbDown;
        FMouseInControl:= MouseInControl;
        Invalidate;
        PlaySnd(ClickSnd, false);
        Delay(150);
        FState := cbUp;
        Invalidate;
        Message.Result := 1;
        Click;
    end;
end;

procedure TCoolButton.OnMouseTimer(Sender: TObject);
begin
  if not MouseInControl then begin
   FTimer.Enabled:=false;
   Perform(CM_MOUSELEAVE, 0, 0);
  end
end;



{********* TShadowLabel *************************************************}

function DrawShadowText(DC: HDC; Str: PChar; Count: Integer; var Rect: TRect;
  Format: Word; ShadowSize: Byte; ShadowColor: TColorRef;
  ShadowPos: TShadowPosition): Integer;
var
  RText, RShadow: TRect;
  Color: TColorRef;
begin
  RText := Rect;
  RShadow := Rect;
  Color := SetTextColor(DC, ShadowColor);
  case ShadowPos of
    spLeftTop: OffsetRect(RShadow, -ShadowSize, -ShadowSize);
    spRightBottom: OffsetRect(RShadow, ShadowSize, ShadowSize);
    spLeftBottom: OffsetRect(RShadow, -ShadowSize, ShadowSize);
    spRightTop: OffsetRect(RShadow, ShadowSize, -ShadowSize);
  end;
  Result := DrawText(DC, Str, Count, RShadow, Format);
  if Result > 0 then Inc(Result, ShadowSize);
  SetTextColor(DC, Color);
  DrawText(DC, Str, Count, RText, Format);
  UnionRect(Rect, RText, RShadow);
end;

constructor TShadowLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csOpaque];
  ControlStyle := ControlStyle + [csReplicatable];
  Width := 65;
  Height := 17;
  FAutoSize := True;
  FShadowColor := clBtnHighlight;
  FShadowSize := 1;
  FShadowPos := spLeftTop;
end;

function TShadowLabel.GetLabelCaption: string;
begin
  Result := Caption;
end;

function TShadowLabel.GetDefaultFontColor: TColor;
begin
  Result := Font.Color;
end;

procedure TShadowLabel.DoDrawText(var Rect: TRect; Flags: Word);
var
  Text: string;
  PosShadow: TShadowPosition;
  SizeShadow: Byte;
  ColorShadow: TColor;
begin
  Text := GetLabelCaption;
  if (Flags and DT_CALCRECT <> 0) and (Text = '')  then Text := Text + ' ';
  Flags := Flags or DT_NOPREFIX;
  Canvas.Font := Font;
  Canvas.Font.Color := GetDefaultFontColor;
  PosShadow := FShadowPos;
  SizeShadow := FShadowSize;
  ColorShadow := FShadowColor;
  if not Enabled then begin
    if (FShadowSize = 0) and NewStyleControls then begin
      PosShadow := spRightBottom;
      SizeShadow := 1;
    end;
    Canvas.Font.Color := clGrayText;
    ColorShadow := clBtnHighlight;
  end;
  DrawShadowText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags,
    SizeShadow, ColorToRGB(ColorShadow), PosShadow);
end;

procedure TShadowLabel.Paint;
var
  Rect: TRect;
  DrawStyle: Integer;
begin
  with Canvas do begin
    if not Transparent then begin
      Brush.Color := Self.Color;
      Brush.Style := bsSolid;
      FillRect(ClientRect);
    end;
    Brush.Style := bsClear;
    Rect := ClientRect;
    InflateRect(Rect, -1, 0);
    DrawStyle := DT_EXPANDTABS or WordWraps[FWordWrap] or Alignments[FAlignment];
    { Calculate vertical layout }
    if FLayout <> tlTop then begin
      DoDrawText(Rect, DrawStyle or DT_CALCRECT);
      Rect.Left := ClientRect.Left;
      Rect.Right := ClientRect.Right;
      if FLayout = tlBottom then OffsetRect(Rect, 0, Height - Rect.Bottom)
      else OffsetRect(Rect, 0, (Height - Rect.Bottom) div 2);
    end;
    DoDrawText(Rect, DrawStyle);
  end;
end;

procedure TShadowLabel.AdjustBounds;
var
  DC: HDC;
  X: Integer;
  Rect: TRect;
  AAlignment: TAlignment;
begin
  if AutoSize then begin
    Rect := ClientRect;
    InflateRect(Rect, -1, 0);
    DC := GetDC(0);
    Canvas.Handle := DC;
    DoDrawText(Rect, DT_EXPANDTABS or DT_CALCRECT or WordWraps[FWordWrap]);
    Canvas.Handle := 0;
    ReleaseDC(0, DC);
    InflateRect(Rect, 1, 0);
    X := Left;
    AAlignment := FAlignment;
    if AAlignment = taRightJustify then Inc(X, Width - Rect.Right);
    SetBounds(X, Top, Rect.Right, Rect.Bottom);
  end;
end;

procedure TShadowLabel.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then begin
    FAlignment := Value;
    Invalidate;
  end;
end;

procedure TShadowLabel.SetAutoSizeInt(Value: Boolean);
begin
  if AutoSize <> Value then begin
    FAutoSize := Value;
    AdjustBounds;
  end;
end;

procedure TShadowLabel.SetLayout(Value: TTextLayout);
begin
  if FLayout <> Value then begin
    FLayout := Value;
    Invalidate;
  end;
end;

procedure TShadowLabel.SetShadowColor(Value: TColor);
begin
  if Value <> FShadowColor then begin
    FShadowColor := Value;
    Invalidate;
  end;
end;

procedure TShadowLabel.SetShadowSize(Value: Byte);
begin
  if Value <> FShadowSize then begin
    FShadowSize := Value;
    AdjustBounds;
    Invalidate;
  end;
end;

procedure TShadowLabel.SetShadowPos(Value: TShadowPosition);
begin
  if Value <> FShadowPos then begin
    FShadowPos := Value;
    Invalidate;
  end;
end;

function TShadowLabel.GetTransparent: Boolean;
begin
  Result := not (csOpaque in ControlStyle);
end;

procedure TShadowLabel.SetTransparent(Value: Boolean);
begin
  if Transparent <> Value then begin
    if Value then ControlStyle := ControlStyle - [csOpaque]
    else ControlStyle := ControlStyle + [csOpaque];
    Invalidate;
  end;
end;

procedure TShadowLabel.SetWordWrap(Value: Boolean);
begin
  if FWordWrap <> Value then begin
    FWordWrap := Value;
    AdjustBounds;
  end;
end;

procedure TShadowLabel.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
  AdjustBounds;
end;

procedure TShadowLabel.CMFontChanged(var Message: TMessage);
begin
  inherited;
  AdjustBounds;
end;



{ ******** TMyProgress **************************************************}

type
  TBltBitmap = class(TBitmap)
    procedure MakeLike(ATemplate: TBitmap);
  end;

{ TBltBitmap }

procedure TBltBitmap.MakeLike(ATemplate: TBitmap);
begin
  Width := ATemplate.Width;
  Height := ATemplate.Height;
  Canvas.Brush.Color := clWindowFrame;
  Canvas.Brush.Style := bsSolid;
  Canvas.FillRect(Rect(0, 0, Width, Height));
end;

{ This function solves for x in the equation "x is y% of z". }
function SolveForX(Y, Z: Longint): Longint;
begin
  Result := Longint(Trunc( Z * (Y * 0.01) ));
end;

{ This function solves for y in the equation "x is y% of z". }
function SolveForY(X, Z: Longint): Longint;
begin
  if Z = 0 then Result := 0
  else Result := Longint(Trunc( (X * 100.0) / Z ));
end;


constructor TMyProgress.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csFramed, csOpaque];
  FMinValue := 0;
  FMaxValue := 100;
  FCurValue := 0;
  FKind := pkHorizontalBar;
  FShowText := True;
  FBorderStyle := bsSingle;
  FForeColor := clBlack;
  FBackColor := clWhite;
  Width := 100;
  Height := 100;
end;

function TMyProgress.GetPercentDone: Longint;
begin
  Result := SolveForY(FCurValue - FMinValue, FMaxValue - FMinValue);
end;

procedure TMyProgress.Paint;
var
  TheImage: TBitmap;
  OverlayImage: TBltBitmap;
  PaintRect: TRect;
begin
    TheImage := TBitmap.Create;
    try
      TheImage.Height := Height;
      TheImage.Width := Width;
      PaintBackground(TheImage);
      PaintRect := ClientRect;
      if FBorderStyle = bsSingle then InflateRect(PaintRect, -1, -1);
      OverlayImage := TBltBitmap.Create;
      try
        OverlayImage.MakeLike(TheImage);
        PaintBackground(OverlayImage);
        case FKind of
          pkHorizontalBar, pkVerticalBar: PaintAsBar(OverlayImage, PaintRect);
        end;
        TheImage.Canvas.CopyMode := cmSrcInvert;
        TheImage.Canvas.Draw(0, 0, OverlayImage);
        TheImage.Canvas.CopyMode := cmSrcCopy;
        if ShowText then PaintAsText(TheImage, PaintRect);
      finally
        OverlayImage.free;
      end;
      Canvas.CopyMode := cmSrcCopy;
      Canvas.Draw(0, 0, TheImage);
    finally
      TheImage.free;
    end;
end;

procedure TMyProgress.PaintBackground(AnImage: TBitmap);
var
  ARect: TRect;
begin
  with AnImage.Canvas do
  begin
    CopyMode := cmBlackness;
    //ARect := Rect(1, 1, Width-1, Height-1);
    ARect := Rect(0, 0, Width, Height);
    CopyRect(ARect, Animage.Canvas, ARect);
    CopyMode := cmSrcCopy;
  end;
end;

procedure TMyProgress.PaintAsText(AnImage: TBitmap; PaintRect: TRect);
var
  S: string;
  X, Y: Integer;
  OverRect: TBltBitmap;
begin
  OverRect := TBltBitmap.Create;
  try
    OverRect.MakeLike(AnImage);
    PaintBackground(OverRect);
    S := Format('%d%%', [PercentDone]);
    with OverRect.Canvas do
    begin
      Brush.Style := bsClear;
      Font := Self.Font;
      Font.Color := clWhite;
      with PaintRect do
      begin
        X := (Right - Left + 1 - TextWidth(S)) div 2;
        Y := (Bottom - Top + 1 - TextHeight(S)) div 2;
      end;
      TextRect(PaintRect, X, Y, S);
    end;
    AnImage.Canvas.CopyMode := cmSrcInvert;
    AnImage.Canvas.Draw(0, 0, OverRect);
  finally
    OverRect.Destroy;
  end;
end;


procedure TMyProgress.PaintAsBar(AnImage: TBitmap; PaintRect: TRect);
var
  FillSize: Longint;
  W, H: Integer;
begin
  W := PaintRect.Right - PaintRect.Left+1;
  H := PaintRect.Bottom - PaintRect.Top+1;
  with AnImage.Canvas do
  begin
    Brush.Color := BackColor;
    FillRect(PaintRect);
    Pen.Color := ForeColor;
    Pen.Width := 1;
    Brush.Color := ForeColor;
    case FKind of
      pkHorizontalBar:
        begin
          FillSize := SolveForX(PercentDone, W-2);
          if FillSize > W-2 then FillSize := W-2;
          if FillSize > 0 then FillRect(Rect(PaintRect.Left+2, PaintRect.Top+1,
            FillSize, H-1));
        end;
      pkVerticalBar:
        begin
          FillSize := SolveForX(PercentDone, H - 2);
          if FillSize >= H-1 then FillSize := H - 3;
          FillRect(Rect(PaintRect.Left+1, H - FillSize+1, W-1, H-1));
        end;
    end;
  end;
end;


procedure TMyProgress.SetGaugeKind(Value: TProgressKind);
begin
  if Value <> FKind then
  begin
    FKind := Value;
    Invalidate;
  end;
end;

procedure TMyProgress.SetShowText(Value: Boolean);
begin
  if Value <> FShowText then
  begin
    FShowText := Value;
    Invalidate;
  end;
end;

procedure TMyProgress.SetBorderStyle(Value: TBorderStyle);
begin
  if Value <> FBorderStyle then
  begin
    FBorderStyle := Value;
    Invalidate;
  end;
end;

procedure TMyProgress.SetForeColor(Value: TColor);
begin
  if Value <> FForeColor then
  begin
    FForeColor := Value;
    Invalidate;
  end;
end;

procedure TMyProgress.SetBackColor(Value: TColor);
begin
  if Value <> FBackColor then
  begin
    FBackColor := Value;
    Invalidate;
  end;
end;

procedure TMyProgress.SetMinValue(Value: Longint);
begin
  if Value <> FMinValue then
  begin
    if Value > FMaxValue then FMinValue:=0 else
    FMinValue := Value;
    if FCurValue < Value then FCurValue := Value;
    Invalidate;
  end;
end;

procedure TMyProgress.SetMaxValue(Value: Longint);
begin
  if Value <> FMaxValue then
  begin
    if Value > FMinValue then FMaxValue := Value;
    if FCurValue > FMaxValue then FCurValue := FMaxValue;
    Invalidate;
  end;
end;

procedure TMyProgress.SetProgress(Value: Longint);
var
  TempPercent: Longint;
begin
  TempPercent := GetPercentDone;
  if Value < FMinValue then
    Value := FMinValue
  else if Value > FMaxValue then
    Value := FMaxValue;
  if FCurValue <> Value then
  begin
    FCurValue := Value;
    if TempPercent <> GetPercentDone then 
      Invalidate;
  end;
end;

procedure TMyProgress.AddProgress(Value: Longint);
begin
  Progress := FCurValue + Value;
  Invalidate;
end;


{********* TCoolImage ***************************************************}

constructor TCoolImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  FPicture := TPicture.Create;
  FPicture.OnChange := PictureChanged;
  FStretch:=stRealSize;
  FClickable:=false;
  Height := 105;
  Width := 105;
end;

destructor TCoolImage.Destroy;
begin
  FPicture.Free;
  inherited Destroy;
end;

function TCoolImage.GetPalette: HPALETTE;
begin
  Result := 0;
  if FPicture.Graphic <> nil then
	Result := FPicture.Graphic.Palette;
end;

procedure TCoolImage.LoadImgFromRes(Instance: THandle; Name:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    TmpBitmap.LoadFromResourceName(Instance, Name);
    if not TmpBitmap.Empty then Picture.Assign(TmpBitmap);
  finally
    TmpBitmap.Free;
  end;
end;

procedure TCoolImage.LoadImgFromFile(FileName:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    if FileExists(FileName) then begin
     TmpBitmap.LoadFromFile(FileName);
     if not TmpBitmap.Empty then Picture.Assign(TmpBitmap);
    end;
  finally
    TmpBitmap.Free;
  end;
end;

function TCoolImage.DestRect: TRect;
var
  w, h, cw, ch: Integer;
  xyaspect: Double;

  procedure CalkSize;
  begin
  if Proportional and ((w > 0) and (h > 0)) then
	 begin
      xyaspect := w / h;
      if w > h then
      begin
        w := cw;
        h := Trunc(cw / xyaspect);
        if h > ch then  
        begin
          h := ch;
          w := Trunc(ch * xyaspect);
        end;
      end
      else
      begin
        h := ch;
        w := Trunc(ch * xyaspect);
        if w > cw then
        begin
          w := cw;
          h := Trunc(cw / xyaspect);
        end;
      end;
    end
    else
    begin
      w := cw;
      h := ch;
    end;
   end;
begin
  w := Picture.Width;
  h := Picture.Height;
  cw := ClientWidth;
  ch := ClientHeight;

  case FStretch of
    stReduce: if (w > cw) or (h > ch) then CalkSize;
    stEnlarge: if(w < cw) and (h < ch) then CalkSize;
    stAlwas: CalkSize;
    stRealSize:;
  end;

  with Result do
  begin
    Left := 0;
    Top := 0;
    Right := w;
    Bottom := h;
  end;

  if Center then
	OffsetRect(Result, (cw - w) div 2, (ch - h) div 2);
end;

procedure TCoolImage.Paint;
var
  Save: Boolean;
begin
  if csDesigning in ComponentState then
	with inherited Canvas do
	begin
	  Pen.Style := psDash;
	  Brush.Style := bsClear;
	  Rectangle(0, 0, Width, Height);
	end;
  Save := FDrawing;
  FDrawing := True;
  try
	with inherited Canvas do
	  StretchDraw(DestRect, Picture.Graphic);
  finally
	FDrawing := Save;
  end;
end;

function TCoolImage.DoPaletteChange: Boolean;
var
  ParentForm: TCustomForm;
  Tmp: TGraphic;
begin
  Result := False;
  Tmp := Picture.Graphic;
  if Visible and (not (csLoading in ComponentState)) and (Tmp <> nil) and
	(Tmp.PaletteModified) then
  begin
	if (Tmp.Palette = 0) then
	  Tmp.PaletteModified := False
	else
	begin
	  ParentForm := GetParentForm(Self);
	  if Assigned(ParentForm) and ParentForm.Active and Parentform.HandleAllocated then
	  begin
		if FDrawing then
		  ParentForm.Perform(wm_QueryNewPalette, 0, 0)
		else
		  PostMessage(ParentForm.Handle, wm_QueryNewPalette, 0, 0);
		Result := True;
		Tmp.PaletteModified := False;
	  end;
	end;
  end;
end;

procedure TCoolImage.SetCenter(Value: Boolean);
begin
  if FCenter <> Value then
  begin
	FCenter := Value;
	PictureChanged(Self);
  end;
end;

procedure TCoolImage.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;


procedure TCoolImage.SetTransparent(Value: Boolean);
begin
  if Value <> FTransparent then
  begin
	FTransparent := Value;
	PictureChanged(Self);
  end;
end;

procedure TCoolImage.SetProportional(Value: Boolean);
begin
  if FProportional <> Value then
  begin
	FProportional := Value;
	PictureChanged(Self);
  end;
end;

procedure TCoolImage.SetClickable(Value: Boolean);
begin
  if Value <> FClickable then
  begin
	FClickable := Value;
  if FClickable then  Cursor:=crHandPoint
                else  Cursor:=Parent.Cursor;
  end;
end;

procedure TCoolImage.PictureChanged(Sender: TObject);
var
  G: TGraphic;
  D : TRect;
begin
  if AutoSize and (Picture.Width > 0) and (Picture.Height > 0) then
	SetBounds(Left, Top, Picture.Width, Picture.Height);
  G := Picture.Graphic;
  if G <> nil then
  begin
	if not ((G is TMetaFile) or (G is TIcon)) then
	  G.Transparent := FTransparent;
        D := DestRect;
	if (not G.Transparent) and (D.Left <= 0) and (D.Top <= 0) and
	   (D.Right >= Width) and (D.Bottom >= Height) then
	  ControlStyle := ControlStyle + [csOpaque]
	else
	  ControlStyle := ControlStyle - [csOpaque];
	if DoPaletteChange and FDrawing then Update;
  end
  else ControlStyle := ControlStyle - [csOpaque];
  if not FDrawing then Invalidate;
end;

function TCoolImage.CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := True;
  if not (csDesigning in ComponentState) or (Picture.Width > 0) and
    (Picture.Height > 0) then
  begin
    if Align in [alNone, alLeft, alRight] then
      NewWidth := Picture.Width;
    if Align in [alNone, alTop, alBottom] then
      NewHeight := Picture.Height;
  end;
end;

procedure TCoolImage.SetStretch(Value: TStretchType);
begin
  if FStretch <> Value then
  begin
	FStretch := Value;
	PictureChanged(Self);
  end;
end;

procedure TCoolImage.Click;
begin
  if FClickable then PlaySnd(FClickSnd, false);
  inherited Click;
end;

{********* TUrlLabel ****************************************************}

constructor TUrlLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FActiveColor:=clHighlight;
  FInActiveColor:=clWindowText;
  FActiveUnderline:=false;
  FActiveBold:=false;
  Cursor:= crHandPoint;
end;


function TUrlLabel.MouseInControl: Boolean;
var
  P: TPoint;
begin
 GetCursorPos(P);
 result:= Enabled and(FindDragTarget(P, True) = Self);
end;

procedure TUrlLabel.CMEnabledChanged(var Message: TMessage);
begin
  FDragging := False;
  FMouseInControl := False;
  Font.Color:=FInActiveColor;
  Invalidate;
end;

procedure TUrlLabel.CMMouseEnter(var Message: TMessage);
var
  NeedRepaint: Boolean;
begin
  inherited;
  NeedRepaint := not FMouseInControl and Enabled  and (GetCapture = 0);
  if NeedRepaint  then
  begin
    FMouseInControl := True;
    if FTimer = nil then begin
      FTimer:=TTimer.Create(Self);
      FTimer.Interval:=50;
      FTimer.OnTimer:=OnMouseTimer;
      FTimer.Enabled:=true;
    end;
    PlaySnd(ActivateSnd,false);
    if Enabled then begin
                      FInActiveColor:=Font.Color;
                      Font.Color:=FActiveColor;
                      if FActiveBold then Font.Style:= Font.Style + [fsBold];
                      if FActiveUnderline then Font.Style:= Font.Style + [fsUnderline];
                      Invalidate;
    end;
  end;
end;

procedure TUrlLabel.CMMouseLeave(var Message: TMessage);
var
  NeedRepaint: Boolean;
begin
  inherited;
  NeedRepaint :=  FMouseInControl and Enabled and not FDragging;
  if NeedRepaint then
  begin
    FMouseInControl := False;
    if FTimer <> nil then begin
     FTimer.Free;
     FTimer:=nil;
    end;
    if Enabled then begin
     Font.Color:= FInActiveColor;
     if FActiveBold then Font.Style:= Font.Style - [fsBold];
     if FActiveUnderline then Font.Style:= Font.Style - [fsUnderline];
     Invalidate;
    end;
  end;
end;

procedure TUrlLabel.OnMouseTimer(Sender: TObject);
begin
  if not MouseInControl then begin
   FTimer.Enabled:=false;
   Perform(CM_MOUSELEAVE, 0, 0);
  end
end;


procedure TUrlLabel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
  if not FMouseInControl and MouseInControl then Perform(CM_MOUSEENTER, 0, 0);
end;



{********* TSmartMemo ***************************************************}

const
  EM_AUTOURLDETECT                    = WM_USER + 91; 
  EM_GETAUTOURLDETECT                 = WM_USER + 92;

constructor TSmartMemo.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    ScrollBars := ssBoth;
    BevelInner := bvSpace;
    BevelOuter := bvNone;
    //BorderWidth:=2;
    WantReturns:=True;
    WordWrap:=True;
    ReadOnly := True;
    HideSelection := true;
    HideScrollBars :=true;
    aFontColor:= Font.Color;
    aFontName:= Font.Name;
    Font.Pitch:=fpFixed;
    PlainText:= false;
end;

procedure TSmartMemo.UpdateText(IsRtf:boolean);
begin
   PlainText:= not IsRtf;
   DefAttributes.Name:= aFontName;
   DefAttributes.Color:= aFontColor;
   DefAttributes.Size:= aFontSize;
   DefAttributes.Style:=[];
   DefAttributes.Pitch:=fpFixed;
   Font.Name:= aFontName;
   Font.Color:= aFontColor;
   Font.Size:= aFontSize;
   Font.Pitch:=fpFixed;
   SelStart:=0;
   SelLength:=1;
   SelStart:=0;
   SelLength:=0;
end;

procedure TSmartMemo.LoadText(FileName:string);
begin
  Clear;
  DefAttributes.Name:=aFontName;
  DefAttributes.Color:= aFontColor;
  DefAttributes.Size:= aFontSize;
  DefAttributes.Style:=[];
  DefAttributes.Pitch:=fpFixed;
  PlainText:= UpperCase(ExtractFileExt(FileName)) <> '.RTF';
  SendMessage(Handle, EM_AUTOURLDETECT, Longint(true), 0);
  Lines.LoadFromFile(FileName);
  SelStart:=0;
  SelLength:=1;
  SelStart:=0;
  SelLength:=0;
end;

procedure TSmartMemo.SetFontColor(value:TColor);
begin
 aFontColor:=value;
 Font.Color:=value;
 Font.Pitch:=fpFixed;
 DefAttributes.Color:= value;
 DefAttributes.Pitch:=fpFixed;
end;

procedure TSmartMemo.SetFontName(value:string);
begin
 aFontName:= value;
 Font.Name:= value;
 Font.Pitch:=fpFixed;
 DefAttributes.Name:=value;
 DefAttributes.Pitch:=fpFixed;
end;

procedure TSmartMemo.SetFontSize(value:integer);
begin
  aFontSize:= value;
  Font.Size:= value;
  Font.Pitch:=fpFixed;
  DefAttributes.Size:=value;
  DefAttributes.Pitch:=fpFixed;
end;

{procedure TSmartMemo.SetScrollMode;
var
  ACanvas:TControlCanvas;
  AScrolBars:TScrollStyle;
  TextRect:Trect;
begin
  AScrolBars:=ssNone;
  ACanvas:=TControlCanvas.Create;
  try
    ACanvas.Control:=Self;
    ACanvas.Font:=Self.Font;
    TextRect:=Self.ClientRect;
    if Self.Text <> '' then begin
     DrawText(ACanvas.Handle, PChar(Self.Text), Length(Self.Text), TextRect, DT_CALCRECT);
     if (TextRect.Right - TextRect.Left) +10 > Self.ClientWidth then AScrolBars:=ssHorizontal;
     if (TextRect.Bottom - TextRect.Top) +10 > Self.ClientHeight then AScrolBars:=ssVertical;
     if ((TextRect.Right - TextRect.Left) +10 > Self.ClientWidth) and
        ((TextRect.Bottom - TextRect.Top)  +10 > Self.ClientHeight) then AScrolBars:=ssBoth;
   end
  finally
    ACanvas.Free;
  end;
  Self.ScrollBars:=AScrolBars;
end;  }

 {-------------------------- TBackDrop ------------------------------------}

constructor TBackDrop.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FDir := bdUp;
   Align := alClient;
   FClrIn := clBlue;
   FClrOut := clBlack;
   FGradCount:=$FF;
   FActive:=true;
   FPicture := TBitmap.Create;
   ControlStyle := ControlStyle + [csOpaque]- [csSetCaption,csCaptureMouse];
end;

Destructor TBackDrop.Destroy;
begin;
   UnHookWndProc;
   FPicture.Free;
   Inherited Destroy;
end;

procedure TBackDrop.HookWndProc;
begin
  if Parent = nil then   exit;
  fOldWndProc := pointer(GetWindowLong(Parent.Handle,GWL_WNDPROC));
  SetWindowLong(Parent.Handle, GWL_WNDPROC, Longint(MakeObjectInstance(NewWndProc)));
end;

procedure TBackDrop.UnHookWndProc;
begin
  if (Parent = nil) or (FOldWndProc=nil) then   exit;
  SetWindowLong(Parent.Handle, GWL_WNDPROC, Longint(fOldWndProc));
  FOldWndProc:=nil;
end;

procedure TBackDrop.SetParent(AParent : TWinControl);
Var
  i:Integer;
begin
  UnHookWndProc;
  inherited SetParent(AParent);
  If AParent<>nil then
    With AParent do
    begin
      For i:=0 to ControlCount-1 do
        If (Controls[i] is TBackDrop) and (Controls[i]<>Self) then exit;
    end;
  HookWndProc;
  SendToBack;
end;

procedure TBackDrop.NewWndProc(var Message : TMessage);
begin
  with Message do
    begin
      if (Msg = WM_ERASEBKGND) and Visible and FActive then
        begin
          Result := 1;
          exit;
        end;
      Result := CallWindowProc(fOldWndProc, Parent.Handle, Msg, WParam, LParam);
    end;
end;

function  TBackDrop.LocalCheckImage;
begin
  result:=(FPicture<>nil) and not FPicture.Empty;
end;


procedure TBackDrop.SetDir(Value: TDirection);
begin
   if Value = FDir then exit;
   FDir:= Value;
   Invalidate;
end;

procedure TBackDrop.SetColorIn(Value: TColor);
begin
   FClrIn := Value;
   Invalidate;
end;

procedure TBackDrop.SetColorOut(Value: TColor);
begin
   FClrOut := Value;
   Invalidate;
end;

procedure TBackDrop.SetGradientCount(Value : byte);
begin
   if Value = FGradCount then exit;
   FGradCount:= Value;
   Invalidate;
end;

procedure TBackDrop.SetActive(Value : boolean);
begin
   if Value = FActive then exit;
   FActive:= Value;
   if FActive then Invalidate else Parent.Invalidate;
end;

procedure TBackDrop.SetPicture(Value : TBitmap);
begin
   FPicture.Assign(Value);
   if (FDir = bdTiledImage) or (FDir = bdStretchImage) then Invalidate
   else if LocalCheckImage then SetDir(bdTiledImage);
end;

procedure TBackDrop.LoadPictureFromRes(Instance: THandle; Name:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    TmpBitmap.LoadFromResourceName(Instance, Name);
    if not TmpBitmap.Empty then SetPicture(TmpBitmap);
  finally
    TmpBitmap.Free;
  end;
end;

procedure TBackDrop.LoadPictureFromFile(FileName:string);
var
  TmpBitmap:TBitmap;
begin
  TmpBitmap:=TBitmap.Create;
  try
    if FileExists(FileName) then begin
     TmpBitmap.LoadFromFile(FileName);
     if not TmpBitmap.Empty then SetPicture(TmpBitmap);
    end;
  finally
    TmpBitmap.Free;
  end;
end;

procedure TBackDrop.ImageChange(Sender:TObject);
begin
    invalidate;
end;

procedure TBackDrop.FillOneWay(WType: TOneWayType; ClrIn, ClrOut: TColor);
begin
   if WType = Up then HorzOneWay(Canvas,ClientRect,ClrIn,ClrOut,FGradCount);
   if WType = Down then HorzOneWay(Canvas,ClientRect,ClrOut,ClrIn,FGradCount);
   if WType = DLeft then VertOneWay(Canvas,ClientRect,ClrIn,ClrOut,FGradCount);
   if WType = DRight then VertOneWay(Canvas,ClientRect,ClrOut,ClrIn,FGradCount);
end;

procedure TBackDrop.FillTwoWay(WType: TTwoWayType; WDir: TTwoWayDir; ClrIn, ClrOut: TColor);
begin
   if WDir = Horz then
   begin
       if WType = DIn then HorzTwoWay(Canvas,ClientRect,ClrOut,ClrIn,FGradCount);
       if WType = DOut then HorzTwoWay(Canvas,ClientRect,ClrIn,ClrOut,FGradCount);
   end
   else
   begin
       if WType = DIn then VertTwoWay(Canvas,ClientRect,ClrOut,ClrIn,FGradCount);
       if WType = DOut then VertTwoWay(Canvas,ClientRect,ClrIn,ClrOut,FGradCount);
   end;
end;



procedure TBackDrop.StretchDrawImage;
begin
 if LocalCheckImage then begin
    Canvas.StretchDraw(ClientRect,FPicture);
    end
 else begin
       Canvas.Brush.Style:=bsDiagCross;
       Canvas.Brush.Color:=Color;
       Canvas.FillRect(ClientRect);
      end;
end;

procedure TBackDrop.TiledDrawImage;
var
 X, Y: Integer;
 ClRect:TRect;
begin
  ClRect:=ClientRect;
  if LocalCheckImage then begin
      y := 0;
      while y < (ClRect.Bottom -  ClRect.Top) do begin
        x := 0;
        while x < (ClRect.Right -  ClRect.Left) do begin
           Canvas.Draw(X, Y,FPicture);
           x := x + FPicture.Width;
        end;
        y := y + FPicture.Height;
      end
   end else begin
               Canvas.Brush.Color:=Color;
               Canvas.FillRect(ClRect);
            end;
end;


procedure TBackDrop.Paint;
begin
  if not FActive then exit;
  case fDir of
     bdUp:           FillOneWay(Up, FClrIn, FClrOut);
     bdDown:         FillOneWay(Down, FClrIn, FClrOut);
     bdLeft:         FillOneWay(DLeft, FClrIn, FClrOut);
     bdRight:        FillOneWay(DRight, FClrIn, FClrOut);
     bdHorzOut:      FillTwoWay(DOut, Horz, FClrIn, FClrOut);
     bdHorzIn:       FillTwoWay(DIn, Horz, FClrIn, FClrOut);
     bdVertIn:       FillTwoWay(DIn, Vert, FClrIn, FClrOut);
     bdVertOut:      FillTwoWay(DOut, Vert, FClrIn, FClrOut);
     bdTiledImage:   TiledDrawImage;
     bdStretchImage: StretchDrawImage;
  end;
end;

end.

