{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }

unit CommonProc;

interface


uses
  Windows, Messages, SysUtils, Classes, ComCtrls, CommCtrl, Forms, IniFiles, Controls;


type

    PInstallGroup = ^TInstallGroup;
    TInstallGroup = record
      Selected:byte;
      INode: TTreeNode;
      Group:string;
      Description:string;
      Expandet: boolean;
      Blocked:boolean;
      St3Checked:boolean;
      ItemList:TList;
      Fixed:boolean;
    end;

    PInstallItem = ^TInstallItem;
    TInstallItem = record
      Parent: PInstallGroup;
      INode: TTreeNode;
      Number:integer;
      Group:string;
      Caption:string;
      Description:string;
      DependsList:TList;
      ExcludeList:TList;
      DefaultInExcludeList:boolean;
      Folder:string;
      SourceFolder:string;
      PreCopyCommand:string;
      PostCopyCommand:string;
      PreRegFile:string;
      Command1:string;
      Command2:string;
      Command3:string;
      Command4:string;
      Command5:string;
      Command6:string;
      PostRegFile:string;
      KillWait:Integer;
      Killed:boolean;
      IconFileName:string;
      IconNumber:integer;
      SkreenShotImage:string;
      ImageId:cardinal;
      ImageIdBig:cardinal;
      Error:DWORD;
      SelectDefault:boolean;
      Fixed:boolean;
      WrongPatch:boolean;
      Visible:boolean;
      RebootNeed:boolean;
      Selected:boolean;
      Installed:boolean;
    end;

    PUserFuncItem = ^TUserFuncItem;
    TUserFuncItem = record
      Caption:string;
      Hint:string;
      Picture:string;
      Folder:string;
      Command:string;
      Text:string;
      Visible:boolean;
    end;

    procedure CreateInstallList;
    procedure InitInstallList;
    procedure AddCommonInfo;
    procedure ClearInstallList;
    procedure FreeInstallList;
    function  GetGroupCount:integer;
    function  GetGroupFromName (GroupName: string):PInstallGroup;
    function  GetGroupFromId (GroupId: integer):PInstallGroup;
    function  NewInstallGroup (Group:string; Desciription: string):PInstallGroup;
    function  GetNewInstallGroupName:string;
    procedure DeleteInstallGroup(AGroup:PInstallGroup);
    function  ValidateSetIni(filename:string):boolean;
    function  GroupsLoadFromIni(filename:string):boolean;
    function  GroupsSaveToIni(filename:string; OnlySelected:boolean):boolean;
    function  CheckGroupSelected(AGroup: PInstallGroup):byte;
    function  SetGroupSelected(AGroup: PInstallGroup; Checked:boolean):byte;
    procedure RecheckAllgroup;
    procedure SetDefault;
    procedure SetState(Checked:boolean);
    function  ValidateItem(AInstallItem: PInstallItem):boolean;
    function  ValidateGroup(AInstallGroup: PInstallGroup):boolean;
    function  GetExcludeString(AInstallItem: PInstallItem):string;
    function  GetDependsString(AInstallItem: PInstallItem):string;
    procedure CheckExclude(AInstallItem: PInstallItem);
    procedure CheckDepends(AInstallItem: PInstallItem);
    procedure ValidateExcludeAll;
    procedure FillTreeView(ATreeView: TTreeView; OnlyFullGroup:boolean; OnlyVisible:boolean);
    procedure MakeSelectLog(ALogList:TStrings);
    function  GetAllItemCount:integer;
    function  GetAllSelectCount:integer;
    function  GetInGrpSelectCount(AInstallGroup: PInstallGroup):integer;
    function  GetUsedGroupCount:integer;
    function  GetSelGroupCount:integer;
    function  GetInstalledGroupCount:integer;
    function  ItemFromNumber(AItemNumber:integer):PInstallItem;
    function  ItemNameFromNumber(AItemNumber:integer):string;
    function  GetShotFile(Item: PInstallItem):string;
    function  GetNewInstallItemName(AGroup:PInstallGroup):string;
    function  GetNewInstallItemNumber:integer;
    procedure ReNumerateItems;
    function  NewInstallItem(AGroup: PInstallGroup): PInstallItem;
    function  InstallItemAdd(AGroup:PInstallGroup;  AInstallItem: PInstallItem):integer;
    procedure InstallItemDelete(AInstallItem: PInstallItem);
    function  InstallItemReadFromIni(const Ini: TIniFile; SectionName: string):PInstallItem;
    function  InstallItemWriteToIni (const Ini: TIniFile; InstallItem: PInstallItem):boolean;
    function  InstallItemInstall(Item: PInstallItem): boolean;

    procedure KillItem;

    procedure PreInstall;
    procedure PostInstall;
    function  StartItem(ParentForm:TForm;  Root, Folder, Caption, Cmd, Text :string):DWORD;

    function  ValidateConfig(filename:string):boolean;
    function  SaveConfig(filename:string):boolean;
    function  LoadConfig(filename:string):boolean;
    function  GetInstallLog:string;
    function  GetLastMainIni:string;
    function  CheckInstallLog:boolean;
    procedure DeleteInstallLog;
    function  LoadInstallLog:boolean;
    procedure ReloadLog;
    function  GetLogFileName:string;
    function  LogSelectedItems: boolean;


    procedure AddDebugMsg(Msg:string);
    procedure Delay(MSecs: Longint);
    function  CheckCmdParam(Param:string):boolean;
    function  GetCmdParam(Param:string):string;
    function  GetConfigFile: string;

    function IsUNCPath(filename:string):boolean;
    function IsAbcPath(filename:string):boolean;
    function ExpandEnvString(EnvString: string): string;
    function NormaliseAllSlash(filename:string):string;
    function NormaliseFirstSlash(filename:string):string;
    procedure GetSelfFolder;
    procedure GetSourceDrive;
    procedure GetRootFolder;
    function ClearDir(const Path: string; Delete: Boolean): Boolean;
    function CopyDir(Source, Destination:string; ParentWnd: hwnd; Silent:boolean):boolean;
    function CopySet(SourceDir, DestDir:string; OnlySelected:boolean; ParentWnd: hwnd; Silent:boolean):boolean;

    procedure HideRunOnce;
    procedure ShowRunOnce;
    procedure CleanRun;
    procedure AddRunOnce;
    
    procedure ShutdownSystem;
    procedure RebootSystem;

    function SafeFormat(const AFormat: string; const Args: array of const): string;
    function DelToLf(Text:string):string;
    function Min(A,B:integer):Integer;
    function Max(A,B:integer):Integer;
    function WidthOf(R: TRect): Integer;
    function HeightOf(R: TRect): Integer;
    function GetMainIni:string;
    function GetSkinIni:string;
    function GetSkinFolder:string;
    function GetAboutInfo:string;
    function CheckLicense:boolean;
    function CheckReadMe:boolean;
    function IsPeMode:boolean;
    function IsExplorerRuning:boolean;
    function GetApplicationVersion(filename:string): string;
    function BoolToString(Value:boolean):string;
    function IsAdminLoggedOn: Boolean;
    procedure OptimiseIni(IniFile: string);

 var
   SetAutor:string = '';
   SetDescription:string ='';
   SetDate:string = '';
   RootInstallDir:string = '';
   RootFolder:string = '';
   CommonIconLib:string = '';
   CommonIconLibFile:string = '';
   CommonShotFolder:string = '';
   CommonShotFolderExp:string = '';
   PreInstallFolder: string = '';
   PreCommand: array [0..3] of string = ('','','','');
   BeforePreRegFile: string ='';
   BeforePostRegFile: string ='';
   PostInstallFolder: string = '';
   PostCommand: array [0..3] of string = ('','','','');
   AfterPreRegFile: string ='';
   AfterPostRegFile: string ='';
   UserButton: array [1..3] of TUserFuncItem;
   RebootFlag: boolean;
   PowerOffFlag: boolean;
   ShowLog: boolean = false;
   AutoClose: boolean = true;
   EnableUserInput: boolean = true;
   EnableCloseMsg: boolean = true;
   EnableWelcomeDlg: boolean = true;
   CheckFDD: boolean = false;
   CheckFlash: boolean = true;
   CheckHdd: boolean = false;
   CheckCD: boolean = true;
   CheckNet: boolean = false;
   LogFile: string = '%SystemDrive%\InstallLog.txt';
   LogInstall: boolean = true;
   DetaliseLog: boolean = true;
   SourceTagFile: string = '';
   CheckProgFolder: boolean = false;
   SupressReboot: boolean = false;
   AdminRightsRequired: boolean = false;
   RebootSheduled: boolean = false;
   TestMode:boolean = false;
   PeMode:boolean = false;
   MainH: integer = 600;
   MainW: integer = 800;
   WStr, HStr, LStr, TStr: string;
   StartTimerTime: integer = 0;
   ReadMeTxt: string = '';
   LicenseTxt: string = '';
   SmallIconList:TImageList = nil;
   BigIconList:TImageList = nil;
   RunOnceSubKey:string = '999';
   RunValyeName:string = 'TEMP_BS_POSTINSTALLER';
   UseRunKey:boolean = false;
   SetCRC:cardinal;
   InProgress: boolean = false;
   MainIni: string = 'PRESETUP.INI';

   IsEditorMode: boolean = false;
   ProjectRootDir: string = '';


 var
   GroupList:TList;


implementation

uses
  Registry, ShellApi, StrUtils, GlobalConst, Graphics, ChkSumm, LogEngine, Vimer;

var
   ConfigList:TStringList;
   InstallList:TStringList;
   UserEnvironmentVariable:TStringList;
   PrId: integer = 0;
   IsBreak: boolean =false;
   RunOnceHandle: LongInt = 0;
   ItemFolder:string = '';
   SourceDiskLetter:string = '';
   SelfFolder:string = '';
   IconShift: integer = 0;

const
   InstallLog ='$instal$.log';
   RunOnce = '\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnceEx';
   Run = '\SOFTWARE\Microsoft\Windows\CurrentVersion\Run';

function SafeFormat(const AFormat: string; const Args: array of const): string;
begin
  try
   result:=Format(AFormat, Args);
  except
   result:='[Invalid fmt string]';
  end;
end;

function CheckLicense:boolean;
begin
  result:= FileExists(ExtractFilePath(Application.ExeName)+ 'license.txt') or
           FileExists(ExtractFilePath(Application.ExeName)+ 'license.rtf');
end;

function CheckReadMe:boolean;
begin
  result:= FileExists(ExtractFilePath(Application.ExeName)+ 'readme.txt') or
           FileExists(ExtractFilePath(Application.ExeName)+ 'readme.mht') or
           FileExists(ExtractFilePath(Application.ExeName)+ 'readme.htm') or
           FileExists(ExtractFilePath(Application.ExeName)+ 'readme.html') or
           FileExists(ExtractFilePath(Application.ExeName)+ 'readme.rtf') ;
end;

function Min(A,B:integer):Integer;
begin
  if A > B then result:= B else  result:= A;
end;

function Max(A,B:integer):Integer;
begin
  if A < B then result:= B else  result:= A;
end;

function WidthOf(R: TRect): Integer;
begin
  Result := R.Right - R.Left;
end;

function HeightOf(R: TRect): Integer;
begin
  Result := R.Bottom - R.Top;
end;

procedure OptimiseIni(IniFile: string);
var
 i:integer;

begin
 with TStringList.Create do
 try
   LoadFromFile(IniFile);
   for I := 0 to Count - 1 do begin
     if (Strings[i] <> '') and (pos('[',Strings[I]) > 0 )then Strings[I]:=#13#10+Strings[I];
   end;
   SaveToFile(IniFile);
 finally
   free;
 end;
end;

function GetApplicationVersion(filename:string): string;
var
  Pt,Pt2: Pointer;
  Size,Size2: DWord;
  Ver: array[0..3] of Integer; {0-version, 1-minor version, 2-release, 3-build}
const
  t = '.';
begin
  Size := GetFileVersionInfoSize(PChar(filename),Size2);
  If Size > 0 then
    begin
      GetMem(Pt, Size);
      try
        GetFileVersionInfo(PChar(filename), 0,Size, PT);
         VerQueryValue(Pt,'\', Pt2, Size2);
        with TVSFixedFileInfo(Pt2^) do
          begin
            Ver[0] := HiWord(dwFileVersionMS);
            Ver[1] := LoWord(dwFileVersionMS);
            Ver[2] := HiWord(dwFileVersionLS);
            Ver[3] := LoWord(dwFileVersionLS);
          end;
      finally
        FreeMem(Pt);
        Result := IntToStr(Ver[0]) + t + IntToStr(Ver[1]) + t + IntToStr(Ver[2]) +  t + IntToStr(Ver[3]);
      end;
    end
    else result:='no version';
end;

function BoolToString(Value:boolean):string;
begin
  if Value then Result:='Yes'
           else Result:='No';
end;

function StripFirstWord( var Line:string): string;
begin
  result:='';
  if (Line <> '') and (pos(';',Line)=0) then begin
    result:=Trim(line);
    Line:='';
    exit;
  end else if (Line <> '') and (pos(';',Line)> 0) then begin
    result:=Copy(Line, 1, pos(';',Line)-1);
    delete(Line, 1, pos(';',Line));
  end;
end;

function GetAboutInfo:string;
begin
  result:=AboutMsg;
  result:= result + 'Current Skinset:' + #13#10#9 + 'Autor: ' + SkinAutor +  #13#10#9 + 'Description: ' + SkinDescription +  #13#10#9 + 'Date: ' + SkinDate+  #13#10#13#10;
  result:= result + 'Current Config:' + #13#10#9 + 'Autor: ' + SetAutor +  #13#10#9 + 'Description: ' + SetDescription +  #13#10#9 + 'Date: ' + SetDate+  #13#10#13#10;
  result:= result + AboutMoreMsg;
end;

procedure AddLine(List:TStringList;SectName:string;Value:string);
var
  LinePos:integer;
begin
  List.CaseSensitive:=false;
  LinePos:=List.IndexOf('['+SectName+']');
  if LinePos > 0 then begin
     List.Insert(LinePos+1,Value);
  end else begin
    List.Add('');
    List.Add('['+SectName+']');
    List.Add(Value);
  end;
end;


function CheckSection(SectName:string;IniList:TStrings):boolean;
var i:integer;
begin
  result:=false;
  for I:=0 to IniList.Count-1 do begin
   if Uppercase(Trim(IniList[I])) = ('[' +Uppercase(SectName)+ ']') then  begin
     result:=true;
     break;
   end
  end;
end;


function GetSectionContent(SectName:string;IniList:TStrings;ContList:TStrings):boolean;
var i:integer;
    startsec:boolean;
begin
  startsec:=false;
  ContList.Clear;
  for I:=0 to IniList.Count-1 do begin
   if pos('[', IniList[I]) > 0 then begin
     if Uppercase(Trim(IniList[I])) = ('[' +Uppercase(SectName)+ ']') then
      startsec:=true else startsec:=false;
   end else if startsec then begin
     if  (Trim(IniList[I]) <> '') and
         (Trim(IniList[I])[1]<>';') then ContList.Add(Trim(IniList[I]));
   end;
  end;
  result:= ContList.Count > 0;
end;

function ClearSection(SectName:string;IniList:TStrings):boolean;
var i:integer;
    startsec:boolean;
begin
  startsec:=false;
  I:=0;
  while I < IniList.Count-1 do begin
   inc(I);
   if pos('[', IniList[I]) > 0 then begin
     if Uppercase(Trim(IniList[I])) = ('[' +Uppercase(SectName)+ ']') then
      startsec:=true else startsec:=false;
   end else if startsec then 
     if  (Trim(IniList[I]) <> '') and
         (Trim(IniList[I])[1]<>';') then begin
                                           IniList.Delete(i);
                                           dec(i);
                                         end;
  end;
  result:= true;
end;

function GetMainIni:string;
var
  IniName: string;
begin
  IniName:=GetCmdParam('ini:');
  if IniName = '' then IniName:='PRESETUP.INI';
  IniName:=ExpandEnvString(IniName);
  if not(IsABCPath(IniName) or IsUNCPath(IniName)) then IniName:= ExtractFilePath(Application.ExeName)+ IniName;
  IniName:= NormaliseFirstSlash(IniName);
  if FileExists(IniName) then result:= IniName
                         else result:= '';
end;

function GetLogFileName:string;
var
  IniName:string;
  Ini:TIniFile;
  LogFile:string;
begin
  result:= GetCmdParam('logfile:');
  if result = '' then begin
   IniName:= MainIni;
   if (IniName <> '') and FileExists(IniName) then begin
     Ini:=TIniFile.Create(IniName);
     try
      LogFile:=Ini.ReadString('Setup','LogFile','%SystemDrive%\InstallLog.txt');
      if Ini.ReadBool('Setup','LogInstall',true) then result:= LogFile;
     finally
      Ini.Free;
     end;
   end;
  end;
  result:= ExpandEnvString(result);
end;

function GetSkinIni:string;
begin
  result:=ExtractFilePath(Application.ExeName)+ DefaultSkinFolder + '\' + DefaultSkinIniName;
end;

function GetSkinFolder:string;
begin
  result:=ExtractFilePath(Application.ExeName)+ DefaultSkinFolder + '\';
end;

function CalcCRC(FileName:string):cardinal;
 var
  Buffer : array[1..2048] of Char;
  Count  : Cardinal;
  F: File;
begin
 result:= CRC32INIT;
 {$I-}
 AssignFile(F, FileName);
 try
   FileMode := 0;
   Reset(F,1);
   if IOResult = 0 then begin
    repeat
      BlockRead(F, Buffer, SizeOf(Buffer), Count);
      result := CalculateBufferCRC32( result, Buffer, Count );
    until Eof(F);
   end;
   result := result xor CRC32INIT;
 finally
   CloseFile(F);
 end;
 {$I+}
end;

procedure GetSelfFolder;
begin
if not IsEditorMode then begin
  SelfFolder:=ExtractFileDir(Application.ExeName);
  SetEnvironmentVariable(PChar('SELF'),PChar(SelfFolder));
end else begin
  SelfFolder:=ProjectRootDir;
  SetEnvironmentVariable(PChar('SELF'),PChar(SelfFolder));
end;
end;

procedure GetSourceDrive;
var
  OldErrorMode: DWORD;
  DriveNum: Byte;
  StartNum: Byte;
  DriveChar: Char;
  DriveBits: set of 0..25;
  DriveType: DWORD;
  CdPath:string;
begin
if not IsEditorMode then begin
 if  SourceTagFile = '' then exit;
 OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
 try
  Integer(DriveBits) := GetLogicalDrives;
  SourceDiskLetter:='';
  if CheckFDD then StartNum:=0 else StartNum:=2;
  for DriveNum := StartNum to 25 do
  begin
   if not (DriveNum in DriveBits) then Continue;
   DriveChar:= Char(DriveNum + Ord('a'));
   DriveType:= GetDriveType(PChar(DriveChar + ':\'));
   if (DriveType > 1) and (
       (CheckFDD and (DriveType = DRIVE_REMOVABLE)) or
       (CheckFlash and (DriveType = DRIVE_REMOVABLE)) or
       (CheckCD and (DriveType = DRIVE_CDROM)) or
       (CheckHdd and (DriveType = DRIVE_FIXED)) or
       (CheckHdd and (DriveType = DRIVE_RAMDISK)) or
       (CheckNet and (DriveType = DRIVE_REMOTE))) then begin
         DriveChar := Upcase(DriveChar);
         CdPath:= DriveChar + ':\'+ SourceTagFile;
         if FileExists(CdPath) then begin
           SourceDiskLetter:=DriveChar + ':';
           SetEnvironmentVariable(PChar('CDROM'),PChar(SourceDiskLetter));
           SetEnvironmentVariable(PChar('SOURCE'),PChar(SourceDiskLetter));
           break;
         end;
   end;
  end;
 finally
  SetErrorMode(OldErrorMode);
 end;
end else begin
   SourceDiskLetter:= ExtractFileDrive(ProjectRootDir);
   SetEnvironmentVariable(PChar('CDROM'),PChar(SourceDiskLetter));
   SetEnvironmentVariable(PChar('SOURCE'),PChar(SourceDiskLetter));
end;
end;

procedure GetRootFolder;
begin
 if not IsEditorMode then begin
   RootFolder:=NormaliseFirstSlash(ExpandEnvString(RootInstallDir));
   SetEnvironmentVariable(PChar('ROOT'),PChar(RootFolder));
 end else begin
   RootFolder:=ProjectRootDir;
   SetEnvironmentVariable(PChar('ROOT'),PChar(RootFolder));
 end;
end;

function GetConfigFile: string;
var
  OldErrorMode: Integer;
  DriveNum: Integer;
  DriveChar: Char;
  DriveBits: set of 0..25;
  CdPath:string;
  SetName:string;
begin
 result:='';
 SetName:= ExtractFileName(MainIni);
 if SetName <> '' then SetName:=ChangeFileExt(SetName,'.SET')
                  else SetName:= 'PRESETUP.SET';
 if CheckFDD then begin
   OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
   try
    Integer(DriveBits) := GetLogicalDrives;
    SourceDiskLetter:='';
    for DriveNum := 0 to 25 do
    begin
      if not (DriveNum in DriveBits) then Continue;
      DriveChar := Char(DriveNum + Ord('a'));
      if GetDriveType(PChar(DriveChar + ':\'))= DRIVE_REMOVABLE		then begin
         DriveChar := Upcase(DriveChar);
         CdPath:= DriveChar + ':\'+ SetName;
         if FileExists(CdPath) and ValidateConfig(CdPath) then begin
           result:=CdPath;
           break;
         end;
      end;
    end;
   finally
    SetErrorMode(OldErrorMode);
   end;
 end;
 if result = '' then result:=ExtractFilePath(Application.ExeName)+ SetName;
end;

function GetTempDir:string;
var
 Tmp : PChar;
begin
 GetMem(Tmp,MAX_PATH);
 try
  ZeroMemory(Tmp,MAX_PATH);
  GetTempPath(MAX_PATH,Tmp);
  Result :=  StrPas (Tmp);
 finally
  FreeMem(Tmp,MAX_PATH);
 end;
end;


function IsNtOs:boolean;
var
 ver: TOSVERSIONINFO;
begin
 ver.dwOSVersionInfoSize := Sizeof(ver);
 GetVersionEx(ver);
 result:= ver.dwPlatformId=VER_PLATFORM_WIN32_NT;
end;


type
  SC_HANDLE = THandle;
function OpenSCManager(lpMachineName, lpDatabaseName: PChar;
  dwDesiredAccess: DWORD): SC_HANDLE; stdcall;
  external 'advapi32.dll' name 'OpenSCManagerA';
function CloseServiceHandle(hSCObject: SC_HANDLE): BOOL; stdcall;
  external 'advapi32.dll' name 'CloseServiceHandle';

function IsAdminLoggedOn: Boolean;
{ Returns True if an administrator is logged onto the system. Always returns
  True on Windows 95/98. }
var
  hSC: SC_HANDLE;
begin
  if not IsNtOs then  Result := True
  else begin
    { Try an admin privileged API }
   hSC := OpenSCManager(nil, nil, GENERIC_READ or GENERIC_WRITE or GENERIC_EXECUTE);
   Result := hSC <> 0;
   if Result then CloseServiceHandle (hSC);
  end;
end;

function AdjustShutdownPrivileges:boolean;
var
 handle, ph: THandle;
 pid, n: DWORD;
 luid: TLargeInteger;
 priv: TTokenPrivileges;
 dummy: PTokenPrivileges;
 Err: DWORD;
begin
 if IsNtOs then begin
    result:=false;
    pid := GetCurrentProcessId;
    ph := OpenProcess(PROCESS_ALL_ACCESS, false, pid);
    if not OpenProcessToken(ph, TOKEN_ADJUST_PRIVILEGES, handle) then exit;
    if not  LookupPrivilegeValue(nil, 'SeShutdownPrivilege', luid) then exit;
    priv.PrivilegeCount := 1;
    priv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
    priv.Privileges[0].Luid := luid;
    dummy := nil;
    AdjustTokenPrivileges(handle, false, priv, 0, dummy^, n);
    Err := GetLastError;
    if Err <> ERROR_SUCCESS then exit;
 end;
 result:=true;
end;

procedure ShutdownSystem;
begin
 if AdjustShutdownPrivileges then
 ExitWindowsEx(EWX_SHUTDOWN or EWX_POWEROFF, 0);
end;

procedure RebootSystem;
begin
 if AdjustShutdownPrivileges then
 ExitWindowsEx(EWX_REBOOT, 0);
end;


function CheckCmdParam(Param:string):boolean;
var
  i: Integer;
begin
  result:=false;
  for i := 1 to ParamCount do
  begin
    if LowerCase(ParamStr(i)) = LowerCase(Param) then begin
     result:=true;
     break;
    end
  end;
end;

function GetCmdParam(Param:string):string;
var
  i: Integer;
  p: Integer;
begin
  result:='';
  for i := 1 to ParamCount do
  begin
    P:= pos(LowerCase(Param),LowerCase(ParamStr(i)));
    if P>0 then begin
     result:=Copy(ParamStr(i),Length(Param)+P, Length(ParamStr(i))-P -Length(Param)+1);
     break;
    end
  end;
end;

function IsPeMode:boolean;
begin
 result:=false;
 with TRegistry.Create(KEY_READ) do
 try
  RootKey:=HKEY_LOCAL_MACHINE;
  if OpenKeyReadOnly('\SYSTEM\Setup') then
   result:= ValueExists('SystemSetupInProgress') and
            (ReadInteger('SystemSetupInProgress') <> 0 );
 finally
  CloseKey;
  free;
 end
end;

function IsExplorerRuning:boolean;
 var
  hTaskBar: HWND;
begin
 hTaskBar:= FindWindow('Shell_TrayWnd','');
 result:= (hTaskBar<> INVALID_HANDLE_VALUE) and IsWindow(hTaskBar);
end;


procedure Delay(MSecs: Longint);
var
  FirstTickCount, Now: Longint;
begin
  FirstTickCount := GetTickCount;
  repeat
    Application.ProcessMessages;
    Sleep(10);
    Now := GetTickCount;
  until (Now - FirstTickCount >= MSecs) or (Now < FirstTickCount) or IsBreak;
end;


type
   ThIconArray = array[0..0] of hIcon;
   PhIconArray = ^ThIconArray;


function LocExtractIconExA(lpszFile: PAnsiChar;
                        nIconIndex: Integer;
                        phiconLarge : PhIconArray;
                        phiconSmall: PhIconArray;
                        nIcons: UINT): UINT; stdcall; external 'shell32.dll' name 'ExtractIconExA';

function LocExtractIconExW(lpszFile: PWideChar;
                        nIconIndex: Integer;
                        phiconLarge: PhIconArray;
                        phiconSmall: PhIconArray;
                        nIcons: UINT): UINT; stdcall; external 'shell32.dll' name 'ExtractIconExW';

function LocExtractIconEx(lpszFile: PAnsiChar;
                       nIconIndex: Integer;
                       phiconLarge : PhIconArray;
                       phiconSmall: PhIconArray;
                       nIcons: UINT): UINT; stdcall; external 'shell32.dll' name 'ExtractIconExA'; 


function GetIconEx(FileName: string; Id: word; IsSmall: boolean): HICON;
var
 Count:integer;
begin
  Result := 0;
  if FileExists(FileName) then
   begin
     Count:=LocExtractIconEx(PChar(FileName), -1, nil, nil, 1);
      if Id > Count-1 then Id:=0;
      if IsSmall then  LocExtractIconEx(PChar(FileName), Id, nil, @result, 1)
                 else  LocExtractIconEx(PChar(FileName), Id, @result, nil, 1);
   end;
end;

function InitIconLib(FileName: string; SmallImg, BigImg:TImageList):integer;
var
   IconCount : integer;
   pTheLargeIcons : phIconArray;
   pTheSmallIcons : phIconArray;
   TmpImg:TBitmap;
   i : integer;
begin
  Result := 0;
  if FileExists(FileName) and ((SmallImg <> nil ) or (BigImg <> nil)) then begin
   IconCount:=LocExtractIconEx(PChar(FileName), -1, nil, nil, 1);
   if IconCount > 0 then begin
     GetMem(pTheLargeIcons, IconCount * sizeof(hIcon));
     GetMem(pTheSmallIcons, IconCount * sizeof(hIcon));
     FillChar(pTheLargeIcons^, IconCount * sizeof(hIcon), #0);
     FillChar(pTheSmallIcons^, IconCount * sizeof(hIcon), #0);
     LocExtractIconEx(PChar(FileName),0,pTheLargeIcons,pTheSmallIcons,IconCount);
     {$IFOPT R+} 
       {$DEFINE CKRANGE}
         {$R-}
       {$ENDIF}
     for i := 0 to (IconCount - 1) do begin
       if BigImg <> nil then ImageList_AddIcon(BigImg.Handle, pTheLargeIcons^[i]);
       DestroyIcon(pTheLargeIcons^[i]); // Need for prevent GDI Leak
       if SmallImg <> nil then begin
        TmpImg:=TBitmap.Create;
        try
         TmpImg.Height:=SmallImg.Height;
         TmpImg.Width:= SmallImg.Width;
         TmpImg.PixelFormat:=pf32bit;
         TmpImg.Canvas.Brush.Color:= IconBackColor;
         TmpImg.Canvas.FillRect(Rect(0,0,TmpImg.Width,TmpImg.Height));
         DrawIconEx(TmpImg.Canvas.Handle,(TmpImg.Width - 16)div 2,(TmpImg.Height - 16)div 2,pTheSmallIcons^[i], 16, 16, 0, 0, DI_NORMAL);
         SmallImg.AddMasked(TmpImg,IconBackColor);
        finally
         TmpImg.Free;
        end;
       //ImageList_AddIcon(SmallImg.Handle, pTheSmallIcons^[i]);
       end;
       DestroyIcon(pTheSmallIcons^[i]);  // Need for prevent GDI Leak
     end;
     {$IFDEF CKRANGE}
      {$UNDEF CKRANGE}
         {$R+}
     {$ENDIF}
     FreeMem(pTheLargeIcons, IconCount * sizeof(hIcon));
     FreeMem(pTheSmallIcons, IconCount * sizeof(hIcon));
     result:=IconCount;
   end;
  end;
end;

function GetShotFile(Item: PInstallItem):string;
begin
 result:='';
 if Item^.SkreenShotImage  <> '' then begin
     if not IsAbcPath(Item^.SkreenShotImage) then begin
        if CommonShotFolderExp <> '' then begin
           result:=NormaliseAllSlash(CommonShotFolderExp) + NormaliseFirstSlash(Item^.SkreenShotImage);
        end else begin
           if IsAbcPath(Item^.Folder) then result:=NormaliseAllSlash(ExpandEnvString((Item^.Folder)))
                                 else if (Item^.Folder <> '') then  result:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(Item^.Folder))
                                 else result:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
           result:=result + NormaliseFirstSlash(ExpandEnvString(Item^.SkreenShotImage));
        end;
     end else result:= NormaliseFirstSlash(ExpandEnvString(Item^.SkreenShotImage));
   end else result:='';
end;

function IsAbcPath(filename:string):boolean;
var
  path:string;
begin
  path:=ExpandEnvString(filename);
  result:= (Length(path) > 1) and ((path[2] = ':') or (path[1] = '|')) ;
  result:= result or IsUNCPath(path);
end;

function IsUNCPath(filename:string):boolean;
var
  path:string;
begin
  path:=ExpandEnvString(filename);
  result:= (Length(path) > 1) and (path[1] = '\') and (path[2] = '\');
end;

function NormaliseAllSlash(filename:string):string;
begin
   result:=NormaliseFirstSlash(filename);
   if result = '' then exit;
   if result[Length(result)] <> '\' then result:=result+'\';
end;

function NormaliseFirstSlash(filename:string):string;
begin
   result:=filename;
   if result = '' then exit;
   if IsAbcPath(filename) then begin
    if result[1] = '|' then delete(result,1,1);
   end else begin
    if result[1] = '\' then delete(result,1,1);
   end;
end;

function ExpandEnvString(EnvString: string): string;
var
  Sz: integer;
begin
  Result := '';
  Sz := ExpandEnvironmentStrings(PChar(EnvString), nil, 0);
  SetLength(Result, Sz);
  Sz := ExpandEnvironmentStrings(PChar(EnvString), PChar(Result), Sz);
  SetLength(Result, Sz - 1);
end;

const
  ExicutableExtensions: Array [0..31 ] of string =
               ('EXE', 'COM', 'BAT', 'CMD', 'MSI', 'REG', 'VB',
                'VBS', 'INF', 'ADE', 'ADP', 'BAS', 'CHM', 'CPL',
                'CRT', 'HLP', 'HTA', 'INS', 'ISP', 'LNK', 'MDB',
                'MDE', 'MSC', 'MSP', 'MST', 'OCX', 'PCD', 'PIF',
                'SCR', 'SHS', 'URL', 'WSC');


function ParseCommandLine(Const Cmd:string; var CmdLine, CmdParam:string):boolean;
var
 ExePos:integer;

 function GetExePos(ACmdLine:string):integer;
 var
  P:integer;
  TmpPos:integer;
  Del:string;
 begin
   result:=Length(ACmdLine);
   if ACmdLine = '' then exit;
   for p:=Low(ExicutableExtensions) to High(ExicutableExtensions) do
   begin
     Del:='.'+ExicutableExtensions[p];
     TmpPos:= Pos(Del,Uppercase(ACmdLine));
     if (TmpPos> 0) then result:= Min(result,TmpPos+Length(Del));
   end;
 end;


begin
  CmdLine:='';
  CmdParam:='';
  ExePos:= GetExePos(Cmd);
  if ExePos = Length(Cmd) then  CmdLine:= Cmd else
   begin
     CmdLine:= Copy(Cmd,0,ExePos-1);
     CmdParam:= Copy(Cmd,ExePos,Length(Cmd) - ExePos+1);
   end;
   result:=true;
end;

function  StartItem(ParentForm:TForm;  Root, Folder, Caption, Cmd, Text :string):DWORD;
var
 CmdLine:string;
 CmdParam:string;
 ProgrammFolder:string;
 AbcCmdPach:boolean;
begin
  result:=0;
  if Text <> '' then begin
     AbcCmdPach:= IsAbcPath(Text);
     if not AbcCmdPach  then
       begin
          if IsAbcPath(Folder) then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(Folder))
                                    else if (Folder <> '') then  ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(Folder))
                                         else ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
       end;
     if not AbcCmdPach then  Text:= ProgrammFolder + Text;
     VievFile(ParentForm,Text,Caption);
  end
  else 
  if Cmd <> '' then begin
     AbcCmdPach:= IsAbcPath(Cmd);
     if not AbcCmdPach  then
       begin
          if IsAbcPath(Folder)  then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString((Folder)))
                                     else if (Folder <> '') then  ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(Folder))
                                          else ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
       end;
     ItemFolder:= ProgrammFolder;
     SetEnvironmentVariable(PChar('FOLDER'),PChar(ProgrammFolder));
     ParseCommandLine(NormaliseFirstSlash(ExpandEnvString(cmd)), CmdLine, CmdParam);
     if AbcCmdPach then ProgrammFolder:=ExtractFileDir(CmdLine) else CmdLine:= ProgrammFolder +CmdLine;
     if AbcCmdPach then SetEnvironmentVariable(PChar('FOLDER'),PChar(ProgrammFolder));
     result:= ShellExecute(ParentForm.Handle,'open',PChar(CmdLine),PChar(CmdParam),PChar(ProgrammFolder),SW_SHOW);
  end;
end;

function RunItem(Root, Folder, Cmd:string; KillWait:integer):DWORD;
var
 ShExInfo: TShellExecuteInfo;
 ExitCode: DWORD;
 FirstTickCount, Now: Longint;
 CmdLine:string;
 CmdParam:string;
 ProgrammFolder:string;
 AbcCmdPach:boolean;
 ErrorCode: Integer;
 Buf: array [Byte] of Char;
begin
  result:=0;
  IsBreak:=false;
  if Cmd <> '' then begin
     AbcCmdPach:= IsAbcPath(Cmd);
     if not AbcCmdPach  then
       begin
          if IsAbcPath(Folder) then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString((Folder)))
                                    else if (Folder <> '') then  ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(Folder))
                                        else ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
       end;
     ItemFolder:= ProgrammFolder;
     SetEnvironmentVariable(PChar('FOLDER'),PChar(ProgrammFolder));
     ParseCommandLine(NormaliseFirstSlash(ExpandEnvString(cmd)), CmdLine, CmdParam);
     if AbcCmdPach then ProgrammFolder:=ExtractFileDir(CmdLine) else CmdLine:= ProgrammFolder +CmdLine;
     if AbcCmdPach then SetEnvironmentVariable(PChar('FOLDER'),PChar(ProgrammFolder));
  end else exit;

  WriteLog('Command: '+Cmd);
  if DetaliseLog then begin
   WriteLog('  Work Dir: '+ProgrammFolder);
   WriteLog('  Cmd Line: '+CmdLine);
   WriteLog('  Cmd Param: '+CmdParam);
  end;
  WriteLog('');
  if TestMode then begin
   if not FileExists(CmdLine) then begin
      ErrorCode := 2;  //ERROR_FILE_NOT_FOUND
      if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil,
                        ErrorCode, LOCALE_USER_DEFAULT,
                        Buf, sizeof(Buf), nil) <> 0) then
          WriteLog('  Error: '+ String(Buf));
   end;
   Delay(DemoWaitTime);
  end else begin
  FillChar(ShExInfo,SizeOf(TShellExecuteInfo),0);
  ShExInfo.cbSize:= SizeOf(TShellExecuteInfo);
  ShExInfo.fMask:=SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_NO_UI;
  ShExInfo.Wnd:=Application.Handle;
  ShExInfo.lpVerb:='open';
  ShExInfo.lpFile:=PChar(CmdLine);
  ShExInfo.lpParameters:=PChar(CmdParam);
  ShExInfo.lpDirectory:=PChar(ProgrammFolder);
  ShExInfo.nShow:=SW_SHOW;
  ShExInfo.hInstApp:=Application.Handle;
  if not ShellExecuteEx(@ShExInfo) then begin
    ErrorCode := GetLastError;
   if (ErrorCode <> 0) and (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil,
    ErrorCode, LOCALE_USER_DEFAULT, Buf, sizeof(Buf), nil) <> 0) then
   WriteLog('  Error: '+ String(Buf));
  end else begin;
  PrId:= ShExInfo.hProcess;
  FirstTickCount := GetTickCount;
   repeat
      Application.ProcessMessages;
      Sleep(10);
      GetExitCodeProcess(PrId, ExitCode);
      Now := GetTickCount;
      if (KillWait>0) and
         ((Now - FirstTickCount >= KillWait*1000) or
          (Now < FirstTickCount) or
          Application.Terminated) then
      begin
        IsBreak:=true;
        TerminateProcess(PrId,0);
        WriteLog('  Wait time is out. Process killed!!!');
        WriteLog('');
      end
   until (ExitCode <> STILL_ACTIVE) or Application.Terminated or IsBreak;
	 GetExitCodeProcess(PrId, result);
   end;
   CloseHandle(ShExInfo.hProcess);
 end;
end;

function RegAdd(Root, Folder, RegFileName: string):DWORD;
var
 ShExInfo: TShellExecuteInfo;
 ExitCode: DWORD;
 CmdLine:string;
 CmdParam:string;
 RegFile:string;
 ProgrammFolder:string;
 AbcCmdPach:boolean;
 ErrorCode: Integer;
 Buf: array [Byte] of Char;
begin
  result:=0;
  IsBreak:=false;
  if RegFileName <> '' then begin
     AbcCmdPach:= IsAbcPath(RegFileName);
     if not AbcCmdPach  then
       begin
          if IsAbcPath(Folder) then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString((Folder)))
                                    else if (Folder <> '') then  ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(Folder))
                                         else ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
       end;
     ItemFolder:= ProgrammFolder;
     CmdParam:=NormaliseFirstSlash(ExpandEnvString(RegFileName));
     if not AbcCmdPach then CmdParam:= ProgrammFolder + CmdParam;
     RegFile:=CmdParam;
     CmdParam:=' /S "'+CmdParam+'"';
     CmdLine:=ExpandEnvString('%SystemRoot%\regedit.exe');

  end else exit;

  WriteLog('Reg File: '+RegFileName);
  if DetaliseLog then begin
   WriteLog('  Work Dir: '+ProgrammFolder);
   WriteLog('  Cmd Line: '+CmdLine);
   WriteLog('  Cmd Param: '+CmdParam);
  end;
  WriteLog('');
  if not FileExists(RegFile) then begin
      ErrorCode := 2;  //ERROR_FILE_NOT_FOUND
      if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil,
                        ErrorCode, LOCALE_USER_DEFAULT,
                        Buf, sizeof(Buf), nil) <> 0) then
          WriteLog('  Error: '+ String(Buf));
  end else begin
   FillChar(ShExInfo,SizeOf(TShellExecuteInfo),0);
   ShExInfo.cbSize:= SizeOf(TShellExecuteInfo);
   ShExInfo.fMask:=SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_NO_UI;
   ShExInfo.Wnd:=Application.Handle;
   ShExInfo.lpVerb:='open';
   ShExInfo.lpFile:=PChar(CmdLine);
   ShExInfo.lpParameters:=PChar(CmdParam);
   ShExInfo.lpDirectory:=PChar(ProgrammFolder);
   ShExInfo.nShow:=SW_SHOW;
   ShExInfo.hInstApp:=Application.Handle;

   if not ShellExecuteEx(@ShExInfo) then begin
      ErrorCode := GetLastError;
      if (ErrorCode <> 0) and (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil,
         ErrorCode, LOCALE_USER_DEFAULT, Buf, sizeof(Buf), nil) <> 0) then
         WriteLog('  Error: '+ String(Buf));
   end else begin

    PrId:= ShExInfo.hProcess;
    repeat
      Application.ProcessMessages;
      Sleep(10);
      GetExitCodeProcess(PrId, ExitCode);
     until (ExitCode <> STILL_ACTIVE) or Application.Terminated  or IsBreak;
	   GetExitCodeProcess(PrId, result);
   end;
   if TestMode then  Delay(DemoWaitTime);
 end;

end;

procedure KillItem;
begin
  if not InProgress then exit;
  IsBreak:=true;
  TerminateProcess(PrId,0);
  WriteLog('  Process killed manually!!!');
  WriteLog('');
end;

procedure PreInstall;
  var
   SelLog:TstringList;
   i:integer;
begin
  WriteLog('Starts install process at: '+TimeToStr(Now));
  InProgress:=true;
  if TestMode then begin
   WriteLog('');
   WriteLog('  Warning! Test mode.');
   WriteLog('  Not really install! Simulated only!');
   WriteLog('');
  end;
  WriteLog('*** Selected programm ***********************************************************');
  WriteLog('');
  SelLog:=TstringList.Create;
  try
    MakeSelectLog(SelLog);
    for i:=0 to SelLog.Count-1 do WriteLog( SelLog[i]);
  finally
    SelLog.Free;
  end;
  WriteLog('');
  WriteLog('*** Pre-install task ************************************************************');
  WriteLog('');
  if (BeforePreRegFile<>'') then begin
      WriteLog('');
      WriteLog('Adding Pre Reg File:');
      RegAdd(RootInstallDir,PreInstallFolder,BeforePreRegFile);
  end;
  if (PreCommand[0] <> '') or
        (PreCommand[1] <> '') or
        (PreCommand[2] <> '') or
        (PreCommand[3] <> '') then begin
      WriteLog('');
      WriteLog('Executing pre-install commands:');
      WriteLog('');
      RunItem(RootInstallDir,PreInstallFolder,PreCommand[0],0);
      RunItem(RootInstallDir,PreInstallFolder,PreCommand[1],0);
      RunItem(RootInstallDir,PreInstallFolder,PreCommand[2],0);
      RunItem(RootInstallDir,PreInstallFolder,PreCommand[3],0);
  end;
  if (BeforePostRegFile<>'') then begin
      WriteLog('');
      WriteLog('Adding Post Reg File:');
      RegAdd(RootInstallDir,PreInstallFolder,BeforePostRegFile);
  end;
  WriteLog('');
  WriteLog('*** End Pre-install task ********************************************************');
  if TestMode then Delay(DemoWaitTime*2);
end;

procedure PostInstall;
begin
  WriteLog('');
  WriteLog('*** Post-install task ***********************************************************');
  WriteLog('');
  if (AfterPreRegFile <> '') then begin
   WriteLog('');
   WriteLog('Adding Pre Reg File:');
   RegAdd(RootInstallDir,PostInstallFolder,AfterPreRegFile);
  end;
  if (PostCommand[0] <> '') or
     (PostCommand[1] <> '') or
     (PostCommand[2] <> '') or
     (PostCommand[3] <> '') then begin
   WriteLog('');
   WriteLog('Executing post-install commands:');
   WriteLog('');
   RunItem(RootInstallDir,PostInstallFolder,PostCommand[0],0);
   RunItem(RootInstallDir,PostInstallFolder,PostCommand[1],0);
   RunItem(RootInstallDir,PostInstallFolder,PostCommand[2],0);
   RunItem(RootInstallDir,PostInstallFolder,PostCommand[3],0);
  end;
  if (AfterPostRegFile<>'') then begin
   WriteLog('');
   WriteLog('Adding Post Reg File:');
   RegAdd(RootInstallDir,PostInstallFolder,AfterPostRegFile);
  end;
  InProgress:=false;
  WriteLog('');
  WriteLog('*** End Post-install task *******************************************************');
  WriteLog(' Install process end at: '+TimeToStr(Now));
  if TestMode then Delay(DemoWaitTime*2);
  if not PeMode then begin
   WriteLog('');
   WriteLog(' Reboot planned:    ' + BoolToString(RebootFlag));
   WriteLog(' Power Off planned: ' + BoolToString(PowerOffFlag));
  end;
  if FileExists(GetInstallLog) then DeleteFile(GetInstallLog);
end;

procedure AddDebugMsg(Msg:string);
begin
 WriteLog(Msg);
end;

procedure CreateInstallList;
begin
   GroupList:=TList.Create;
   ConfigList:=TStringList.Create;
   InstallList:=TStringList.Create;
   UserEnvironmentVariable:=TStringList.Create;
end;

procedure InitInstallList;
begin
   InstallList.Add('; +++++++++++++++++++++++++++++++++++++++++');
   InstallList.Add('; BS Post Installer temporay file V'+SetVer);
   InstallList.Add('; This text auto generated');
   InstallList.Add('; Do not modify manually!!!');
   InstallList.Add('; This file will be removed');
   InstallList.Add('; after end of installation.');
   InstallList.Add('; +++++++++++++++++++++++++++++++++++++++++');
   InstallList.Add('');
   InstallList.Add('[Common_Info]');
   InstallList.Add('Ver='+ SetVer);
   InstallList.Add('ConfigFile='+ MainIni);
   InstallList.Add('CRC='+IntToStr(SetCRC));
   InstallList.Add('IsTest='+IntToStr(Ord(TestMode)));
   InstallList.Add('');
   InstallList.Add('[Install_Events]');
   InstallList.Add('');
   InstallList.Add('[Selected_Items]');
   InstallList.Add('');
   InstallList.Add('[Installed_Items]');
   InstallList.Add('');
   InstallList.Add('[Scipped_Items]');
end;

procedure AddCommonInfo;
var
 i:integer;
begin
 if DetaliseLog then begin
   WriteLog('*** Common information **********************************************************');
   WriteLog('');
   WriteLog('Full programm version: ' + GetApplicationVersion(Application.ExeName));
   WriteLog('');
   WriteLog('Environment:');
   WriteLog('  Command-line:'+#9#9+ GetCommandLine);
   WriteLog('  Config file:'+#9#9+ MainIni);
   if CheckCmdParam('force') then  WriteLog('  Anserver file:'+#9+ GetConfigFile);
   WriteLog('  RootInstallDir:'+#9+RootInstallDir);
   if RootInstallDir = '' then WriteLog('  WARNING! '+#9#9+'RootInstallDir not defined!');
   WriteLog('  %SELF%:'+#9#9+ ExpandEnvString('%SELF%'));
   WriteLog('  %SOURCE%:'+#9#9+  ExpandEnvString('%SOURCE%'));
   WriteLog('  %CDROM%:'+#9#9+  ExpandEnvString('%CDROM%'));
   WriteLog('  %ROOT%:'+#9#9+  ExpandEnvString('%ROOT%'));
   WriteLog('  CommonIconLib:'+#9+  CommonIconLibFile);
   WriteLog('  CommonShotFolder:'+#9+  CommonShotFolderExp);
   WriteLog('');
   WriteLog('  UserEnvironmentVariable:');
   if UserEnvironmentVariable.Count> 0 then
      for i:=0 to UserEnvironmentVariable.Count -1 do WriteLog('   ' + UserEnvironmentVariable.Names[i] + ' = '+ ExpandEnvString(UserEnvironmentVariable.ValueFromIndex[i]));
   WriteLog('');
   WriteLog('  PE mode:' +#9#9+ BoolToString(IsPeMode));
   WriteLog('  UnAttendMode:' +#9#9+ BoolToString(CheckCmdParam('force')));
   WriteLog('');
   WriteLog('*** End Common information ******************************************************');
   WriteLog('');
  end; 
end;

procedure ClearInstallList;
var
  TmpGroup:PInstallGroup;
  G,I:integer;
begin
  for G:=0 to GroupList.Count-1 do begin
   TmpGroup:= GroupList[G];
   if (TmpGroup.ItemList<> nil) and
      (TmpGroup.ItemList.Count > 0) then begin
       for I:=0 to TmpGroup.ItemList.Count - 1 do  Dispose(TmpGroup.ItemList[I]);
       TmpGroup.ItemList.Free;
      end;
      Dispose(TmpGroup);
  end;
  GroupList.Clear;
end;

procedure FreeInstallList;
begin
   ClearInstallList;
   GroupList.Free;
   ConfigList.Free;
   InstallList.Free;
   UserEnvironmentVariable.Free;
   if RebootSheduled then begin
      WriteLog('');
      WriteLog('Reboot sheduled: '+TimeToStr(Now));
   end;
end;


function GetGroupCount:integer;
begin
  result:=GroupList.Count;
end;

function GetGroupFromName (GroupName: string):PInstallGroup;
var
  i:integer;
begin
  result:=nil;
  if GroupList.Count > 0 then
   for i:=0 to GroupList.Count-1 do begin
    if PInstallGroup(GroupList[i])^.Group = GroupName then begin
      result:= GroupList[i];
      break;
    end;
   end;
end;

function GetGroupFromId (GroupId: integer):PInstallGroup;
begin
  result:=nil;
  if GroupId < GroupList.Count then result:= GroupList[GroupId];
end;

function NewInstallGroup (Group:string; Desciription: string): PInstallGroup;
begin
   New(Result);
   Result^.ItemList:=TList.Create;
   Result^.Group:=Group;
   Result^.Description:= Desciription;
   Result^.Selected:=0;
   Result^.St3Checked:=false;
   Result^.Expandet:=false;
   Result^.Blocked:=false;
   Result^.Fixed:=false;
   GroupList.Add(Result);
end;

procedure DeleteInstallGroup(AGroup:PInstallGroup);
var
  I:integer;
begin
  if AGroup = nil then exit;
  if (AGroup.ItemList<> nil) and
      (AGroup.ItemList.Count > 0) then begin
       for I:=0 to AGroup.ItemList.Count - 1 do  Dispose(AGroup.ItemList[I]);
       AGroup.ItemList.Free;
  end;
  Dispose(AGroup);
  GroupList.Remove(AGroup);
end;

function  GetNewInstallGroupName:string;
var
 i,J:integer;
 NoUnikue:boolean;
begin
  J:=1;
  NoUnikue:=true;
  while NoUnikue do begin
   NoUnikue:=false;
   result:= NewGroupName + ' ' + IntTostr(J);
   for i:= 0 to GroupList.Count -1 do
     if PInstallGroup(GroupList[i]).Group = result then begin
       NoUnikue:=true;
       Inc(J);
       break;
     end;
  end;
end;

function  GetNewInstallItemName(AGroup:PInstallGroup):string;
var
 i,J:integer;
 NoUnikue:boolean;
begin
  J:=1;
  NoUnikue:=true;
  result:='';
  if AGroup = nil then exit;
  while NoUnikue do begin
   NoUnikue:=false;
   result:= NewInstallItemName + ' ' + IntTostr(J);
   for i:= 0 to AGroup.ItemList.Count -1 do
     if PInstallItem(AGroup.ItemList[i]).Caption = result then begin
       NoUnikue:=true;
       Inc(J);
       break;
     end;
  end;
end;

function  GetNewInstallItemNumber:integer;
var
  G,I: integer;
  TmpGroup:PInstallGroup;
  TmpItem:PInstallItem;
begin
  Result:=-1;
   for G:=0 to  GetGroupCount - 1 do begin
    TmpGroup:=GetGroupFromId(G);
    for i:=0 to TmpGroup.ItemList.Count-1 do begin
     Result:=Max(Result, PInstallItem(TmpGroup.ItemList[I]).Number);
    end;
   end;
  Inc(Result);
end;


function  ValidateSetIni(filename:string):boolean;
begin
 result:=false;
 if not FileExists(FileName) then exit;
 result:=true;
 if CheckCmdParam('nocrc') then exit;
 with TIniFile.Create(FileName) do
  try
    result:=result and (SetVer = ReadString('Common_Info','Ver',''));
    result:=result and SectionExists('Setup');
    result:=result and SectionExists('PreInstall');
    result:=result and SectionExists('PostInstall');
    result:=result and SectionExists('SoftwareGroup');
  finally
   free;
  end;
end;

function GroupsLoadFromIni(filename:string):boolean;
var
  Ini:TIniFile;
  I:Integer;
  TmpList:TstringList;
  TmpItem:PInstallItem;
  TmpGroup:PInstallGroup;
  ParentGroup:PInstallGroup;
begin
  Ini:=TIniFile.Create(filename);
  TmpList:= TStringList.Create;
  result:=false;
  try
   if (SetVer <> Ini.ReadString('Common_Info','Ver','')) then exit;
   SetAutor:= Ini.ReadString('Common_Info','Autor','NoName');
   SetDate:= Ini.ReadString('Common_Info','Date','XX.XX.XX');
   SetDescription:= Ini.ReadString('Common_Info','Description','No Description');
   RootInstallDir:=Ini.ReadString('Setup','RootInstallDir','');
   CommonIconLib:=Ini.ReadString('Setup','CommonIconLib','');
   CommonShotFolder:=Ini.ReadString('Setup','CommonShotFolder','');
   LogFile:=Ini.ReadString('Setup','LogFile','%SystemDrive%\InstallLog.txt');
   LogInstall:= Ini.ReadBool('Setup','LogInstall',true);
   DetaliseLog:= Ini.ReadBool('Setup','DetaliseLog',true);
   EnableUserInput:= Ini.ReadBool('Setup','EnableUserInput',true);
   EnableCloseMsg:= Ini.ReadBool('Setup','EnableCloseMsg',true);
   EnableWelcomeDlg:= Ini.ReadBool('Setup','EnableWelcomeDlg',true);
   AdminRightsRequired:= Ini.ReadBool('Setup','AdminRightsRequired',false);
   CheckFDD:=Ini.ReadBool('Setup','CheckFDD',false);
   CheckCd:=Ini.ReadBool('Setup','CheckCd',true);
   CheckFlash:=Ini.ReadBool('Setup','CheckFlash',true);
   CheckHDD:=Ini.ReadBool('Setup','CheckHDD',false);
   CheckNet:=Ini.ReadBool('Setup','CheckNet',false);
   SourceTagFile:=Ini.ReadString('Setup','SourceTagFile','');
   StartTimerTime:=Ini.ReadInteger('Setup','DefaultTimer',0);
   ReadMeTxt:=Ini.ReadString('Setup','ReadMeText','');
   LicenseTxt:=Ini.ReadString('Setup','LicenseText','');
   RunOnceSubKey:=Ini.ReadString('Setup','RunOnceKey','999');
   RunValyeName:=Ini.ReadString('Setup','RunValyeName','TEMP_BS_POSTINSTALLER');
   UseRunKey:=Ini.ReadBool('Setup','UseRunKey',false);
   ShowLog:=Ini.ReadBool('Setup','ShowLog',false);
   AutoClose:=Ini.ReadBool('Setup','AutoClose',true);
   SupressReboot:=Ini.ReadBool('Setup','SupressReboot',false);
   PreInstallFolder:=Ini.ReadString('Preinstall','Folder','');
   BeforePreRegFile:=Ini.ReadString('Preinstall','PreRegFile','');
   PreCommand[0]:=Ini.ReadString('Preinstall','Command1','');
   PreCommand[1]:=Ini.ReadString('Preinstall','Command2','');
   PreCommand[2]:=Ini.ReadString('Preinstall','Command3','');
   PreCommand[3]:=Ini.ReadString('Preinstall','Command4','');
   BeforePostRegFile:=Ini.ReadString('Preinstall','PostRegFile','');
   PostInstallFolder:=Ini.ReadString('Postinstall','Folder','');
   AfterPreRegFile:=Ini.ReadString('Postinstall','PreRegFile','');
   PostCommand[0]:=Ini.ReadString('Postinstall','Command1','');
   PostCommand[1]:=Ini.ReadString('Postinstall','Command2','');
   PostCommand[2]:=Ini.ReadString('Postinstall','Command3','');
   PostCommand[3]:=Ini.ReadString('Postinstall','Command4','');
   AfterPostRegFile:=Ini.ReadString('Postinstall','PostRegFile','');
   RebootFlag:= Ini.ReadBool('Postinstall','Reboot',false);
   PowerOffFlag:= Ini.ReadBool('Postinstall','PowerOff',false);
   for i:=Low(UserButton) to High(UserButton) do
      with UserButton[i] do begin
            Caption:=Ini.ReadString('UserButton_'+IntToStr(I),'Caption','');
            Hint:=Ini.ReadString('UserButton_'+IntToStr(I),'Hint','');
            Picture:=Ini.ReadString('UserButton_'+IntToStr(I),'Picture','');
            Folder:=Ini.ReadString('UserButton_'+IntToStr(I),'Folder','');
            Command:=Ini.ReadString('UserButton_'+IntToStr(I),'Command','');
            Text:=Ini.ReadString('UserButton_'+IntToStr(I),'Text','');
            Visible:= Ini.ReadBool('UserButton_'+IntToStr(I),'Visible',false);
      end;

   GetSourceDrive;
   GetSelfFolder;
   GetRootFolder;

   if SmallIconList <> nil then IconShift:= SmallIconList.Count;

   Ini.ReadSectionValues('UserEnvironmentVariable',UserEnvironmentVariable);
   if UserEnvironmentVariable.Count> 0 then
      for i:=0 to UserEnvironmentVariable.Count -1 do SetEnvironmentVariable(PChar(UserEnvironmentVariable.Names[i]),PChar(ExpandEnvString(UserEnvironmentVariable.ValueFromIndex[i])));

   if CommonShotFolder <> '' then begin
      if IsAbcPath(CommonShotFolder)
          then CommonShotFolderExp:=NormaliseFirstSlash(ExpandEnvString(CommonShotFolder))
          else CommonShotFolderExp:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseFirstSlash(ExpandEnvString(CommonShotFolder));
   end;

   
   if CommonIconLib <> ''  then begin
      if IsAbcPath(CommonIconLib) then CommonIconLibFile:=NormaliseFirstSlash(ExpandEnvString(CommonIconLib))
                                  else CommonIconLibFile:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseFirstSlash(ExpandEnvString(CommonIconLib));
    InitIconLib(CommonIconLibFile,SmallIconList,BigIconList);
   end;

   Ini.ReadSectionValues('SoftwareGroup',TmpList);

   if TmpList.Count = 0 then exit;
   for i:=0 to TmpList.Count -1 do begin
     TmpGroup:=NewInstallGroup(TmpList.Names[i],TmpList.ValueFromIndex[I]);
     if (TmpGroup^.Group<>'') and
        (TmpGroup^.Group[1] = '+') then begin
         Delete(TmpGroup^.Group,1,1);
         TmpGroup^.Expandet:=true;
         TmpGroup^.Blocked:=false;
     end else if (TmpGroup^.Group<>'') and
                 (TmpGroup^.Group[1] = '#') then begin
         Delete(TmpGroup^.Group,1,1);
         TmpGroup^.Expandet:=true;
         TmpGroup^.Blocked:=true;
     end else begin
         TmpGroup^.Expandet:=false;
         TmpGroup^.Blocked:=false;
     end;
   end;

   TmpList.Clear;
   Ini.ReadSections(TmpList);
   for i:=0 to TmpList.Count-1 do begin
    if pos('installitem_', LowerCase(TmpList[i]))>0 then begin
     TmpItem:=InstallItemReadFromIni(Ini,TmpList[i]);
     if TmpItem <> nil then begin
       ParentGroup:= GetGroupFromName(TmpItem^.Group);
       if ParentGroup <> nil then InstallItemAdd(ParentGroup,TmpItem)
                             else dispose(TmpItem);
     end;
    end;
   end;
   ValidateExcludeAll;
   SetDefault;
   for i:=0 to GroupList.Count -1 do begin
     PInstallGroup(GroupList[i])^.Selected:= CheckGroupSelected(PInstallGroup(GroupList[i]));
     if PInstallGroup(GroupList[i])^.Selected = 1 then PInstallGroup(GroupList[i])^.St3Checked:=true;

   end;
  finally
    TmpList.Free;
    Ini.Free;
  end;
  SetCrc:=CalcCRC(filename);
  result:=true;
end;

function GroupsSaveToIni(filename:string; OnlySelected:boolean):boolean;
var
  Ini:TIniFile;
  G,I: integer;
  TmpGroup:PInstallGroup;
  TmpItem:PInstallItem;
  TmpStr:string;
begin
  if FileExists(filename) then DeleteFile(filename);
  Ini:=TIniFile.Create(filename);
  result:=false;                    
  try
   Ini.WriteString('Common_Info','Ver',SetVer);
   Ini.WriteString('Common_Info','Autor',SetAutor);
   Ini.WriteString('Common_Info','Description',SetDescription); 
   Ini.WriteString('Common_Info','Date',SetDate);
   Ini.WriteString('Setup','RootInstallDir',RootInstallDir);
   Ini.WriteString('Setup','CommonIconLib',CommonIconLib);
   Ini.WriteString('Setup','CommonShotFolder',CommonShotFolder);
   Ini.WriteString('Setup','LogFile',LogFile);
   Ini.WriteBool('Setup','LogInstall',LogInstall);
   Ini.WriteBool('Setup','DetaliseLog',DetaliseLog);
   Ini.WriteBool('Setup','EnableUserInput',EnableUserInput);
   Ini.WriteBool('Setup','EnableCloseMsg',EnableCloseMsg);
   Ini.WriteBool('Setup','EnableWelcomeDlg',EnableWelcomeDlg);
   Ini.WriteBool('Setup','AdminRightsRequired',AdminRightsRequired);
   Ini.WriteBool('Setup','CheckFDD',CheckFDD);
   Ini.WriteBool('Setup','CheckCd',CheckCd);
   Ini.WriteBool('Setup','CheckFlash',CheckFlash);
   Ini.WriteBool('Setup','CheckHDD',CheckHDD);
   Ini.WriteBool('Setup','CheckNet',CheckNet);
   Ini.WriteString('Setup','SourceTagFile',SourceTagFile);
   Ini.WriteInteger('Setup','DefaultTimer',StartTimerTime);
   Ini.WriteString('Setup','ReadMeText',ReadMeTxt);
   Ini.WriteString('Setup','RunOnceKey',RunOnceSubKey);
   Ini.WriteString('Setup','RunValyeName',RunValyeName);
   Ini.WriteBool('Setup','UseRunKey',UseRunKey);
   Ini.WriteBool('Setup','ShowLog',ShowLog);
   Ini.WriteBool('Setup','AutoClose',AutoClose);
   Ini.WriteBool('Setup','SupressReboot',SupressReboot);
   Ini.WriteString('Preinstall','PreRegFile',BeforePreRegFile);
   Ini.WriteString('Preinstall','Command1',PreCommand[0]);
   Ini.WriteString('Preinstall','Command2',PreCommand[1]);
   Ini.WriteString('Preinstall','Command3',PreCommand[2]);
   Ini.WriteString('Preinstall','Command4',PreCommand[3]);
   Ini.WriteString('Preinstall','PostRegFile',BeforePostRegFile);
   Ini.WriteString('Postinstall','PreRegFile',AfterPreRegFile);
   Ini.WriteString('Postinstall','Command1',PostCommand[0]);
   Ini.WriteString('Postinstall','Command2',PostCommand[1]);
   Ini.WriteString('Postinstall','Command3',PostCommand[2]);
   Ini.WriteString('Postinstall','Command4',PostCommand[3]);
   Ini.WriteString('Postinstall','PostRegFile',AfterPostRegFile);
   Ini.WriteBool('Postinstall','Reboot',RebootFlag);
   Ini.WriteBool('Postinstall','PowerOff',PowerOffFlag);
   for i:=Low(UserButton) to High(UserButton) do
      with UserButton[i] do begin
            Ini.WriteString('UserButton_'+IntToStr(I),'Caption',Caption);
            Ini.WriteString('UserButton_'+IntToStr(I),'Hint',Hint);
            Ini.WriteString('UserButton_'+IntToStr(I),'Picture',Picture);
            Ini.WriteString('UserButton_'+IntToStr(I),'Folder',Folder);
            Ini.WriteString('UserButton_'+IntToStr(I),'Command',Command);
            Ini.WriteBool('UserButton_'+IntToStr(I),'Visible',Visible);
      end;

   if UserEnvironmentVariable.Count> 0 then
      for i:=0 to UserEnvironmentVariable.Count -1 do
         Ini.WriteString('UserEnvironmentVariable',UserEnvironmentVariable.Names[i],UserEnvironmentVariable.ValueFromIndex[i]);

   if GetGroupCount > 0 then begin
   for G:=0 to  GetGroupCount - 1 do begin
    TmpGroup:=GetGroupFromId(G);
    if TmpGroup.ItemList.Count > 0 then begin
       if TmpGroup^.Blocked then TmpStr:='#' else
       if TmpGroup^.Expandet then TmpStr:='+' else
       TmpStr:='';
    if not OnlySelected then Ini.WriteString('SoftwareGroup',TmpStr+TmpGroup^.Group,TmpGroup^.Description)
                        else if ValidateGroup(TmpGroup) then begin

       Ini.WriteString('SoftwareGroup',TmpStr+TmpGroup^.Group,TmpGroup^.Description);
      end;
    for i:=0 to TmpGroup.ItemList.Count-1 do begin
     TmpItem:= PInstallItem(TmpGroup.ItemList[I]);
     if TmpItem <> nil then begin if not Onlyselected then InstallItemWriteToIni(Ini,TmpItem)
                                                      else if ValidateItem(TmpItem) then InstallItemWriteToIni(Ini,TmpItem);
                            end;
     end;
    end;
   end;
   end;
  finally
    Ini.Free;
  end;
  SetCrc:=CalcCRC(filename);
  OptimiseIni(filename);
end;


procedure ReNumerateItems;
var
  G,I,N: integer;
  TmpGroup:PInstallGroup;
  TmpItem:PInstallItem;
begin
  N:=0;
   for G:=0 to  GetGroupCount - 1 do begin
    TmpGroup:=GetGroupFromId(G);
    for i:=0 to TmpGroup.ItemList.Count-1 do begin
     PInstallItem(TmpGroup.ItemList[I]).Number:=N;
     Inc(N);
    end;
   end;
end;


procedure FillTreeView(ATreeView: TTreeView; OnlyFullGroup:boolean; OnlyVisible:boolean);
var
 G,I: integer;
 Node, ChildNode, FirstNode :TTreeNode;
 TmpGroup:PInstallGroup;
 TmpItem:PInstallItem;
 ParentFixed:boolean;
begin
 ATreeView.Items.Clear;
 FirstNode:=nil;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
      TmpGroup:=GetGroupFromId(G);
      if (TmpGroup.ItemList.Count > 0) or (not OnlyFullGroup) then  begin
      Node:=ATreeView.Items.AddObject(nil,'--- '+TmpGroup^.Group+' ---',TmpGroup);
      if TmpGroup^.Blocked then  Node.SelectedIndex:=2
                           else  Node.SelectedIndex:=0;
      Node.ImageIndex:=Node.SelectedIndex;
      Node.StateIndex:=TmpGroup^.Selected+1;
      TmpGroup^.INode:=Node;
      if (TmpGroup.ItemList.Count > 0) then ParentFixed:= PInstallItem(TmpGroup.ItemList[0]).Fixed;

      for i:=0 to TmpGroup.ItemList.Count-1 do begin
       TmpItem:= PInstallItem(TmpGroup.ItemList[I]);
       if TmpItem^.Visible or not OnlyVisible then begin
        ChildNode:=ATreeView.Items.AddChildObject(Node,TmpItem^.Caption,TmpItem);
        ChildNode.SelectedIndex:=TmpItem^.ImageId;
        ChildNode.ImageIndex:=TmpItem^.ImageId;
        if TmpItem^.Fixed then ChildNode.StateIndex:=4+Ord(TmpItem^.Selected)
                          else  ChildNode.StateIndex:=1+Ord(TmpItem^.Selected);
        ParentFixed:= TmpItem^.Fixed and  ParentFixed;
        TmpItem^.INode:=ChildNode;
       end;
      end;
      TmpGroup^.Fixed:= ParentFixed;
      if ParentFixed then Node.StateIndex:= Node.StateIndex+3;
      if ParentFixed then TmpGroup^.Fixed:=true;
       if TmpGroup^.Expandet then begin
                                 Node.Expand(false);
                                 if FirstNode = nil then FirstNode:=Node;
                                 //Node.Selected:=true;
                                end;
      end;
    end;
  end;
  if ATreeView.Items.Count > 0 then ATreeView.Items[0].MakeVisible;
  if FirstNode<> nil then begin
                            FirstNode.Selected:=true;
                            FirstNode.MakeVisible;
                          end;
end;

function CheckGroupSelected(AGroup: PInstallGroup):byte;
var
  I:integer;
  FirstNodeState:boolean;
begin
 result:=2;
 if AGroup.ItemList.Count > 0 then begin
  FirstNodeState:= PInstallItem(AGroup.ItemList[0]).Selected;
  for i:=1 to AGroup.ItemList.Count-1 do begin
   if FirstNodeState <> PInstallItem(AGroup.ItemList[i]).Selected
   then begin
     result:=2;
     exit;
   end;
  end;
  result:=Ord(FirstNodeState);
 end;
end;

function SetGroupSelected(AGroup: PInstallGroup; Checked:boolean):byte;
var
  G, I:integer;
  EndNodeState:boolean;
  GroupCheckStae:byte;
begin
  GroupCheckStae:=0;
  if AGroup^.ItemList.Count > 0 then begin
   PInstallItem(AGroup^.ItemList[AGroup^.ItemList.Count-1])^.Selected:= Checked;
   EndNodeState:= Checked;
   for i:=AGroup^.ItemList.Count-2 downto 0 do begin
    if PInstallItem(AGroup^.ItemList[i])^.Fixed then PInstallItem(AGroup^.ItemList[i])^.Selected:=PInstallItem(AGroup^.ItemList[i])^.SelectDefault
        else if Checked then begin
        if PInstallItem(AGroup^.ItemList[i])^.DefaultInExcludeList
          then
           PInstallItem(AGroup^.ItemList[i])^.Selected:= PInstallItem(AGroup^.ItemList[i])^.SelectDefault
          else
           PInstallItem(AGroup^.ItemList[i])^.Selected:= Checked;
    end else PInstallItem(AGroup^.ItemList[i])^.Selected:= Checked;
    if PInstallItem(AGroup^.ItemList[i]).Selected then CheckExclude(AGroup.ItemList[i]);
    CheckDepends(AGroup^.ItemList[i]);
    if EndNodeState <> PInstallItem(AGroup^.ItemList[i]).Selected
    then begin
     GroupCheckStae:=2;
    end;
  end;
  if GroupCheckStae = 2 then GroupCheckStae:=Ord(EndNodeState);
  result:=  GroupCheckStae;
  end;
end;


procedure RecheckAllgroup;
var
  I:Integer;
begin
   for i:=0 to GroupList.Count -1 do begin
     PInstallGroup(GroupList[i])^.Selected:= CheckGroupSelected(PInstallGroup(GroupList[i]));
   end;
end;

procedure SetDefault;
var
  G, I:integer;
  FirstNodeState:boolean;
  GroupCheckState:byte;
begin
  for G:=0 to GroupList.Count -1 do begin
  GroupCheckState:=0;
  if PInstallGroup(GroupList[G]).ItemList.Count > 0 then begin
   PInstallItem(PInstallGroup(GroupList[G]).ItemList[0]).Selected:= PInstallItem(PInstallGroup(GroupList[G]).ItemList[0]).SelectDefault;
   FirstNodeState:= PInstallItem(PInstallGroup(GroupList[G]).ItemList[0]).Selected;
   for i:=1 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
    PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Selected:= PInstallItem(PInstallGroup(GroupList[G]).ItemList[i]).SelectDefault;
    if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Selected then
    CheckExclude(PInstallGroup(GroupList[G])^.ItemList[i]);
    CheckDepends(PInstallGroup(GroupList[G])^.ItemList[i]);
    if FirstNodeState <> PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Selected
    then begin
     GroupCheckState:=2;
    end;
  end;
  if GroupCheckState = 0 then GroupCheckState:=Ord(FirstNodeState);
  PInstallGroup(GroupList[G])^.Selected:= GroupCheckState;
  PInstallGroup(GroupList[G])^.St3Checked:= GroupCheckState>0;
  end;
 end;
 RecheckAllgroup;
end;

procedure SetState(Checked:boolean);
var
  G, I:integer;
  FirstNodeState:boolean;
  GroupCheckState:byte;
begin
  for G:=0 to GroupList.Count -1 do begin
  GroupCheckState:=0;
  if PInstallGroup(GroupList[G])^.ItemList.Count > 0 then begin
   FirstNodeState:=Checked;
   for i:=PInstallGroup(GroupList[G])^.ItemList.Count-1 downto 0 do begin
     if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Fixed then
       PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:= PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.SelectDefault
    else if Checked then begin
        if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.DefaultInExcludeList
          then
           PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:= PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.SelectDefault
          else
           PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:= Checked;
    end else PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:= Checked;
    if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected then
    CheckExclude(PInstallGroup(GroupList[G])^.ItemList[i]);
    CheckDepends(PInstallGroup(GroupList[G])^.ItemList[i]);
    if FirstNodeState <> PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected
    then begin
     GroupCheckState:=2;
    end;
  end;
  if GroupCheckState = 0 then GroupCheckState:=Ord(FirstNodeState);
  PInstallGroup(GroupList[G])^.Selected:= GroupCheckState;
  PInstallGroup(GroupList[G])^.St3Checked:=Checked;
  end;
 end;
 RecheckAllgroup;
end;

procedure SetSelectedFromNumber(AItemNumber:integer; ASelected: boolean);
var
 G, I:integer;
begin
  for G:=0 to GroupList.Count -1 do begin
   if PInstallGroup(GroupList[G])^.ItemList.Count > 0 then begin
     for i:=PInstallGroup(GroupList[G])^.ItemList.Count-1 downto 0 do
         if (PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Number = AItemNumber) then begin
           PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:=ASelected;
         end;
     end;
   end;
end;

procedure SetDependsFromNumber(ADependetItemNumber:integer);
var
 N, G, I:integer;

begin
  for G:=0 to GroupList.Count -1 do begin
   if PInstallGroup(GroupList[G])^.ItemList.Count > 0 then begin
     for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do
      if  PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.DependsList.Count > 0 then begin
        for N:=0 to PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.DependsList.Count - 1 do
        begin
          if   (ADependetItemNumber = Integer(PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.DependsList[N])) then begin
               PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:=false;
               break;
          end;
        end;
      end;
     end;
  end;
end;

function ItemNameFromNumber(AItemNumber:integer):string;
 var
  G, I:integer;
begin
  for G:=0 to GroupList.Count -1 do begin
    if PInstallGroup(GroupList[G]).ItemList.Count > 0 then begin
      for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do
       if  (PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number = AItemNumber) then begin
            result:= PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Caption;
            break;
      end;
    end;
  end;
end;

function ItemFromNumber(AItemNumber:integer):PInstallItem;
 var
  G, I:integer;
begin
  for G:=0 to GroupList.Count -1 do begin
    if PInstallGroup(GroupList[G]).ItemList.Count > 0 then begin
      for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do
       if  (PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number = AItemNumber) then begin
            result:= PInstallGroup(GroupList[G])^.ItemList[i];
            break;
      end;
    end;
  end;
end;


function GetDependsString(AInstallItem: PInstallItem):string;
var
 N :integer;
 ItemNumber:integer;
begin
 result:='';
 if AInstallItem^.DependsList.Count>0 then begin
    for N:=0 to AInstallItem^.DependsList.Count - 1 do
      begin
         ItemNumber:=Integer(AInstallItem^.DependsList[N]);
         result:= result + ItemNameFromNumber(ItemNumber) + '; ';
       end;
 end;
end;


function GetExcludeString(AInstallItem: PInstallItem):string;
var
 N :integer;
 ItemNumber:integer;
begin
 result:='';
 if AInstallItem^.ExcludeList.Count>0 then begin
    for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
      begin
         ItemNumber:=Integer(AInstallItem^.ExcludeList[N]);
         result:= result + ItemNameFromNumber(ItemNumber) + '; ';
       end;
 end;
end;


procedure ValidateExclude(AInstallItem: PInstallItem);
var
 N:integer;
 ItemNumber:integer;
 Blocked:boolean;
 TmpItem: PInstallItem;
 DefInList:boolean;
begin
 Blocked:= AInstallItem^.SelectDefault and AInstallItem^.Fixed;
 DefInList:= AInstallItem^.SelectDefault;
 if AInstallItem^.ExcludeList.Count>0 then begin
    if blocked then begin
       for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
          begin
            ItemNumber:=Integer(AInstallItem^.ExcludeList[N]);
            TmpItem:= ItemFromNumber(ItemNumber);
            if TmpItem <> nil then begin
                                     TmpItem^.Fixed:=true;
                                     TmpItem^.SelectDefault:=false;
                                     TmpItem^.Selected:=false;
                                   end;
         end
    end else begin
    Blocked:=false;
    for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
       begin
         ItemNumber:=Integer(AInstallItem^.ExcludeList[N]);
         TmpItem:= ItemFromNumber(ItemNumber);
         if TmpItem <> nil then begin
           Blocked:= TmpItem^.SelectDefault and TmpItem^.Fixed;
           if Blocked then break;
         end;
       end;
       if blocked then  begin
          AInstallItem^.Fixed:=true;
          for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
             begin
               TmpItem:= ItemFromNumber(ItemNumber);
               if TmpItem <> nil then TmpItem^.Fixed:=true;
             end
       end;
   end;
   if DefInList then begin
     for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
          begin
            ItemNumber:=Integer(AInstallItem^.ExcludeList[N]);
            TmpItem:= ItemFromNumber(ItemNumber);
            if TmpItem <> nil then TmpItem^.DefaultInExcludeList:=true;
          end;
   end else begin
    DefInList:=false;
    for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
       begin
         ItemNumber:=Integer(AInstallItem^.ExcludeList[N]);
         TmpItem:= ItemFromNumber(ItemNumber);
         if TmpItem <> nil then begin
           DefInList:= TmpItem^.SelectDefault;
           if DefInList then break;
         end;
       end;
       if DefInList then  begin

          for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
             begin
               TmpItem:= ItemFromNumber(ItemNumber);
               if TmpItem <> nil then TmpItem^.DefaultInExcludeList:=true;
             end
       end;
   end;
   if DefInList then AInstallItem^.DefaultInExcludeList:=true;
 end;
end;


procedure ValidateExcludeAll;
var
  G,I: integer;
  TmpGroup:PInstallGroup;
begin
   for G:=0 to  GetGroupCount - 1 do begin
    TmpGroup:=GetGroupFromId(G);
    for i:=0 to TmpGroup.ItemList.Count-1 do begin
     ValidateExclude(PInstallItem(TmpGroup.ItemList[I]));
    end;
   end;
end;


procedure CheckExclude(AInstallItem: PInstallItem);
var
 N:integer;
 ItemNumber:integer;
begin
 if AInstallItem^.ExcludeList.Count>0 then
 for N:=0 to AInstallItem^.ExcludeList.Count - 1 do
 begin
   ItemNumber:=Integer(AInstallItem^.ExcludeList[N]);
   SetSelectedFromNumber(ItemNumber,false);
 end;
end;


procedure CheckDepends(AInstallItem: PInstallItem);
var
 N:integer;
 ItemNumber:integer;
 IsSelected:boolean;
 TmpItem: PInstallItem;

 function InExcludeList(FInstallItem: PInstallItem; DependsList:TList):boolean;
   var
   I,K:integer;
   Id:integer;
 begin
   result:=false;
    if FInstallItem^.ExcludeList.Count>0 then
    for I:=0 to FInstallItem^.ExcludeList.Count - 1 do begin
      Id := Integer(FInstallItem^.ExcludeList[I]);
      for K:=0 to DependsList.Count - 1 do begin
       if Id = Integer(DependsList[K]) then begin
           result:=true;
           exit;
       end;
      end;
    end;
 end;

begin
 if AInstallItem^.Selected then begin
    IsSelected:=true;
    if AInstallItem^.DependsList.Count>0 then begin
       for N:=0 to AInstallItem^.DependsList.Count - 1 do
       begin
         ItemNumber:=Integer(AInstallItem^.DependsList[N]);
         TmpItem:= ItemFromNumber(ItemNumber);
         IsSelected:=  (TmpItem <> nil) and
                      ( not (TmpItem^.Fixed and not TmpItem^.Selected)) and
                      (not InExcludeList(TmpItem, AInstallItem^.DependsList));
         if not IsSelected then break;
       end;
       if IsSelected then begin
         for N:=0 to AInstallItem^.DependsList.Count - 1 do
         begin
           ItemNumber:=Integer(AInstallItem^.DependsList[N]);
           TmpItem:= ItemFromNumber(ItemNumber);
           SetSelectedFromNumber(ItemNumber,true);
         end;
       end else AInstallItem^.Selected:=false;
    end;
 end else SetDependsFromNumber(AInstallItem^.Number);
end;

function ValidateItem(AInstallItem: PInstallItem):boolean;
begin
 result:=(AInstallItem <> nil) and
          AInstallItem.Selected and
        ((AInstallItem.PreRegFile<>'')or
         (AInstallItem.PostRegFile<>'')or
         (AInstallItem.Command1<>'')or
         (AInstallItem.Command2<>'')or
         (AInstallItem.Command3<>'')or
         (AInstallItem.Command4<>'')or
         (AInstallItem.Command5<>'')or
         (AInstallItem.Command6<>''));
end;

function ValidateItemFiles(AInstallItem: PInstallItem):boolean;


function CheckCommand(Cmd,Root,Folder:string):boolean;
  var
 CmdLine:string;
 CmdParam:string;
 ProgrammFolder:string;
 AbcCmdPach:boolean;
begin
    if Cmd <> '' then begin
     AbcCmdPach:= IsAbcPath(Cmd);
     if not AbcCmdPach  then
       begin
          if IsAbcPath(Folder) then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString((Folder)))
                                    else if (Folder <> '') then  ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(Folder))
                                        else ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
       end;
     ItemFolder:= ProgrammFolder;
     SetEnvironmentVariable(PChar('FOLDER'),PChar(ProgrammFolder));
     ParseCommandLine(NormaliseFirstSlash(ExpandEnvString(cmd)), CmdLine, CmdParam);
     if AbcCmdPach then ProgrammFolder:=ExtractFileDir(CmdLine) else CmdLine:= ProgrammFolder +CmdLine;
  end;
end;




begin


 // if not FileExists(CmdLine) then begin

end;


function ValidateGroup(AInstallGroup: PInstallGroup):boolean;
var
  I:integer;
begin
  result:=false;
  if AInstallGroup.ItemList.Count > 0 then begin
   for i:=0 to AInstallGroup^.ItemList.Count-1 do begin
    result:= result or ( ValidateItem( PInstallItem(AInstallGroup^.ItemList[i])))
    end;
  end;
end;

procedure MakeSelectLog(ALogList:TStrings);
var
 G,I: integer;
 TmpGroup:PInstallGroup;
 TmpItem:PInstallItem;
 GrupSelected:boolean;
 GrpCount:integer;
 PrgCount:integer;
begin
 ALogList.Clear;
 GrpCount:=0;
 PrgCount:=0;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
     TmpGroup:=GetGroupFromId(G);
     GrupSelected:=false;
     if TmpGroup.ItemList.Count > 0 then begin
     for i:=0 to TmpGroup.ItemList.Count-1 do begin
       if PInstallItem(TmpGroup.ItemList[I])^.Selected then begin
         GrupSelected:=true;
         break;
       end;
      end;
     if GrupSelected then begin
     Inc(GrpCount);
     ALogList.Add(SelectLogGroupName + ' '+ TmpGroup^.Group);
     ALogList.Add('--------------------------------------------------------------------');
     for i:=0 to TmpGroup.ItemList.Count-1 do begin
       TmpItem:= PInstallItem(TmpGroup.ItemList[I]);
       if  TmpItem^.Selected then begin
         ALogList.Add(TmpItem^.Caption);
         Inc(PrgCount);
       end;
      end;
     ALogList.Add('--------------------------------------------------------------------');
     ALogList.Add('');
     end;
     end;
    end;
    ALogList.Add(SafeFormat(SelectLogCommon,[PrgCount,GrpCount]));
  end;
end;

function GetAllSelectCount:integer;
var
 G,I: integer;
 TmpGroup:PInstallGroup;
begin
 Result:=0;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
     TmpGroup:=GetGroupFromId(G);
     if TmpGroup.ItemList.Count > 0 then begin
     for i:=0 to TmpGroup.ItemList.Count-1 do if
       PInstallItem(TmpGroup.ItemList[I])^.Selected then Inc(Result);;
     end;
    end;
 end;
end;


function  GetAllItemCount:integer;
var
 G: integer;
 TmpGroup:PInstallGroup;
begin
 Result:=0;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
     TmpGroup:=GetGroupFromId(G);
     if TmpGroup.ItemList.Count > 0 then Inc(Result,TmpGroup.ItemList.Count);
    end;
 end;
end;


function  GetInGrpSelectCount(AInstallGroup: PInstallGroup):integer;
var
 I: integer;
begin
 Result:=0;
 if AInstallGroup.ItemList.Count > 0 then begin
     for i:=0 to AInstallGroup.ItemList.Count-1 do if
       PInstallItem(AInstallGroup.ItemList[I])^.Selected then Inc(Result);;
 end;
end;


function  GetInGrpInstallCount(AInstallGroup: PInstallGroup):integer;
var
 I: integer;
begin
 Result:=0;
 if AInstallGroup.ItemList.Count > 0 then begin
     for i:=0 to AInstallGroup.ItemList.Count-1 do if
       PInstallItem(AInstallGroup.ItemList[I])^.Selected and
       PInstallItem(AInstallGroup.ItemList[I])^.Installed then Inc(Result);;
 end;
end;


function  GetUsedGroupCount:integer;
var
 G: integer;
 TmpGroup:PInstallGroup;
begin
 Result:=0;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
     TmpGroup:=GetGroupFromId(G);
     if TmpGroup.ItemList.Count > 0 then Inc(Result);
    end;
 end;
end;


function  GetSelGroupCount:integer;
var
 G: integer;
 TmpGroup:PInstallGroup;
begin
 Result:=0;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
     TmpGroup:=GetGroupFromId(G);
     if GetInGrpSelectCount(TmpGroup) > 0 then Inc(Result);
    end;
 end;
end;


function  GetInstalledGroupCount:integer;
var
 G: integer;
 TmpGroup:PInstallGroup;
begin
 Result:=0;
 if GetGroupCount > 0 then begin
  for G:=0 to  GetGroupCount - 1 do begin
     TmpGroup:=GetGroupFromId(G);
     if (GetInGrpSelectCount(TmpGroup) > 0)and
        (GetInGrpSelectCount(TmpGroup) = GetInGrpInstallCount(TmpGroup)) then Inc(Result);
    end;
 end;
end;

function NewInstallItem(AGroup: PInstallGroup): PInstallItem;
begin
  New(result);
  with result^ do begin
   Parent:=AGroup;
   Number:=0;
   Group:=AGroup^.Group;
   Caption:='';
   Description:='';
   DependsList:=TList.Create;
   ExcludeList:=TList.Create;
   Folder:='';
   SourceFolder:='';
   PreCopyCommand:='';
   PostCopyCommand:='';
   Command1:='';
   Command2:='';
   Command3:='';
   Command4:='';
   Command5:='';
   Command6:='';
   PostRegFile:='';
   PreRegFile:='';
   IconFileName:='';
   IconNumber:=0;
   SkreenShotImage:='';
   ImageId:=3;
   KillWait:=0;
   SelectDefault:=false;
   Fixed:=false;
   Selected:=false;
   Visible:=true;
   RebootNeed:=false;
   Installed:=false;
  end;
end;

function InstallItemAdd(AGroup:PInstallGroup;  AInstallItem: PInstallItem):integer;
begin
  result:=0;
  if (AGroup <> nil) and (AInstallItem <> nil) then begin
     AGroup.ItemList.Add(AInstallItem);
     AInstallItem.Parent:=AGroup;
     AInstallItem.Group:=AGroup^.Group;
     result:=AGroup.ItemList.Count;
  end;
end;

procedure InstallItemDelete(AInstallItem: PInstallItem);
begin
  if (AInstallItem <> nil) and
     (AInstallItem.Parent <> nil) then
      AInstallItem.Parent.ItemList.Remove(AInstallItem);
  AInstallItem.DependsList.Free;
  AInstallItem.ExcludeList.Free;
  Dispose(AInstallItem);
end;

function InstallItemReadFromIni(const Ini: TIniFile; SectionName: string):PInstallItem;
var
 SectionNumber:integer;
 Tmp:string;
 TmpDepends:string;
 TmpExclude:string;


 function GetImageId(AIconFileName, AFolder:string; Number: integer):cardinal;
 var
   FilePach:string;
   AIcon:HIcon;
   TmpImg:TBitmap;
 begin
   if (AIconFileName = '') and
      (CommonIconLib <> '') then begin

      if (SmallIconList <> nil) and
         (Number+IconShift < SmallIconList.Count) then  result:= IconShift + Number
                                                  else  result:= IconShift-1;

    end else begin
     FilePach:='';
     result:=3;
     if AIconFileName <> '' then begin
      if not IsAbcPath(AIconFileName) then begin
         if IsAbcPath(AFolder) then FilePach:=NormaliseAllSlash(ExpandEnvString((AFolder)))
                                   else if (AFolder <> '') then  FilePach:=NormaliseAllSlash(ExpandEnvString(RootInstallDir)) + NormaliseAllSlash(ExpandEnvString(AFolder))
                                     else FilePach:=NormaliseAllSlash(ExpandEnvString(RootInstallDir));
         FilePach:=FilePach+NormaliseFirstSlash(ExpandEnvString(AIconFileName));
      end else FilePach:= NormaliseFirstSlash(ExpandEnvString(AIconFileName));
     end;
     if (AIconFileName <> '') or (Number >= 0) then begin
       AIcon:=GetIconEx(FilePach,Number,true);
       if (AIcon<>0) and (SmallIconList <> nil) then begin
        TmpImg:=TBitmap.Create;
        try
         TmpImg.Height:=SmallIconList.Height;
         TmpImg.Width:= SmallIconList.Width;
         TmpImg.PixelFormat:=pf32bit;
         TmpImg.Canvas.Brush.Color:= IconBackColor;
         TmpImg.Canvas.FillRect(Rect(0,0,TmpImg.Width,TmpImg.Height));
         DrawIconEx(TmpImg.Canvas.Handle,(TmpImg.Width - 16)div 2,(TmpImg.Height - 16)div 2,AIcon, 16, 16, 0, 0, DI_NORMAL);
         result:= SmallIconList.AddMasked(TmpImg,IconBackColor);
        finally
         TmpImg.Free;
        end;
       end;
       DestroyIcon(AIcon);  // Need for prevent GDI Leak
       AIcon:=GetIconEx(FilePach,Number,false);
       if (AIcon<>0) and (BigIconList <> nil) then ImageList_AddIcon(BigIconList.Handle, AIcon);
       DestroyIcon(AIcon);  // Need for prevent GDI Leak
     end;
   end;
 end;

begin
  result:=nil;
  if ini = nil then exit;
  if not Ini.SectionExists(SectionName) then exit;
  if pos('installitem_', SectionName)>-1 then begin
    Tmp:= Copy(SectionName,pos('installitem_', SectionName)+Length('installitem_')+1,3);
    SectionNumber:=StrToIntDef(Tmp,0);
  end else SectionNumber:=0;
  New(result);
  with result^ do begin
   Number:=SectionNumber;
   DependsList:=TList.Create;
   ExcludeList:=TList.Create;
   DefaultInExcludeList:=false;
   Group:=Ini.ReadString(SectionName, 'Group', '');
   Caption:=Ini.ReadString(SectionName, 'Caption', '');
   Description:=Ini.ReadString(SectionName, 'Description', NoDescriptionTitle);
   TmpDepends:=Ini.ReadString(SectionName, 'Depends', '');
   if TmpDepends <> '' then begin
    repeat
      Tmp:=StripFirstWord(TmpDepends);
      if (Tmp <> '') and (Ini.SectionExists(Tmp))then begin
        Tmp:=Copy(Tmp,pos('installitem_', Tmp)+Length('installitem_')+1,3);
        SectionNumber:=StrToIntDef(Tmp,0);
        DependsList.Add(Pointer(SectionNumber));
      end;
    until TmpDepends = '';
   end;
   TmpExclude:=Ini.ReadString(SectionName, 'Exclude', '');
   if TmpExclude <> '' then begin
    repeat
      Tmp:=StripFirstWord(TmpExclude);
      if (Tmp <> '') and (Ini.SectionExists(Tmp))then begin
        Tmp:=Copy(Tmp,pos('installitem_', Tmp)+Length('installitem_')+1,3);
        SectionNumber:=StrToIntDef(Tmp,0);
        ExcludeList.Add(Pointer(SectionNumber));
      end;
    until TmpExclude = '';
   end;
   Folder:=Ini.ReadString(SectionName, 'Folder', '');
   SourceFolder:=Ini.ReadString(SectionName, 'SourceFolder', '');
   PreCopyCommand:=Ini.ReadString(SectionName, 'PreCopyCommand', '');
   PostCopyCommand:=Ini.ReadString(SectionName, 'PostCopyCommand', '');
   IconFileName:=Ini.ReadString(SectionName, 'IconFile', '');
   IconNumber:=Ini.ReadInteger(SectionName, 'IconNumber', -1);
   SkreenShotImage:=Ini.ReadString(SectionName, 'SkreenShotImage', '');
   PreRegFile:=Ini.ReadString(SectionName,  'PreRegFile', '');
   Command1:=Ini.ReadString(SectionName, 'Command1', '');
   Command2:=Ini.ReadString(SectionName, 'Command2', '');
   Command3:=Ini.ReadString(SectionName, 'Command3', '');
   Command4:=Ini.ReadString(SectionName, 'Command4', '');
   Command5:=Ini.ReadString(SectionName, 'Command5', '');
   Command6:=Ini.ReadString(SectionName, 'Command6', '');
   PostRegFile:=Ini.ReadString(SectionName,  'PostRegFile', '');
   KillWait:=Ini.ReadInteger(SectionName, 'KillWait', 0);
   SelectDefault:=Ini.ReadBool(SectionName, 'Default', false);
   Fixed:=Ini.ReadBool(SectionName, 'Fixed', false);
   Visible:=Ini.ReadBool(SectionName, 'Visible', true);
   RebootNeed:=Ini.ReadBool(SectionName, 'RebootNeed', false);
   Selected:=SelectDefault;
   Installed:=false;
   Killed:=false;
   ImageId:=GetImageId(IconFileName, Folder,IconNumber);
   ImageIdBig:= ImageId-IconShift+1;
  end;
end;

function InstallItemWriteToIni (const Ini: TIniFile; InstallItem: PInstallItem):boolean;
var
  Section:string;

  function GetDependsStr:string;
   var N:integer;
  begin
   result:='';
   if InstallItem^.DependsList.Count>0 then
      for N:=0 to InstallItem^.DependsList.Count - 1 do
       begin
         result:=result + SafeFormat('Installitem_%3.3d;',[Integer(InstallItem^.DependsList[N])]);
       end;
  end;

  function GetExcludeStr:string;
   var N:integer;
  begin
   result:='';
   if InstallItem^.ExcludeList.Count>0 then
      for N:=0 to InstallItem^.ExcludeList.Count - 1 do
       begin
         result:=result + SafeFormat('Installitem_%3.3d;',[Integer(InstallItem^.ExcludeList[N])]);
       end;
  end;



begin
  result:=false;
  if (ini = nil) or (InstallItem=nil) then exit;
  with InstallItem^ do begin
   Section:= SafeFormat('Installitem_%3.3d',[Number]);
   Ini.WriteString(Section, 'Group', Group);
   Ini.WriteString(Section, 'Caption', Caption);
   Ini.WriteString(Section, 'Description', Description);
   Ini.WriteString(Section, 'Depends', GetDependsStr);
   Ini.WriteString(Section, 'Exclude', GetExcludeStr);
   Ini.WriteString(Section, 'Folder', Folder);
   Ini.WriteString(Section, 'IconFile', IconFileName);
   Ini.WriteInteger(Section, 'IconNumber', IconNumber);
   Ini.WriteString(Section, 'SkreenShotImage', SkreenShotImage);
   Ini.WriteString(Section, 'PreRegFile', PreRegFile);
   Ini.WriteString(Section, 'Command1', Command1);
   Ini.WriteString(Section, 'Command2', Command2);
   Ini.WriteString(Section, 'Command3', Command3);
   Ini.WriteString(Section, 'Command4', Command4);
   Ini.WriteString(Section, 'Command5', Command5);
   Ini.WriteString(Section, 'Command6', Command6);
   Ini.WriteString(Section, 'PostRegFile', PostRegFile);
   Ini.WriteInteger(Section, 'KillWait', KillWait);
   Ini.WriteBool(Section, 'Default', SelectDefault);
   Ini.WriteBool(Section, 'Fixed', Fixed);
   Ini.WriteBool(Section, 'Visible', Visible);
   Ini.WriteBool(Section, 'RebootNeed', RebootNeed);
  end;
  result:=true;
end;

function InstallItemInstall(Item: PInstallItem): boolean;
  var
   LogSectName:string;
begin
  LogSectName:='Installed_Items';
  if not IsBreak then RegAdd(RootInstallDir, Item^.Folder, Item^.PreRegFile);
  if not IsBreak then RunItem(RootInstallDir, Item^.Folder, Item^.Command1, Item^.KillWait);
  if not IsBreak then RunItem(RootInstallDir, Item^.Folder, Item^.Command2, Item^.KillWait);
  if not IsBreak then RunItem(RootInstallDir, Item^.Folder, Item^.Command3, Item^.KillWait);
  if not IsBreak then RunItem(RootInstallDir, Item^.Folder, Item^.Command4, Item^.KillWait);
  if not IsBreak then RunItem(RootInstallDir, Item^.Folder, Item^.Command5, Item^.KillWait);
  if not IsBreak then RunItem(RootInstallDir, Item^.Folder, Item^.Command6, Item^.KillWait);
  if not IsBreak then RegAdd(RootInstallDir, Item^.Folder, Item^.PostRegFile);
  Item^.Killed:=IsBreak;
  IsBreak :=false;
  result:=true;
  Item^.Installed:=true;
  if Item^.Killed then LogSectName:='Scipped_Items';
  AddLine(InstallList,LogSectName,SafeFormat('installitem_%3.3d',[Item^.Number]));
  if Item^.RebootNeed then begin
    if PeMode then begin
       AddLine(InstallList,'Install_Events',SafeFormat('Items %3.3d sheduled reboot!',[Item^.Number]));
       AddLine(InstallList,'Install_Events','"PE" mode - reboot supressed!');
       WriteLog(' Items sheduled reboot!');
       WriteLog(' Reboot supressed!');
       WriteLog('');
     end else if SupressReboot then begin
       AddLine(InstallList,'Install_Events',SafeFormat('Items %3.3d sheduled reboot!',[Item^.Number]));
       AddLine(InstallList,'Install_Events','Reboot supressed!');
       WriteLog(' Items sheduled reboot!');
       WriteLog(' Reboot supressed!');
       WriteLog('');
    end else begin
       AddLine(InstallList,'Install_Events',SafeFormat('Items %3.3d sheduled reboot!',[Item^.Number]));
       WriteLog(' Items sheduled reboot!');
       WriteLog('');
       RebootSheduled:=true;
    end;
  end;
  try
   InstallList.SaveToFile(GetInstallLog);
  except
  end;
end;

function ValidateConfig(filename:string):boolean;
begin
 result:=false;
 if not FileExists(FileName) then exit;
 result:=true;
 if CheckCmdParam('nocrc') then exit;
 with TIniFile.Create(FileName) do
  try
    result:=result and (SetVer = ReadString('Common_Info','Ver',''));
    result:=result and (SetCRC = StrToInt64Def(ReadString('Common_Info','CRC',''),0));
  finally
   free;
  end;
end;

function LoadConfig(filename:string):boolean;
var
  G, I:integer;
  ItemName:string;
  SectTmp:TStringList;
begin
  result:=false;
  ConfigList.Clear;
  if not FileExists(filename) then exit;
  ConfigList.LoadFromFile(filename);
  SectTmp:=TStringList.Create;
  try
   GetSectionContent('Selected_Items',ConfigList,SectTmp);
   if SectTmp.Count > 0 then begin
    for G:=0 to GroupList.Count -1 do
    if PInstallGroup(GroupList[G]).ItemList.Count > 0 then
     for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
      ItemName:=SafeFormat('installitem_%3.3d',[PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number]);
      PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:=SectTmp.IndexOf(ItemName)>-1;
     end;
     result:=true;
    end;
  finally
    SectTmp.Free;
  end;
  RecheckAllgroup;
end;

function SaveConfig(filename:string):boolean;
var
  G, I:integer;
  ItemNumber:integer;
begin
  result:=false;
  ConfigList.Clear;
  ConfigList.Add('; +++++++++++++++++++++++++++++++++++++++++');
  ConfigList.Add('; BS Post Installer answers file  V'+SetVer);
  ConfigList.Add('; this text auto generated');
  ConfigList.Add('; Do not modify manually!!!');
  ConfigList.Add('; +++++++++++++++++++++++++++++++++++++++++');
  ConfigList.Add('');
  ConfigList.Add('[Common_Info]');
  ConfigList.Add('Ver='+SetVer);
  ConfigList.Add('Autor='+SetAutor);
  ConfigList.Add('Date='+DateToStr(now));
  ConfigList.Add('CRC='+IntToStr(SetCRC));
  ConfigList.Add('');
  ConfigList.Add('[Selected_Items]');
  for G:=0 to GroupList.Count -1 do
  if PInstallGroup(GroupList[G]).ItemList.Count > 0 then
   for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
    if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Selected then begin
     result:=true;
     ItemNumber:=PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number;
     AddLine(ConfigList,'Selected_Items',SafeFormat('installitem_%3.3d',[ItemNumber]));
    end
   end;
   ConfigList.SaveToFile(filename);
end;

function LogSelectedItems:boolean;
var
  G, I:integer;
  ItemNumber:integer;
begin
  result:=false;
  ClearSection('Selected_Items',InstallList);
  for G:=0 to GroupList.Count -1 do
  if PInstallGroup(GroupList[G]).ItemList.Count > 0 then
   for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
    if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Selected then begin
     result:=true;
     ItemNumber:=PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number;
     AddLine(InstallList,'Selected_Items',SafeFormat('installitem_%3.3d',[ItemNumber]));
    end
   end;
end;

function GetInstallLog:string;
begin
 result:=NormaliseAllSlash(GetTempDir)+InstallLog;
end;

function CheckInstallLog:boolean;
begin
  result:= FileExists(GetInstallLog);
  if result then
  with TIniFile.Create(GetInstallLog) do
  try
    result:=result and (SetVer = ReadString('Common_Info','Ver',''));
    result:=result and (UpperCase(MainIni) = UpperCase(ReadString('Common_Info','ConfigFile','')));
    if not CheckCmdParam('nocrc') then  result:=result and (SetCRC = StrToInt64Def(ReadString('Common_Info','CRC',''),0));
  finally
   free;
  end;
end;

function  GetLastMainIni: string;
var
 LastMainIni:string;
begin
 result:='';
 if FileExists(GetInstallLog) then
  with TIniFile.Create(GetInstallLog) do
  try
    if (SetVer = ReadString('Common_Info','Ver','')) then
    LastMainIni:= ReadString('Common_Info','ConfigFile','');
    if FileExists(LastMainIni) then
     if not CheckCmdParam('nocrc') then  begin
        if (CalcCRC(LastMainIni) = StrToInt64Def(ReadString('Common_Info','CRC',''),0)) then result:= LastMainIni;
     end else  result:= LastMainIni;
  finally
   free;
  end;
end;

procedure DeleteInstallLog;
begin
 if FileExists(GetInstallLog) then DeleteFile(GetInstallLog);
end;

function LoadInstallLog:boolean;
var
  G, I:integer;
  ItemName:string;
  Found:boolean;
  SectTmp:TStringList;
begin
  result:=false;
  if not CheckInstallLog then exit;
  InstallList.Clear;
  InstallList.LoadFromFile(GetInstallLog);
  SectTmp:=TStringList.Create;
   try
   TestMode:= InstallList.Values['IsTest'] = '1';
   GetSectionContent('Selected_Items',InstallList,SectTmp);
   if SectTmp.Count > 0 then
    for G:=0 to GroupList.Count -1 do
    if PInstallGroup(GroupList[G]).ItemList.Count > 0 then
     for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
      ItemName:=SafeFormat('installitem_%3.3d',[PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number]);
      Found:=SectTmp.IndexOf(ItemName)>-1;
      PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:=Found;
     end;
   GetSectionContent('Installed_Items',InstallList,SectTmp);
   if SectTmp.Count > 0 then
    for G:=0 to GroupList.Count -1 do
    if PInstallGroup(GroupList[G]).ItemList.Count > 0 then
     for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
       ItemName:=SafeFormat('installitem_%3.3d',[PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Number]);
       Found:=SectTmp.IndexOf(ItemName)>-1;
       if found then begin
          PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Selected:=true;
          PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i])^.Installed:=true;
       end;
     end;
   finally
    SectTmp.Free;
   end;
   RecheckAllgroup;
   AddLine(InstallList,'Install_Events','Installation process restarting');
   result:=true;
end;

procedure ReloadLog;
begin
  WriteLog('Installation process restarting at: '+TimeToStr(Now));
  if TestMode and not CheckCmdParam('rest') then begin
   WriteLog('');
   WriteLog('Warning! Test mode.');
   WriteLog('Not really install! Simulated only!');
   WriteLog('');
  end;
end;


procedure HideRunOnce;
var
 Reg:TRegistry;
 RunOnceTitle:string;
begin
  Reg:=TRegistry.Create;
  Reg.RootKey:=HKEY_LOCAL_MACHINE;
  Reg.OpenKey(RunOnce,false);
  RunOnceTitle:=Reg.ReadString('TITLE');
  Reg.CloseKey;
  Reg.Free;
  if RunOnceTitle <> '' then
  RunOnceHandle:=FindWindow(nil,PChar(RunOnceTitle));
  if RunOnceHandle<> 0 then
  ShowWindow(RunOnceHandle, SW_HIDE);
end;

procedure ShowRunOnce;
begin
  if RunOnceHandle<> 0 then
  ShowWindow(RunOnceHandle, SW_SHOW);
end;

procedure CleanRun;
var
 Reg:TRegistry;
begin
   Reg:=TRegistry.Create;
   try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey(Run,false) then
       if Reg.ValueExists(RunValyeName) then Reg.DeleteValue(RunValyeName)
   finally
     Reg.CloseKey;
     Reg.Free;
   end;
end;

procedure AddRunOnce;
var
 Reg:TRegistry;
 Param:string;
begin
  Param:='rest ini:' + MainIni;
  if CheckCmdParam('nocrc') then Param:= Param + ' nocrc';
  if TestMode then Param:= Param + ' test nomutex';
  if CheckCmdParam('force') then Param:= Param + ' force';
  Param:= Param + ' W:'+ WStr + ' H:' + HStr + ' L:' +  LStr + ' T:' + TStr;
  if TestMode then begin
     ShellExecute(Application.Handle,'open',PChar(Application.ExeName),PChar(Param),PChar(ExtractFileDir(PChar(Application.ExeName))),SW_SHOW);
  end
  else begin
    Reg:=TRegistry.Create;
    try
     Reg.RootKey:=HKEY_LOCAL_MACHINE;
     if UseRunKey then begin
      Reg.OpenKey(Run,true);
      Reg.WriteString(RunValyeName,Application.ExeName + ' ' + Param);
     end else begin
      Reg.OpenKey(RunOnce,true);
      Reg.WriteString('TITLE',RunOnceTitle);
      Reg.OpenKey(RunOnce + '\'+ RunOnceSubKey, true);
      Reg.WriteString('',RunOnceItemTitle);
      Reg.WriteString('1',Application.ExeName + ' ' + Param);
     end;
    finally
     Reg.CloseKey;
     Reg.Free;
    end;
  end;
end;

function DelToLf(Text:string):string;
const
  LF  = #13#10;
  Del = '|';
begin
  Result:=AnsiReplaceStr(Text,Del,LF);
end;

{Additional function - to future use}

function ClearDir(const Path: string; Delete: Boolean): Boolean;
const
  FileNotFound = 18;

var
  FileInfo: TSearchRec;
  DosCode: Integer;
begin
  Result := DirectoryExists(Path);
  if not Result then Exit;
  try
  DosCode := FindFirst(NormaliseAllSlash(Path) + '*.*', faAnyFile, FileInfo);
  try
    while DosCode = 0 do begin
      if (FileInfo.Name[1] <> '.') and (FileInfo.Attr <> faVolumeID) then
      begin
        if (FileInfo.Attr and faDirectory = faDirectory) then
          Result := ClearDir(NormaliseAllSlash(Path) + FileInfo.Name, Delete) and Result
        else if (FileInfo.Attr and faVolumeID <> faVolumeID) then begin
          if (FileInfo.Attr and faReadOnly = faReadOnly) then
            FileSetAttr(NormaliseAllSlash(Path) + FileInfo.Name, faArchive);
          Result := DeleteFile(NormaliseAllSlash(Path) + FileInfo.Name) and Result;
        end;
      end;
      DosCode := FindNext(FileInfo);
    end;
  finally
    FindClose(FileInfo);
  end;
  if Delete and Result and (DosCode = FileNotFound) and
    not ((Length(Path) = 2) and (Path[2] = ':')) then
  begin
    FileSetAttr(Path, faArchive);
    RemoveDirectory(PChar(Path));
    Result := (IOResult = 0) and Result;
  end;
  except
    Result:=false;
  end;
end;

function CopyDir (Source, Destination:string; ParentWnd: hwnd; Silent:boolean):boolean;
var
  SHFStruct: TSHFileOpStruct;

  function AllocFileStr(const S: string): PChar;
  var
    P: PChar;
  begin
    Result := nil;
    if S <> '' then begin
      Result := StrCopy(StrAlloc(Length(S) + 2), PChar(S));
      P := Result;
      while P^ <> #0 do begin
        if (P^ = ';') or (P^ = '|') then P^ := #0;
        Inc(P);
      end;
      Inc(P);
      P^ := #0;
    end;
  end;

begin
  FillChar(SHFStruct,SizeOf(TSHFileOpStruct),0);
  with SHFStruct do begin
    Wnd:=ParentWnd;
    wFunc:=FO_COPY;
    fFlags:=FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR or FOF_NOERRORUI ;
    if silent then fFlags:=fFlags or FOF_SILENT;
    pFrom:=AllocFileStr(ExpandEnvString(Source));
    pTo:=AllocFileStr(ExpandEnvString(Destination));
    try
      result:=(SHFileOperation(SHFStruct)=0) and (not SHFStruct.fAnyOperationsAborted);
    finally
      if pFrom <> nil then StrDispose(pFrom);
      if pTo <> nil then StrDispose(pTo);
      if SHFStruct.fAnyOperationsAborted then Abort;
    end;
  end;
end;

function CopyCommand(Command, Root, DestFolder:string; ParentWnd: hwnd; Silent:boolean):boolean;
var
 CmdLine:string;
 CmdParam:string;
 DestItemFolder:string;
begin
  result:= false;
  if Command <> '' then begin
     ParseCommandLine(NormaliseFirstSlash(ExpandEnvString(Command)), CmdLine, CmdParam);
     if Command[1]<>'|' then  CmdLine:= NormaliseAllSlash(ExpandEnvString(Root))  + CmdLine;
   end else exit;

  DestItemFolder:= NormaliseAllSlash(DestFolder)+ ExtractRelativePath(NormaliseAllSlash(ExpandEnvString(Root)),CmdLine);
  DestItemFolder:=ExtractFilePath(DestItemFolder);
  if Fileexists(CmdLine) then begin
     ForceDirectories(DestItemFolder);
     result:= CopyDir(CmdLine,DestItemFolder, ParentWnd, Silent);
  end;
end;

function CopyItem(Item: PInstallItem; Root, DestFolder:string; ParentWnd: hwnd; Silent:boolean):boolean;
var
 ProgrammFolder:string;
 DestItemFolder:string;
begin
  result:=false;

  if (Item.Folder <> '') and
     (Item.Folder[1]='|') then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString((Item.Folder)))
                          else if (Item.Folder <> '')
                               then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(Root)) + ExpandEnvString(Item.Folder)
                               else begin
                                     if Item.PreRegFile <> '' then   CopyCommand(Item.PreRegFile, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.Command1 <> '' then   CopyCommand(Item.Command1, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.Command2 <> '' then   CopyCommand(Item.Command2, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.Command3 <> '' then   CopyCommand(Item.Command3, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.Command4 <> '' then   CopyCommand(Item.Command4, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.Command5 <> '' then   CopyCommand(Item.Command6, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.Command6 <> '' then   CopyCommand(Item.Command6, Root, DestFolder ,ParentWnd, Silent);
                                     if Item.PostRegFile <> '' then   CopyCommand(Item.PostRegFile, Root, DestFolder ,ParentWnd, Silent);
                                    end;
  DestItemFolder:= NormaliseAllSlash(DestFolder)+ ExtractRelativePath(NormaliseAllSlash(ExpandEnvString(Root)),NormaliseAllSlash(ProgrammFolder));
  if (Item.SourceFolder <> '') and
     (Item.SourceFolder[1]='|') then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString((Item.SourceFolder)))
                                else if (Item.SourceFolder <> '')
                                     then ProgrammFolder:=NormaliseAllSlash(ExpandEnvString(Root)) + ExpandEnvString(Item.SourceFolder);
  if DirectoryExists(NormaliseAllSlash(ProgrammFolder)) then begin
     ForceDirectories(DestItemFolder);
     result:= CopyDir(NormaliseAllSlash(ProgrammFolder)+'*.*',DestItemFolder,ParentWnd, Silent);
  end;
end;



function CopySet(SourceDir, DestDir:string; OnlySelected:boolean; ParentWnd: hwnd; Silent:boolean):boolean;
var
  G, I:integer;
  RootFolder: string;

begin
  result:=false;
  GetSelfFolder;
  GetSourceDrive;

  if SourceDir<> '' then RootFolder:= SourceDir
                    else RootFolder:= RootInstallDir;
                    
  if not DirectoryExists(RootFolder) then exit;
  for G:=0 to GroupList.Count -1 do
  if PInstallGroup(GroupList[G]).ItemList.Count > 0 then
   for i:=0 to PInstallGroup(GroupList[G])^.ItemList.Count-1 do begin
    if PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]).Selected then begin
     CopyItem(PInstallItem(PInstallGroup(GroupList[G])^.ItemList[i]), RootFolder,DestDir, ParentWnd, Silent);
    end
   end;

   if BeforePreRegFile <> '' then CopyCommand(BeforePreRegFile, RootFolder, DestDir ,ParentWnd, Silent);
   if BeforePostRegFile <> '' then CopyCommand(BeforePostRegFile, RootFolder, DestDir ,ParentWnd, Silent);
   if AfterPreRegFile <> '' then CopyCommand(AfterPreRegFile, RootFolder, DestDir ,ParentWnd, Silent);
   if AfterPostRegFile <> '' then CopyCommand(AfterPostRegFile, RootFolder, DestDir ,ParentWnd, Silent);
   for i:=0 to 3 do if  PreCommand[i]<>'' then CopyCommand(PreCommand[i], RootFolder, DestDir ,ParentWnd, Silent);
   for i:=0 to 3 do if  PostCommand[i]<>'' then CopyCommand(PostCommand[i], RootFolder, DestDir ,ParentWnd, Silent);

   result:=true;
end;

end.
