{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }

unit LogEngine;

interface


uses
 Windows, Classes;

procedure OpenLog(LogFileName:string; PrgMsg: string; LogReWrite: boolean);
procedure WriteLog(LogMsg:string);
procedure WriteLogTime(LogMsg:string);
procedure CloseLog(EndLog:boolean);


implementation

uses
 Messages, SysUtils;

var
 LogF: TextFile;
 LogEvents: Boolean = false;
 FLock: TRTLCriticalSection;

function logLine(Txt:string):string;
begin
  result:= '['+DateToStr(now) + ',' + TimeToStr(now)+ ']' + ' ' +Txt
end;

procedure OpenLog(LogFileName:string; PrgMsg: string; LogReWrite: boolean);
var
  NewLog:boolean;
begin
 InitializeCriticalSection(FLock);
 if LogFileName = '' then exit;
 {$I-}
 Newlog:= LogReWrite;
 AssignFile(LogF, LogFileName);
 if not FileExists(LogFileName) then begin
                                       Rewrite(LogF);
                                       NewLog:=true;
                                     end  
                                else if LogReWrite then Rewrite(LogF)
                                                   else Append(LogF);
 if Newlog then begin
  Rewrite(LogF);
  Writeln(LogF, PrgMsg);
  Writeln(LogF, '');
  Writeln(LogF, '*** Log startet at: '+ DateToStr(Now)+ ' '+ TimeToStr(Now)+' ******************************************');
  Writeln(LogF, '');
 end else begin
  Writeln(LogF, '*** Log restartet at: '+ DateToStr(Now)+ ' '+ TimeToStr(Now)+' *****************************************');
  Writeln(LogF, '');
 end;
 LogEvents:= (IOResult = 0);
 {$I+}
end;

procedure WriteLogTime(LogMsg:string);
begin
 if not LogEvents then exit;
 EnterCriticalSection(FLock);
 {$I-}
  Writeln(LogF,  logLine(LogMsg));
 {$I+}
 LeaveCriticalSection(FLock);
end;

procedure WriteLog(LogMsg:string);
begin
 if not LogEvents then exit;
 EnterCriticalSection(FLock);
 {$I-}
  Writeln(LogF, LogMsg);
  Flush(LogF);
 {$I+}
 LeaveCriticalSection(FLock);
end;


procedure CloseLog(EndLog:boolean);
begin
 if LogEvents then begin
 EnterCriticalSection(FLock);
 {$I-}
 if EndLog then  begin
   Writeln(LogF, '');
   Writeln(LogF, '*** Log end at: '+ DateToStr(Now)+ ' '+ TimeToStr(Now)+ ' **********************************************');
   Writeln(LogF, 'EOF');
 end;
 LogEvents:=false;
 Flush(LogF);
 CloseFile(LogF);
 {$I+}
 LeaveCriticalSection(FLock);
 end;
 DeleteCriticalSection(FLock);
end;



end.
