{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }

unit NewProcess;

interface
                   
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ImgList, StdCtrls, CommonCtrl, ComCtrls, CommCtrl, Menus,
  GlobalConst, midi;

type

  TInstallState = (isStartup, isWelcome, isWait, isLicenseConfirm, isSelectProg, isPrepare, isPreInstall, isInstallProg, isPostInstall, isReboot, isFinish );

  TStageLabels = (slSelect, slPrepare, slInstall, slCleanup, slFinish);

  TNewProcessFm = class(TForm)

    RebootTimer: TTimer;
    StartDelayTimer: TTimer;
    StartDefautInstallTimer: TTimer;
    TrayTimer: TTimer;
    SelectTreeImg: TImageList;
    SelectTreeStateImg: TImageList;
    TrayIconImageList: TImageList;
    TrayImg: TImageList;
    BigImg: TImageList;

    TrayMenu: TPopupMenu;
    RestoreMi: TMenuItem;
    ScipMi: TMenuItem;
    N3: TMenuItem;
    HelpMi: TMenuItem;
    AboutMi: TMenuItem;
    N6: TMenuItem;
    CloseMi: TMenuItem;
    Wallpapers: TImage;
    LeftMargin: TImage;
    procedure FormCreate(Sender: TObject);
    procedure RebootTimerTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StartDelayTimerTimer(Sender: TObject);
    procedure TrayMenuClick(Sender: TObject);
    procedure StartDefautInstallTimerTimer(Sender: TObject);
    procedure MiMeasureItem(Sender: TObject; ACanvas: TCanvas;
      var Width, Height: Integer);
    procedure TrayTimerTimer(Sender: TObject);
    procedure ScipBtClick(Sender: TObject);
    procedure HelpClick(Sender: TObject);
    procedure CopyRightLabelClick(Sender: TObject);
    procedure CloseClick(Sender: TObject);
    procedure TopLogoMouseDown(Sender: TObject;
                               Button: TMouseButton;
                               Shift: TShiftState;
                               X, Y: Integer);
    procedure TopLogoMouseMove(Sender: TObject;
                               Shift: TShiftState;
                               X, Y: Integer);
    procedure TopLogoMouseUp(Sender: TObject;
                             Button: TMouseButton;
                             Shift: TShiftState;
                             X, Y: Integer);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure SelectProgMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SelectProgMemoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrayMenuDrawItem(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; State: TOwnerDrawState);

  private
    { Private declarations }
    LeftLabels: array [0..4] of TCheckLabel;
    ItemImage: TImage;
    MyLogo: TImage;
    ScrShot: TCoolImage;
    GrpLabel: TLabel;
    AllLabel: TLabel;
    MemoLabel2: TLabel;
    DeskriptionLabel: TLabel;
    MemoLabel1: TLabel;
    RebootMsgLabel: TLabel;
    CopyRightLabel: TUrlLabel;
    TimerCaption: TLabel;
    TestModeLabel: TLabel;
    TestTrialModeLabel: TLabel;
    CaptionLabel:TShadowLabel;
    TimerMsg:TShadowLabel;
    GrpPrBar: TMyProgress;
    AllPrBar: TMyProgress;
    RebootPrBar: TMyProgress;
    ProgressImg :TProgressImage;
    InstallState: TInstallState;
    SelectProgTree: TTreeView;
    SelectProgMemo: TSmartMemo;
    CheckAllBt: TCoolButton;
    CheckNoneBt: TCoolButton;
    CheckDefBt: TCoolButton;
    CheckRebootBt: TCoolButton;
    CheckPoweroffBt: TCoolButton;
    CheckCloseBt: TCoolButton;
    FastSelectLabel: TLabel;
    CloseBt : TCoolButton;
    HelpBt  : TCoolButton;
    TrayBt :  TCoolButton;
    NoRebootBt: TCoolButton;
    ScipBt: TCoolButton;
    NextBt: TCoolButton;
    UserFuncButton: array [1..3] of TCoolButton;
    PrevBt: TCoolButton;
    FinishBt: TCoolButton;
    ExpandBt: TCoolButton;
    CollapseBt: TCoolButton;
    LicConfirmBt: TCoolButton;
    StartinstallDelay:integer;
    TrayStage: byte;
    HelpIndex: integer;
    Moving:boolean;
    OldLeft:integer;
    OldTop:integer;
    MidiPlay: TUMidi;
    procedure WMEraseBkgnd(var m: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMSysCommand(var m: TWMSysCommand); message WM_SYSCOMMAND;
    procedure InitControls;
    procedure ResizeControls;
    procedure WriteControlPos(IniFileName:string; Section:string);
    procedure ReadControlPos(IniFileName:string; Section:string);
    procedure SelectProgTreeClick(Sender: TObject);
    procedure SelectProgTreeExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure SelectProgTreeCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure SelectProgTreeExpanded(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeCollapsed(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SelectProgTreeKeyPress(Sender: TObject; var Key: Char);
    procedure SelectProgTreeCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure LicConfirmBtClick(Sender: TObject);
    procedure FinishClick(Sender: TObject);
    procedure TrayClick(Sender: TObject);
    procedure NavigateClick(Sender: TObject);
    procedure UserFuncClick(Sender: TObject);
    procedure CheckSelectClick(Sender: TObject);
    procedure CheckFinishModeClick(Sender: TObject);
    procedure NoRebootClick(Sender: TObject);
    procedure ExpandClick(Sender: TObject);
    procedure CollapseClick(Sender: TObject);
    procedure BeginUpdate;
    procedure EndUpdate;
    procedure DrawAnimation(fMinimise:boolean);
    procedure AppMessage(var Message: TMessage);
    procedure ApplicationHook(var Message: TMessage);
    procedure SendCancelMode;
    procedure  TrayMenuPopup(X, Y: Integer);
    procedure SetTrayIcon;
    procedure ModifyTrayIcon(Stage:byte);
    procedure DeleteTrayIcon;
    procedure NodeStateChange(Node:TTreeNode);
    procedure SetInstallState(State: TInstallState);
    procedure PrepareUserButton;
    procedure BlockUserInput(InputState: boolean);
    procedure ShowWelcome(ShowState: boolean);
    procedure ShowWait(ShowState: boolean);
    procedure EndWait;
    procedure ShowLicense(ShowState: boolean);
    procedure ShowSelector(ShowState: boolean);
    procedure ShowPrepare(ShowState: boolean);
    procedure ShowPreInstall(ShowState: boolean);
    procedure ShowInstall(ShowState: boolean);
    procedure ShowPostInstall(ShowState: boolean);
    procedure ShowReboot(ShowState: boolean);
    procedure ShowFinish(ShowState: boolean);
    procedure StartupProc;
    procedure PreInstallProc;
    procedure InstallProc;
    procedure PostInstallProc;
  public
    { Public declarations }
  end;

var
  NewProcessFm: TNewProcessFm;


 var
   EndInstallProcess: boolean = false;
   RestartInstall: boolean = false;
   FullScreenMode: boolean = false;
   LicenseCheckNeedet: boolean = false;


implementation

uses
 CommonProc, ShellApi, Hints, IniFiles, StrUtils, LogEngine, Jpeg;


{$R *.dfm}

var
  OldWndProc : Pointer;
  NewWndProc : Pointer;
  TaskbarRestarted: integer;
  TrayPresent: boolean = false;

  XUnit, YUnit: extended;
  LeftPaneWidth: integer;
  RightPaneWidth: integer;
  XSpacer, YSpacer: integer;
  TopMargin,BottomMargin: Integer;
  FirstGroupClick: boolean = false;

const
   WM_TRAYMSG = WM_USER  + 805;

procedure TNewProcessFm.BeginUpdate;
begin
 //SendMessage(Self.Handle, WM_SETREDRAW, 0, 0);
end;

procedure TNewProcessFm.EndUpdate;
 //r
//I:integer;
begin
 {SendMessage(Self.Handle, WM_SETREDRAW,1, 0);
 for i:=0 to self.ControlCount-1 do if Self.Controls[i].Visible then begin
  if Self.Controls[i] is TWinControl
    then SendMessage(TWinControl(Self.Controls[i]).Handle, WM_SETREDRAW,1, 0)
    else Self.Controls[i].Refresh;
 end;
 //Self.Update;}
 //delay(10);
end;

procedure TNewProcessFm.DrawAnimation(fMinimise:boolean);
var
 R:TRect;
 hTaskBar:HWND;
 hTray:HWND;
begin
  if fMinimise then Hide;
     hTaskBar:=findWindowEx(GetDesktopWindow, 0, 'Shell_TrayWnd', nil);
     hTray:=findWindowEx(hTaskBar, 0, 'TrayNotifyWnd', nil);
     GetWindowRect(hTray,R);
  if fMinimise then begin
     DrawAnimatedRects(handle, IDANI_CAPTION, boundsRect, R);
     RestoreMi.Caption:=RestoreMiCaptionUp;
     if StayOnTop and FullScreenMode then begin
      hTaskBar:= FindWindow('Shell_TrayWnd','');
      ShowWindow(hTaskBar, SW_SHOW);
     end;
  end else begin
     RestoreMi.Caption:=RestoreMiCaptionDown;
     DrawAnimatedRects(handle, IDANI_CAPTION, R, boundsRect);
     if StayOnTop and FullScreenMode then begin
      hTaskBar:= FindWindow('Shell_TrayWnd','');
      ShowWindow(hTaskBar, SW_HIDE);
     end;
     Show;
     Application.BringToFront;
  end;
end;


procedure TNewProcessFm.SetTrayIcon;
var
  SIData:TNotifyIconData;
begin
   SIData.cbSize:=SizeOf(TNotifyIconData);
   SIData.Wnd:=NewProcessFm.Handle;
   SIData.uID:=2366;
   SIData.uFlags:= NIF_MESSAGE or
                   NIF_ICON or
                   NIF_TIP;
   SIData.uCallbackMessage:=WM_TrayMsg;
   SIData.hIcon:=ImageList_GetIcon(TrayIconImageList.Handle,TrayStage,ILD_NORMAL);
   StrPCopy(SIData.szTip,TrayTip);
   Shell_NotifyIcon(NIM_ADD, @SIData);
   DestroyIcon(SIData.hIcon); // Fix big GDI Leak !!!
end;

procedure TNewProcessFm.ModifyTrayIcon(Stage:byte);
var
  SIData:TNotifyIconData;
begin
   SIData.cbSize:=SizeOf(TNotifyIconData);
   SIData.Wnd:=NewProcessFm.Handle;
   SIData.uID:=2366;
   SIData.uFlags:= NIF_ICON or
                   NIF_TIP;
   SIData.hIcon:=ImageList_GetIcon(TrayIconImageList.Handle,Stage,ILD_NORMAL);
   StrPCopy(SIData.szTip,TrayTip);
   Shell_NotifyIcon(NIM_MODIFY, @SIData);
   DestroyIcon(SIData.hIcon); // Fix big GDI Leak !!!
end;

procedure TNewProcessFm.DeleteTrayIcon;
var
  SIData:TNotifyIconData;
begin
  SIData.cbSize:=SizeOf(TNotifyIconData);
  SIData.Wnd:=NewProcessFm.Handle;
  SIData.uID:=2366;
  Shell_NotifyIcon(NIM_DELETE, @SIData);
  TrayTimer.Enabled:=false;
end;

procedure SwitchToWindow(Wnd: HWnd; Restore: Boolean);
begin
  if IsWindowEnabled(Wnd) then begin
    SetForegroundWindow(Wnd);
    if Restore and IsWindowVisible(Wnd) then begin
      if not IsZoomed(Wnd) then
        SendMessage(Wnd, WM_SYSCOMMAND, SC_RESTORE, 0);
      SetFocus(Wnd);
    end;
  end;
end;

procedure TNewProcessFm.SendCancelMode;
var
  F: TForm;
begin
    F := Screen.ActiveForm;
    if F = nil then F := Application.MainForm;
    if F <> nil then F.SendCancelMode(nil);
end;

procedure TNewProcessFm.TrayMenuPopup(X, Y: Integer);
begin
  TrayMenu.PopupComponent := Self;
  SendCancelMode;
  SwitchToWindow(Handle, False);
  Application.ProcessMessages;
  try
      TrayMenu.Popup(X, Y);
  finally
      SwitchToWindow(Handle, False);
  end;
end;

procedure TNewProcessFm.AppMessage(var Message: TMessage);
var
  MPos:TPoint;

begin
  case Message.Msg of
    WM_TRAYMSG: if TrayPresent then
      case Message.LParam of
        WM_LBUTTONDBLCLK: begin
            if not visible then DrawAnimation(false)
                           else Application.BringToFront;
          end;
        WM_RBUTTONDOWN: begin
            GetCursorPos(MPos);
            TrayMenuPopup(MPos.x,Mpos.Y);
          end;
        else
          WndProc(Message);
        end
     else WndProc(Message);
    WM_SYSCOMMAND: begin
        if(message.wParam = SC_CLOSE) and TrayPresent
              then DrawAnimation(true)
              else WndProc(Message);
     end;
    WM_KEYFIRST..WM_KEYLAST,
    WM_LBUTTONDOWN..WM_MBUTTONDBLCLK,
    WM_NCLBUTTONDOWN..WM_NCXBUTTONDBLCLK: begin
        if (InstallState = isWait) and
            StartDefautInstallTimer.Enabled then EndWait;
        WndProc(Message);
     end;
  else
    WndProc(Message);
  end;
end;

procedure TNewProcessFm.ApplicationHook(var Message: TMessage);

  procedure CallOldProc(var Message: TMessage);
  begin
   with Message do
    Result := CallWindowProc(OldWndProc, Application.Handle, Msg, wParam, lParam);
  end;

begin
  if Message.Msg = TaskbarRestarted then begin
       DeleteTrayIcon;
       delay(10);
       SetTrayIcon;
     end
   else
   if Message.Msg = WM_SYSCOMMAND then  begin
        if message.wParam = SC_CLOSE
              then DrawAnimation(true)
              else WndProc(Message);
     end
   else CallOldProc(Message);
end;

procedure TNewProcessFm.WMEraseBkgnd(var m : TWMEraseBkgnd);
begin
 m.Result := 0;
end;

procedure TNewProcessFm.WMSysCommand(var m: TWMSysCommand);
begin
  if m.CmdType = SC_CLOSE	then m.Result:= 0;
end;


procedure TNewProcessFm.TopLogoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and
     (Y < TopMargin) and
     (X < TrayBt.Left) and
     Movable then begin
      SetCapture(NewProcessFm.Handle);
      OldLeft := X;
      OldTop := Y;
      Screen.Cursor:=crSizeAll;
      Moving := True;
  end;
end;

procedure TNewProcessFm.TopLogoMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if Moving then begin
     NewProcessFm.SetBounds(NewProcessFm.Left+X-OldLeft,
                            NewProcessFm.Top+Y-OldTop,
                            NewProcessFm.Width,
                            NewProcessFm.Height);
  end else begin
     if (Y < TopMargin) and
        (X < TrayBt.Left - 5) and
        Movable then Screen.Cursor:=crDrag
                else Screen.Cursor:=crDefault;
  end;
end;

procedure TNewProcessFm.TopLogoMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and Moving and Movable then begin
    ReleaseCapture;
    if (NewProcessFm.Left <> NewProcessFm.Left+X+OldLeft) or
       (NewProcessFm.Top <> NewProcessFm.Top+Y-OldTop) then
         NewProcessFm.SetBounds(NewProcessFm.Left+X-OldLeft,
                            NewProcessFm.Top+Y-OldTop,
                            NewProcessFm.Width,
                            NewProcessFm.Height);
    Screen.Cursor:=crDefault;
    Moving := False;
  end;
end;


procedure TNewProcessFm.ResizeControls;
var
 I:integer;
 LabelTop:integer;
 LabelShpacer:integer;
 Labelleft:integer;
 LabelFontSize:integer;
 ProgressHeight: integer;
 FormWidth, FormHeight: integer;
 MaxBtHeight: integer;
 ResImg:TBitmap;
 ControlSecktion: string;

begin
   FormWidth:= NewProcessFm.Width;
   FormHeight:= NewProcessFm.Height;
   XUnit:= NewProcessFm.Width / 400;
   YUnit:= NewProcessFm.Height / 300;
   XSpacer:=Round(XUnit * 12);
   YSpacer:=Round(YUnit * 10);
   TopMargin:=Round(YUnit * 21);;
   BottomMargin:= Round(YUnit * 21);;
   LeftPaneWidth:= Round(XUnit * 112);
   RightPaneWidth:=NewProcessFm.Width - LeftPaneWidth;
   LabelTop:= TopMargin + YSpacer;
   LabelShpacer:= Round(YUnit * 10);
   Labelleft:= Round(XUnit * 21);
   ProgressHeight:=Round(YUnit*6);

   if YUnit > 3 then begin
     if FileExists(SkinFolder+ LOGO_1024) then
     MyLogo.Picture.Bitmap.LoadFromFile(SkinFolder+ LOGO_1024);
     LabelFontSize:=13;
   end else if YUnit > 2.4 then begin
     if FileExists(SkinFolder+ LOGO_1024) then
     MyLogo.Picture.Bitmap.LoadFromFile(SkinFolder+ LOGO_1024);
     LabelFontSize:=12;
   end else if  YUnit > 1.9 then begin
     if FileExists(SkinFolder+ LOGO_800) then
     MyLogo.Picture.Bitmap.LoadFromFile(SkinFolder+ LOGO_800);
     LabelFontSize:=10;
   end else begin
     if FileExists(SkinFolder+LOGO_640) then
     MyLogo.Picture.Bitmap.LoadFromFile(SkinFolder+ LOGO_640);
     LabelFontSize:=8;
   end;

   ControlSecktion:='Param_' + IntTostr(FormWidth)  +'x'+ IntTostr(FormHeight);

  {Top pane control}

   with MyLogo do begin
    Top:=(TopMargin - MyLogo.Height) div 2;
    Left:= XSpacer;
   end;

   with  TestModeLabel do begin
    Font.Size:= LabelFontSize;
    Left:=LeftPaneWidth;
    Top:=(TopMargin - TestModeLabel.Height) div 2;
   end;
   
   with CloseBt do begin
      Top:= (TopMargin - Height) div 2;
      Left:= FormWidth - Top - Width;
   end;

   with HelpBt do begin
      Top:= (TopMargin - Height) div 2;
      Left:= FormWidth - Top - Width*2 - Width div 2;
   end;

   with TrayBt do begin
      Top:= (TopMargin - Height) div 2;
      Left:= FormWidth - Top - Width*4;
   end;

  {Left pane control}

   for i:=Low(LeftLabels) to High(LeftLabels) do begin
    with LeftLabels[i] do begin
      Top:=LabelTop;
      Left:=Labelleft div 3 * 2;
      Font.Size:=LabelFontSize;
      LabelTop:=LabelTop + Height + LabelShpacer;
    end;
   end;

   with  TimerCaption do begin
    Font.Size:= LabelFontSize;
    Top:=LeftLabels[High(LeftLabels)].BoundsRect.Bottom + YSpacer*2;
    Width:=LeftPaneWidth - XSpacer*2;
    Left:=(LeftPaneWidth - Width) div 2;
   end;

   with  TimerMsg do begin
      Font.Size:= LabelFontSize*2;
      Top:= TimerCaption.BoundsRect.Bottom + YSpacer*2;
      Left:=(LeftPaneWidth - Width) div 2;
   end;

   with  AllPrBar do begin
    Height := ProgressHeight;
    Left:=YSpacer*2;
    Width:=LeftPaneWidth - YSpacer*4;
    Top:=FormHeight - BottomMargin*2 - Height - YSpacer;
   end;

   with  AllLabel do begin
    Left:=AllPrBar.Left;
    Font.Size:= LabelFontSize;
    Top:=Round(AllPrBar.Top - Height - YUnit*4);
   end;

   with  GrpPrBar do begin
    Height := ProgressHeight;
    Left:=YSpacer*2;
    Width:=LeftPaneWidth - YSpacer *4;
    Top:=Round(AllLabel.Top - Height - YUnit*4);
   end;

   with  GrpLabel do begin
    Left:=GrpPrBar.Left;
    Font.Size:= LabelFontSize;
    Top:=Round(GrpPrBar.Top - Height - YUnit*4);
   end;

   with  MemoLabel2 do begin
    Font.Size:= LabelFontSize+4;
    Width:=LeftPaneWidth - YSpacer * 2;
    Height := MemoLabel2.Canvas.TextHeight('A@0')*2;
    Left:=YSpacer;
    Top:=GrpLabel.Top - MemoLabel2.Canvas.TextHeight('A@0')*2;
   end;

   with  MemoLabel1 do begin
    Font.Size:= LabelFontSize;
    Width:=LeftPaneWidth - YSpacer  *2;
    Height := MemoLabel1.Canvas.TextHeight('AAA')* 3;
    Left:=YSpacer;
    Top:=MemoLabel2.Top - MemoLabel1.Canvas.TextHeight('AAA')*4;
   end;

   with  CheckAllBt do begin
      Font.Size:=LabelFontSize;
      Top:=FormHeight - BottomMargin*2 - (Height div 2)*9;
      Left:=Labelleft div 3 * 2;
   end;

   with  CheckNoneBt do begin
      Font.Size:=LabelFontSize;
      Top:=FormHeight - BottomMargin*2 - (Height div 2)*6;
      Left:=Labelleft div 3 * 2;
   end;

   with  CheckDefBt do begin
      Font.Size:=LabelFontSize;
      Top:=FormHeight - BottomMargin*2 - (Height div 2)*3;
      Left:=Labelleft div 3 * 2;
   end;

   with  CheckRebootBt do begin
      Font.Size:=LabelFontSize;
      Top:=FormHeight - BottomMargin*2 - (Height div 2)*9;
      Left:=Labelleft div 3 * 2;
   end;

   with  CheckPoweroffBt do begin
      Font.Size:=LabelFontSize;
      Top:=FormHeight - BottomMargin*2 - (Height div 2)*6;
      Left:=Labelleft div 3 * 2;
   end;

   with  CheckCloseBt do begin
      Font.Size:=LabelFontSize;
      Left:=Labelleft div 3 * 2;
      Top:=FormHeight - BottomMargin*2 - (Height div 2)*3;
   end;

   with  FastSelectLabel do begin
    Font.Size:=LabelFontSize;
    Left:=Labelleft div 3 * 2;
    Top:=Round(CheckRebootBt.Top - Height -YUnit*6) ;
   end;

   {Right pane control}

   with  CaptionLabel do begin
      Top:=TopMargin + YSpacer;
      Font.Size:= Round(LabelFontSize*1.5);
      //Left:=LeftPaneWidth + XSpacer;
      Left:=LeftPaneWidth + (RightPaneWidth  - Width ) div 2;
   end;

   with  DeskriptionLabel do begin
    Left:=LeftPaneWidth + XSpacer;
    Font.Size:=LabelFontSize;
    Width:=RightPaneWidth - XSpacer*2;
    Top:= Round(CaptionLabel.BoundsRect.Bottom + YUnit*4);
   end;

   with ItemImage do begin
    Left:=LeftPaneWidth + XSpacer;
    Top:= Round(CaptionLabel.BoundsRect.Bottom + YUnit*4);
   end;

   with ScrShot do begin
    Left:=LeftPaneWidth + XSpacer;
    Top:= Round(CaptionLabel.Top + CaptionLabel.Height +YUnit*50);
    Width:=RightPaneWidth - XSpacer*2;
    Height:=FormHeight - Top*2;
   end;

   with CollapseBt do begin
      MaxBtHeight:=Height;
      Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer;
   end;

   with ExpandBt do begin
      MaxBtHeight:=Max(Height,MaxBtHeight);
      Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer+  Width * 2;
   end;

   with PrevBt do begin
      Font.Size:=LabelFontSize;
      MaxBtHeight:=Max(Height,MaxBtHeight);
      Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer + (RightPaneWidth - XSpacer*2) div 5 * 3;
   end;

   with NextBt do begin
      Font.Size:=LabelFontSize;
      MaxBtHeight:=Max(Height,MaxBtHeight);
      Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer + (RightPaneWidth - XSpacer*2) div 5 * 4;
   end;

   for i:=Low(UserFuncButton) to High(UserFuncButton) do begin
    with UserFuncButton[i] do begin
      Font.Size:=LabelFontSize;
      MaxBtHeight:=Max(Height,MaxBtHeight);
       Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer + (RightPaneWidth - XSpacer*2) div 4*(I-1);
    end;
   end;

   with LicConfirmBt do begin
      Font.Size:=LabelFontSize;
      MaxBtHeight:=Max(Height,MaxBtHeight);
       Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer;
   end;

   with FinishBt do begin
      Font.Size:=LabelFontSize;
      MaxBtHeight:=Max(Height,MaxBtHeight);
      Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + XSpacer + (RightPaneWidth - XSpacer*2) div 5 * 4;
   end;

   with  SelectProgTree do begin
    Font.Size:= LabelFontSize;
    Left:=LeftPaneWidth + XSpacer;
    Top:= Round(DeskriptionLabel.Top + DeskriptionLabel.Canvas.TextHeight(SelectorDeskriptionLabelCaption) + YUnit*4);
    Width:=RightPaneWidth - XSpacer*2;
    Height:=FormHeight - Top - BottomMargin - MaxBtHeight *2;
    if TreeColor=clNone then Color:= Wallpapers.Canvas.Pixels[Left,Top]
                        else Color:= TreeColor;
    IconBackColor:=Color;
   end;

   with  SelectProgMemo do begin
    FontSize:= LabelFontSize;
    Left:=LeftPaneWidth + XSpacer;
    Top:= Round(DeskriptionLabel.Top + DeskriptionLabel.Canvas.TextHeight(SelectorDeskriptionLabelCaption) + YUnit*4);
    Width:=RightPaneWidth - XSpacer*2;
    Height:=FormHeight - Top - BottomMargin - MaxBtHeight *2;
    if MemoColor=clNone then Color:= Wallpapers.Canvas.Pixels[Left,Top]
                        else Color:= MemoColor;
   end;

   with  RebootPrBar do begin
     Height := Round(ProgressHeight - YUnit);
     Width:=180;
     Left:= LeftPaneWidth + (RightPaneWidth - Width) div 2;
     RebootPrBar.Top:= (FormHeight - Height) div 2;
   end;

   with  RebootMsgLabel do begin
    Font.Size:=LabelFontSize;
    Top:= RebootPrBar.Top - Height*3;
    Left:= LeftPaneWidth + (RightPaneWidth - Width) div 2;
   end;

   with NoRebootBt do begin
      Font.Size:=LabelFontSize;
      Caption:= NoRebootBtCaption;
      Top:=RebootPrBar.BoundsRect.Bottom + Height;
      Left:= LeftPaneWidth + (RightPaneWidth - Width) div 2;
   end;

   with ScipBt do begin
      Font.Size:=LabelFontSize;
      Top:=FormHeight - BottomMargin - (Height div 2)*3;
      Left:= LeftPaneWidth + (RightPaneWidth - Width) div 2;
   end;

   {Bottom pane control}

   with CopyRightLabel do begin
    Font.Size:= LabelFontSize-4;
    Font.Style:=[];
    Left:= YSpacer;
    Top:= FormHeight - (BottomMargin + Height) div 2;
   end;

   with ProgressImg do begin
      Top:=FormHeight - (BottomMargin + Height) div 2;
      Left:=FormWidth - Width - XSpacer;
   end;

   with  TestTrialModeLabel do begin
    Font.Size:= LabelFontSize;
    Left:=LeftPaneWidth;
    Top:=FormHeight - (BottomMargin + Height) div 2;
   end;
  if CheckCmdParam('writepos') then  WriteControlPos(SkinIni,ControlSecktion);
  //ReadControlPos(SkinIni,ControlSecktion)
  if ABCCoord then  ReadControlPos(SkinIni,ControlSecktion);
end;

procedure TNewProcessFm.WriteControlPos(IniFileName:string; Section:string);
var
 i:integer;
begin
 if not FileExists(IniFileName) then exit;
 with TIniFile.Create(IniFileName) do
 try
  for i:=0 to NewProcessFm.ControlCount -1 do begin
   if (NewProcessFm.Controls[i].Name <> 'Wallpapers') or
      (NewProcessFm.Controls[i].Name <> 'LeftMargin') then
    WriteString(Section,
                NewProcessFm.Controls[i].Name,
                'T:' + IntToStr(NewProcessFm.Controls[i].Top) +' ' +
                'L:' + IntToStr(NewProcessFm.Controls[i].Left) +' ' +
                'W:' + IntToStr(NewProcessFm.Controls[i].Width) +' ' +
                'H:' + IntToStr(NewProcessFm.Controls[i].Height));
  end;
 finally
  free;
 end;
end;

procedure TNewProcessFm.ReadControlPos(IniFileName:string; Section:string);
var
 i:integer;
 ParamLine:string;

 function GetParam(Line:string; Param:string):string;
 var
   F,L:integer;
 begin
   result:='';
   F:=Pos(Param,line);
   if F < 1 then exit;
   L:=PosEx(' ',line,F+1);
   if L < 1 then L:= Length(Line)+1;
   result:= Copy(Line,F+Length(Param), L - (F+Length(Param)));
 end;

 function SetControlParam(AParam:integer; ParLine:string):integer;
 begin
   result:=AParam;

   if ParLine <> '' then begin
     if ParLine[1] = '-' then begin
       Delete(ParLine,1,1);
       result:=AParam - StrToIntDef(ParLine,0);
     end else
     if ParLine[1] = '+' then begin
       Delete(ParLine,1,1);
       result:=AParam + StrToIntDef(ParLine,0);
     end else begin
       result:= StrToIntDef(ParLine,AParam);
     end;
   end;
 end;


begin
 if not FileExists(IniFileName) then exit;
 with TIniFile.Create(IniFileName) do
 try
   if not SectionExists(Section) then Section:=  'Param_DEFxDEF';

   for i:=0 to NewProcessFm.ControlCount -1 do begin
     ParamLine:=ReadString(Section,NewProcessFm.Controls[i].Name,'');
     if  ParamLine <> '' then begin
        NewProcessFm.Controls[i].Top:=SetControlParam(NewProcessFm.Controls[i].Top,GetParam(ParamLine,'T:'));
        NewProcessFm.Controls[i].Left:=SetControlParam(NewProcessFm.Controls[i].Left,GetParam(ParamLine,'L:'));
        NewProcessFm.Controls[i].Width:=SetControlParam(NewProcessFm.Controls[i].Width,GetParam(ParamLine,'W:'));
        NewProcessFm.Controls[i].Height:=SetControlParam(NewProcessFm.Controls[i].Height,GetParam(ParamLine,'H:'));
     end;
   end;
 finally
  free;
 end;
end;

procedure TNewProcessFm.InitControls;
var
 I:integer;
 TmpImg:TPicture;
 ResImg:TBitmap;
begin
   if FileExists(SkinFolder + WALL_PICT) then begin
    TmpImg:=TPicture.Create;
    try
     TmpImg.LoadFromFile(SkinFolder + WALL_PICT);
     Wallpapers.Picture.Bitmap.Assign(TmpImg.Graphic);
    finally
     TmpImg.Free;
    end;
   end;
   ResImg:=TBitmap.Create;
   try
     if FileExists(SkinFolder + GROUP_BIG) then
     ResImg.LoadFromFile(SkinFolder + GROUP_BIG);
     if not ResImg.Empty then  begin
      SelectTreeImg.Clear;
      SelectTreeImg.Height:=ResImg.Height;
      SelectTreeImg.Width:=ResImg.Width div 4;
      SelectTreeImg.AddMasked(ResImg,ResImg.Canvas.Pixels[0,ResImg.Height-1]);
     end;
   finally
     ResImg.Free;
   end;
   ResImg:=TBitmap.Create;
   try
     if FileExists(SkinFolder + TREESEL_BIG) then
     ResImg.LoadFromFile(SkinFolder + TREESEL_BIG);
     if not ResImg.Empty then begin
      SelectTreeStateImg.Clear;
      SelectTreeStateImg.Height:=ResImg.Height;
      SelectTreeStateImg.Width:=ResImg.Width div 7;
      SelectTreeStateImg.AddMasked(ResImg,ResImg.Canvas.Pixels[0,ResImg.Height-1]);
     end;
   finally
     ResImg.Free;
   end;
   MyLogo:= TImage.Create(NewProcessFm);
   with MyLogo do begin
    Name:='MyLogo';
    Parent:= NewProcessFm;
    AutoSize:= true;
    Transparent:= true;
    Visible:=true;
    OnMouseDown:= TopLogoMouseDown;
    OnMouseMove:= TopLogoMouseMove;
    OnMouseUp:= TopLogoMouseUp;
   end;
   CopyRightLabel:=TUrlLabel.Create(NewProcessFm);
   with CopyRightLabel do begin
    Name:='CopyRightLabel';
    Parent:=NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    ActiveColor:=LabelColor;//ButtonActiveFontColor;
    InActiveColor:=LabelColor;
    ActiveUnderline:=true;
    ActiveBold:=false;
    Font.Style:= [fsBold];
    ActivateSnd:=SkinFolder+SND_OVER;
    ClickSnd:=SkinFolder+SND_CLICK;
    Caption:=CopyRightLabelCaption;
    Alignment:= taCenter ;
    Cursor:= crHandPoint;
    OnClick := CopyRightLabelClick;
   end;
   for i:=Low(LeftLabels) to High(LeftLabels) do begin
    LeftLabels[i]:=TCheckLabel.Create(NewProcessFm);
    with LeftLabels[i] do begin
      Name:='LeftLabels'+IntToStr(i);
      Parent:=NewProcessFm;
      Tag:=i;
      Caption:=LabelCaptions[i];
      Font.Name:=LabelFont;
      NormalColor:=LabelColor;
      ActiveColor:=LabelActiveColor;
      if FileExists(SkinFolder + BULB_PICT) then
         LoadBulbImgFromFile(SkinFolder + BULB_PICT);
    end;
   end;
   TimerCaption:=TLabel.Create(NewProcessFm);
   with  TimerCaption do begin
    Parent:=NewProcessFm;
    Name:='TimerCaption';
    Color:=clNone;
    Transparent:=true;
    Caption:= StartupTimerCaptionCaption;
    //Hint:= StartupTimerCaptionHint;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    Font.Style:=[fsBold];
    Alignment:= taCenter ;
    Visible:=false;
   end;
   TimerMsg:=TShadowLabel.Create(NewProcessFm);
   with  TimerMsg do begin
      Name:='TimerMsg';
      Parent:=NewProcessFm;
      Transparent:=true;
      Caption:= '00:00';
      Hint:= StartupTimerCaptionHint;
      Font.Name:=BigLabelFont;
      Font.Color:=BigLabelColor;
      Font.Style:=[fsBold];
      ShadowColor:=BigLabelShadowColor;
      ShadowSize:=2;
      ShadowPos:= spRightBottom;
      Visible:=false;
   end;
   TestModeLabel:=TLabel.Create(NewProcessFm);
   with  TestModeLabel do begin
    Name:='TestModeLabel';
    Parent:=NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Font.Name:=LabelFont;
    Font.Color:=clRed;
    Font.Style:=[fsBold];
    Visible:=false;
    OnMouseDown:= TopLogoMouseDown;
    OnMouseMove:= TopLogoMouseMove;
    OnMouseUp:= TopLogoMouseUp;
   end;
   TestTrialModeLabel:=TLabel.Create(NewProcessFm);
   with  TestTrialModeLabel do begin
    Name:='TestTrialModeLabel';
    Parent:=NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Caption:=TestMsg;
    Font.Name:=LabelFont;
    Font.Color:=clRed;
    Font.Style:=[fsBold];
    Visible:=TestOnly;
   end;
   AllPrBar:= TMyProgress.Create(NewProcessFm);
   with  AllPrBar do begin
    Name:='AllPrBar';
    Parent:= NewProcessFm;
    ForeColor:=ProgressColor;
    BackColor:=ProgressBackColor;
    Progress:= 0;
    ShowText:= False;
   end;
   AllLabel:=TLabel.Create(NewProcessFm);
   with  AllLabel do begin
    Name:='AllLabel';
    Parent:= NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Caption:=AllLabelCaption;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    Font.Style := [fsBold]
   end;
   GrpPrBar:= TMyProgress.Create(NewProcessFm);
   with  GrpPrBar do begin
    Name:='GrpPrBar';
    Parent:= NewProcessFm;
    ForeColor:=ProgressColor;
    BackColor:=ProgressBackColor;
    Progress:= 0;
    ShowText:= False;
   end;
   GrpLabel:=TLabel.Create(NewProcessFm);
   with  GrpLabel do begin
    Name:='GrpLabel';
    Parent:= NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Caption:=GrpLabelCaption;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    Font.Style:= [fsBold];
   end;
   MemoLabel2:=TLabel.Create(NewProcessFm);
   with  MemoLabel2 do begin
    Name:='MemoLabel2';
    Parent:= NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Alignment:= taCenter;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    WordWrap:= True;
    AutoSize:= False;
   end;
   MemoLabel1:=TLabel.Create(NewProcessFm);
   with  MemoLabel1 do begin
    Name:='MemoLabel1';
    Parent:= NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    Alignment:= taCenter;
    WordWrap:= True;
    AutoSize:= False;
   end;
   CaptionLabel:=TShadowLabel.Create(NewProcessFm);
   with  CaptionLabel do begin
      Name:= 'CaptionLabel';
      Parent:=NewProcessFm;
      Transparent:=true;
      Font.Name:=BigLabelFont;
      Font.Color:=BigLabelColor;
      Font.Style:=[fsBold];
      ShadowColor:=BigLabelShadowColor;
      ShadowSize:=2;
      ShadowPos:= spRightBottom;
      Alignment:= taCenter;
  end;
  DeskriptionLabel:=TLabel.Create(NewProcessFm);
  with  DeskriptionLabel do begin
   Name:='DeskriptionLabel';
   Parent:= NewProcessFm;
   Color:=clNone;
   Transparent:=true;
   //AutoSize:=false;
   WordWrap:=true;
   Font.Name:=LabelFont;
   Font.Color:=LabelColor;
  end;
  ItemImage:= TImage.Create(NewProcessFm);
  with ItemImage do begin
   Name:='ItemImage';
   Parent:= NewProcessFm;
   AutoSize:= true;
   Transparent:= true;
   Visible:=false;
  end;
  ScrShot:= TCoolImage.Create(NewProcessFm);
  with ScrShot do begin
   Name:='ScrShot';
   Parent:= NewProcessFm;
   AutoSize:= false;
   Transparent:= false;
   Center:= true;
   Stretch:= TStretchType(StretchSkreenShots);
   Proportional:=true;
   Visible:=false;
  end;
  SelectProgTree:= TTreeView.Create(NewProcessFm);
  with  SelectProgTree do begin
   Name:='SelectProgTree';
   Parent:= NewProcessFm;
   BevelInner := bvSpace;
   BevelOuter := bvNone;
   HideSelection := False;
   Images := SelectTreeImg;
   Indent := 68;
   ReadOnly := True;
   RowSelect := True;
   ShowButtons := False;
   ShowLines := False;
   ShowRoot := False;
   StateImages := SelectTreeStateImg;
   TabOrder := 0;
   ToolTips := False;
   OnClick := SelectProgTreeClick;
   OnCollapsed := SelectProgTreeCollapsed;
   OnCollapsing := SelectProgTreeCollapsing;
   OnCustomDrawItem := SelectProgTreeCustomDrawItem;
   OnExpanding := SelectProgTreeExpanding;
   OnExpanded := SelectProgTreeExpanded;
   OnKeyPress := SelectProgTreeKeyPress;
   OnMouseMove := SelectProgTreeMouseMove;
   Font.Name:=TreeFont;
   Font.Color:=TreeFontColor;
   if TreeColor=clNone then Color:= Wallpapers.Canvas.Pixels[SelectProgTree.Left,SelectProgTree.Top]
                       else Color:= TreeColor;
   AutoExpand:=not GlobalNoCollapseNode;
  end;
 SelectProgMemo:=TSmartMemo.Create(NewProcessFm);
  with  SelectProgMemo do begin
   Name:='SelectProgMemo';
   Parent:=NewProcessFm;
   FontName:=MemoFont;
   FontColor:=MemoFontColor;
   OnKeyDown:= SelectProgMemoKeyDown;
   OnMouseDown:= SelectProgMemoMouseDown;
   if MemoColor=clNone then Color:= Wallpapers.Canvas.Pixels[SelectProgMemo.Left,SelectProgMemo.Top]
                       else Color:= MemoColor;
  end;
  CollapseBt:=TCoolButton.Create(NewProcessFm);
  with CollapseBt do begin
      Name:='CollapseBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+ COLLAPSE_BT);
      Hint:=CollapseBtHint;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=1;
      OnClick:=CollapseClick;
   end;
   ExpandBt:=TCoolButton.Create(NewProcessFm);
   with ExpandBt do begin
      Name:='ExpandBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+EXPAND_BT);
      Hint:=ExpandBtHint;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=1;
      OnClick:=ExpandClick;
   end;
   for i:=Low(UserFuncButton) to High(UserFuncButton) do begin
    UserFuncButton[i]:=TCoolButton.Create(NewProcessFm);
    with UserFuncButton[i] do begin
      Name:='UserFuncBt'+IntToStr(I);
      Parent:=NewProcessFm;
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=i;
      Visible:=false;
      OnClick:=UserFuncClick;
    end;
   end;
   PrevBt:=TCoolButton.Create(NewProcessFm);
   with PrevBt do begin
      Name:='PrevBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+LEFT_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= PrevBtCaption;
      Hint:= PrevBtHint;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=1;
      OnClick:=NavigateClick;
   end;
   NextBt:=TCoolButton.Create(NewProcessFm);
   with NextBt do begin
      Name:='NextBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+RIGHT_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= NextBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:= NextBtHint;
      Tag:=2;
      OnClick:=NavigateClick;
   end;
   LicConfirmBt:=TCoolButton.Create(NewProcessFm);
   with  LicConfirmBt do begin
      Name:='LicConfirmBt';
      Parent:=NewProcessFm;
      Mode:=cmCheckBox;
      Checked:=false;
      LoadGlyphFromFile(SkinFolder+LICCHECK_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;;
      Caption:= CheckLicenseConfirmBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:=CheckLicenseConfirmBtHint;
      OnClick:=LicConfirmBtClick;
   end;
   FinishBt:=TCoolButton.Create(NewProcessFm);
   with FinishBt do begin
      Name:='FinishBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+FINISH_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= FinishBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:= FinishBtHint;
      Tag:=2;
      OnClick:=FinishClick;
   end;
   CloseBt:=TCoolButton.Create(NewProcessFm);
   with CloseBt do begin
      Name:='CloseBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+CLOSE_BT);
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:=CloseBtHint;
      OnClick:=CloseClick;
   end;
   HelpBt:=TCoolButton.Create(NewProcessFm);
   with HelpBt do begin
      Name:='HelpBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+HELP_BT);
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:=HelpBtHint;
      OnClick:=HelpClick;
   end;
   TrayBt:=TCoolButton.Create(NewProcessFm);
   with TrayBt do begin
      Name:='TrayBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+TRAY_BT);
      Hint:= TrayBtHint;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Enabled:=false;
      //Visible:=false;
      OnClick:=TrayClick;
   end;
   FastSelectLabel:=TLabel.Create(NewProcessFm);
   with  FastSelectLabel do begin
     Name:='FastSelectLabel';
     Parent:= NewProcessFm;
     Color:=clNone;
     Transparent:=true;
     Font.Name:=LabelFont;
     Font.Color:=LabelColor;
     Font.Style:= [fsBold];
     Caption:=FastSelectCaption;
     Visible:=false;
   end;
   CheckAllBt:=TCoolButton.Create(NewProcessFm);
   with  CheckAllBt do begin
      Name:='CheckAllBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+CHECKALL_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;;
      Caption:= CheckAllBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=1;
      Hint:=CheckAllBtHint;
      OnClick:=CheckSelectClick;
   end;
   CheckNoneBt:=TCoolButton.Create(NewProcessFm);
   with  CheckNoneBt do begin
      Name:='CheckNoneBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+CHECKNONE_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:=CheckNoneBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=2;
      Hint:=CheckNoneBtHint;
      OnClick:=CheckSelectClick;
   end;
   CheckDefBt:=TCoolButton.Create(NewProcessFm);
   with  CheckDefBt do begin
      Name:='CheckDefBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+CHECKDEF_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= CheckDefBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=3;
      Hint:=CheckDefBtHint;
      OnClick:=CheckSelectClick;
   end;
   CheckRebootBt:=TCoolButton.Create(NewProcessFm);
   with  CheckRebootBt do begin
      Name:='CheckRebootBt';
      Parent:=NewProcessFm;
      Mode:=cmCheckBox;
      Checked:=false;
      LoadGlyphFromFile(SkinFolder+CHECKTG_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;;
      Caption:= CheckRebootBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=1;
      Hint:=CheckRebootBtHint;
      OnClick:=CheckFinishModeClick;
   end;
   CheckPoweroffBt:=TCoolButton.Create(NewProcessFm);
   with  CheckPoweroffBt do begin
      Name:='CheckPoweroffBt';
      Parent:=NewProcessFm;
      Mode:=cmCheckBox;
      Checked:=false;
      LoadGlyphFromFile(SkinFolder+CHECKTG_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:=CheckPoweroffBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=2;
      Hint:=CheckPoweroffBtHint;
      OnClick:=CheckFinishModeClick;
   end;
   CheckCloseBt:=TCoolButton.Create(NewProcessFm);
   with  CheckCloseBt do begin
      Name:='CheckCloseBt';
      Parent:=NewProcessFm;
      Mode:=cmCheckBox;
      Checked:=false;
      LoadGlyphFromFile(SkinFolder+CHECKTG_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= CheckCloseBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Tag:=3;
      Hint:=CheckCloseBtHint;
      OnClick:=CheckFinishModeClick;
   end;
   RebootPrBar:= TMyProgress.Create(NewProcessFm);
   with  RebootPrBar do begin
     Name:='RebootPrBar';
     Parent:= NewProcessFm;
     ForeColor:=RebotProgressColor;
     BackColor:=ProgressBackColor;
     Progress:= 0;
     ShowText:= False;
   end;
   RebootMsgLabel:=TLabel.Create(NewProcessFm);
   with  RebootMsgLabel do begin
    Parent:= NewProcessFm;
    Color:=clNone;
    Transparent:=true;
    Name:='RebootMsgLabel';
    Caption:=RebootMsgLabelRebootCaption;
    Font.Name:=LabelFont;
    Font.Color:=LabelColor;
    Font.Style:= [fsBold];
   end;
   NoRebootBt:=TCoolButton.Create(NewProcessFm);
   with NoRebootBt do begin
      Name:='NoRebootBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+CANCEL_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= NoRebootBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:=NoRebootBtHint;
      OnClick:=NoRebootClick;
   end;
   ScipBt:=TCoolButton.Create(NewProcessFm);
   with ScipBt do begin
      Name:='ScipBt';
      Parent:=NewProcessFm;
      LoadGlyphFromFile(SkinFolder+CANCEL_BT);
      Font.Name:=LabelFont;
      Font.Color:=ButtonFontColor;
      ActiveColor:=ButtonActiveFontColor;
      Caption:= ScipBtCaption;
      ActivateSnd:=SkinFolder+SND_OVER;
      ClickSnd:=SkinFolder+SND_CLICK;
      Hint:=ScipBtHint;
      OnClick:=ScipBtClick;
   end;
  ProgressImg:=TProgressImage.Create(NewProcessFm);
   with ProgressImg do begin
      Name:='ProgressImg';
      Parent:=NewProcessFm;
      if FileExists(SkinFolder + PRCHECK_PICT) then
      LoadPictImgFromFile(SkinFolder + PRCHECK_PICT);
   end;
   for i:=0 to NewProcessFm.ControlCount -1 do begin
       THackControl(NewProcessFm.Controls[i]).font.Charset:=CommonCharSet;
   end;
end;

procedure TNewProcessFm.FormCreate(Sender: TObject);
var
 //WStr,HStr, LStr, TStr :string;
 TW, TH, Tl, TT:integer;
 Alpha: byte;
begin
   WindowProc:=AppMessage;
   OldWndProc := Pointer(GetWindowLong(Application.Handle, GWL_WNDPROC));
   NewWndProc := MakeObjectInstance(ApplicationHook);
   SetWindowLong(Application.Handle, GWL_WNDPROC, LongInt(NewWndProc));
   CreateInstallList;
   MidiPlay:= TUMidi.Create(self);
   SmallIconList:=SelectTreeImg;
   BigIconList:=BigImg;
   SkinIni:=GetSkinIni;
   SkinFolder:=GetSkinFolder;
   if not ValidateSkin(SkinIni) then begin
      MessageBox(Handle,PChar('Skin configuration file not found,'#13#10'wrong (mismatch) version or structure corrupt.'#13#10'Please, check '+DefaultSkinIniName+' file.'#13#10#13#10'Program terminated!'),
                 PChar('Fatal error'), MB_OK or MB_ICONERROR);
      ExitCode := CANCEL_EXIT;           
      Application.Terminate;
   end;
   LoadLocalisedProcessForm(SkinIni);
   LoadLocalisedCommon(SkinIni);
   LoadInterfaceSetting(SkinIni);
   HideRunOnce;
   EndInstallProcess:= false;
   RestartInstall:= false;
   StartinstallDelay:=1000;
   if StayOnTop then FormStyle:=fsStayOnTop else FormStyle:=fsNormal;
   WStr:=GetCmdParam('w:');
   HStr:=GetCmdParam('h:');
   if (WStr<>'') and (HStr <> '') then begin
    TW:= StrToIntDef(WStr,640);
    TH:= StrToIntDef(HStr,480);
    NewProcessFm.Width:=Max(TW,640);
    NewProcessFm.Height:=Max(TH,480);
    NewProcessFm.Width:=Min(TW,Screen.Width);
    NewProcessFm.Height:=Min(TH,Screen.Height);
    LStr:=GetCmdParam('l:');
    TStr:=GetCmdParam('t:');
    if (LStr<>'') and (TStr <> '') then begin
     TL:= StrToIntDef(LStr,0);
     TT:= StrToIntDef(TStr,0);
     NewProcessFm.Left:=Min(TL,Screen.Width-10);
     NewProcessFm.Top:=Min(TT,Screen.Height-10);
     NewProcessFm.Left:=Min(TL,Screen.Width-Width);
     NewProcessFm.Top:=Min(TT,Screen.Height-Height);
    end else
    begin
     NewProcessFm.Left:=(Screen.Width - NewProcessFm.Width) div 2;
     NewProcessFm.Top:=(Screen.Height - NewProcessFm.Height) div 2;
    end;
   end else if (TmpWidth >0) and (TmpHeight > 0) then begin
    NewProcessFm.Width:=Max(TmpWidth,640);
    NewProcessFm.Height:=Max(TmpHeight,480);
    NewProcessFm.Width:=Min(TmpWidth,Screen.Width);
    NewProcessFm.Height:=Min(TmpHeight,Screen.Height);
    if (TmpLeft > 0) and (TmpTop > 0) then begin
     NewProcessFm.Left:=Min(TmpLeft,Screen.Width-Width);
     NewProcessFm.Top:=Min(TmpTop,Screen.Height-Height);
    end else
    begin
     NewProcessFm.Left:=(Screen.Width - NewProcessFm.Width) div 2;
     NewProcessFm.Top:=(Screen.Height - NewProcessFm.Height) div 2;
    end;
   end else begin
    {
    NewProcessFm.Top:=Screen.WorkAreaTop;
    NewProcessFm.Left:=Screen.WorkAreaLeft;
    NewProcessFm.Width:= Screen.WorkAreaWidth;
    NewProcessFm.Height:= Screen.WorkAreaHeight; }
    NewProcessFm.Top:=0;
    NewProcessFm.Left:=0;
    NewProcessFm.Width:= Screen.Width;
    NewProcessFm.Height:= Screen.Height;
    FullScreenMode:=true;
   end;
   Screen.HintFont.Name:=HintFont;
   Screen.HintFont.Color:=HintFontColor;
   Screen.HintFont.Charset:=CommonCharSet;
   Application.HintColor:= HintColor;
   Application.HintHidePause:=MyHintHidePause;
   Application.HintPause:=MyHintPause;
   Application.HintShortPause:=MyHintShortPause;
   Alpha:=255;
    if (AlphaBlendLevel <> 255) and
      (not IsPeMode) and
      IsExplorerRuning then begin
      AlphaBlendValue:=AlphaBlendLevel;
      Alpha:= AlphaBlendLevel;
      AlphaLevel:= AlphaBlendLevel;
      AlphaBlend:=true;
   end;
   if GlobalCoolHint then SetHintStyle(hsRoundRect,3, true, taLeftJustify, Alpha);
   InitControls;
   ResizeControls;
   Application.ShowHint:=GlobalShowHint;
   Application.CancelHint;
   ShowLicense(false);
   ShowPostInstall(false);
   ShowInstall(false);
   ShowReboot(false);
   ShowSelector(false);
   ShowPrepare(false);
   ShowFinish(false);
   StartDelayTimer.Enabled:=true;
   if FullScreenMode then Movable:=false;
end;

procedure TNewProcessFm.BlockUserInput(InputState: boolean);
begin
   CloseBt.Enabled:=InputState;
   NoRebootBt.Enabled:=InputState;
   ScipBt.Enabled:=InputState;
end;


procedure TNewProcessFm.FormDestroy(Sender: TObject);
var
 hTaskBar:HWND;
begin
 if StayOnTop then begin
    hTaskBar:= FindWindow('Shell_TrayWnd','');
    ShowWindow(hTaskBar, SW_SHOW);
 end;
 FreeInstallList;
 CloseLog(not RebootSheduled);
 ShowRunOnce;
 DeleteTrayIcon;
 MidiPlay.Free;
 if OldWndProc <> nil then SetWindowLong(Application.Handle, GWL_WNDPROC, LongInt(OldWndProc));
end;

procedure TNewProcessFm.PrepareUserButton;
 var
  I:integer;
begin
  for i:=Low(UserFuncButton) to High(UserFuncButton) do begin
    with UserFuncButton[i] do begin
      Caption:=UserButton[i].Caption;
      Hint:=UserButton[i].Hint;
      LoadGlyphFromFile(SkinFolder+UserButton[i].Picture);
      Top:=SelectProgTree.Top + SelectProgTree.Height + Height div 2;
    end;
  end;
end;

procedure TNewProcessFm.ShowWelcome(ShowState: boolean);
var
  i:integer;
begin
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   NextBt.Visible:=ShowState;
   for i:=Low(UserFuncButton) to High(UserFuncButton) do
       UserFuncButton[i].Visible:= ShowState and UserButton[i].Visible;
   if ShowState then begin
    if (ReadMeTxt <> '') and
       FileExists(ExpandEnvString(ReadMeTxt)) then begin
       SelectProgMemo.LoadText(ExpandEnvString(ReadMeTxt));
       SelectProgMemo.Visible:=true;
    end;
    NextBt.Caption:=SelectorNextBtCaption;
    NextBt.Enabled:=true;
    NextBt.Hint:=SelectorNextBtHint;
    CaptionLabel.Caption:=StartupCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Caption:=StartupDeskriptionLabelNoWatCaption + StartupDeskriptionLabelCaption;
    DeskriptionLabel.Width:=RightPaneWidth - XSpacer*2 ;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
   end else SelectProgMemo.Visible:=ShowState;
end;

procedure TNewProcessFm.ShowWait(ShowState: boolean);
var
  i:integer;
begin
   TimerCaption.Visible:=ShowState;
   TimerMsg.Visible:=ShowState;
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   NextBt.Visible:=ShowState;
   for i:=Low(UserFuncButton) to High(UserFuncButton) do
       UserFuncButton[i].Visible:= ShowState and UserButton[i].Visible;
   if ShowState then begin
    if (ReadMeTxt <> '') and
       FileExists(ExpandEnvString(ReadMeTxt)) then begin
       SelectProgMemo.WordWrap:=true;
       SelectProgMemo.LoadText(ExpandEnvString(ReadMeTxt));
       SelectProgMemo.Visible:=true;
    end;
    NextBt.Caption:=SelectorNextBtCaption;
    NextBt.Hint:=SelectorNextBtHint;
    CaptionLabel.Caption:=StartupCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Caption:=StartupDeskriptionLabelWatCaption +  StartupDeskriptionLabelCaption;
    DeskriptionLabel.Width:=SelectProgTree.Width ;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
   end else SelectProgMemo.Visible:=ShowState;
end;

procedure TNewProcessFm.EndWait;
begin
   AddDebugMsg('Wait timer stopped. Use manually select mode.');
   AddDebugMsg('');
   StartDefautInstallTimer.Enabled:=false;
   TimerCaption.Visible:=false;
   TimerMsg.Visible:=false;
   CaptionLabel.Caption:=StartupCaptionLabelCaption;
   CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
   DeskriptionLabel.Caption:=StartupDeskriptionLabelNoWatCaption  +  StartupDeskriptionLabelCaption;
   DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
end;

procedure TNewProcessFm.ShowLicense(ShowState: boolean);
begin
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   LicConfirmBt.Visible:=ShowState;
   NextBt.Visible:=ShowState;
   PrevBt.Visible:=ShowState and EnableWelcomeDlg;
   if ShowState then begin
    //NextBt.Enabled:=LicConfirmBt.Checked;
    if LicConfirmBt.Checked then begin
        NextBt.Caption:=SelectorNextBtCaption;
        NextBt.Hint:=SelectorNextBtHint;
      end
      else begin
        NextBt.Caption:=CheckLicenseCancelBtCaption;
        NextBt.Hint:=CheckLicenseCancelBtHint;
      end;
    if FileExists(ExpandEnvString(LicenseTxt)) then begin
       SelectProgMemo.WordWrap:=true;
       SelectProgMemo.LoadText(ExpandEnvString(LicenseTxt));
       SelectProgMemo.Visible:=true;
       LicConfirmBt.Enabled:=true;
    end else begin
       SelectProgMemo.WordWrap:=true;
       SelectProgMemo.Clear;
       SelectProgMemo.Lines.Add('Error!');
       SelectProgMemo.Lines.Add('License file "'+ExpandEnvString(LicenseTxt)+'" is missing.');
       SelectProgMemo.Visible:=true;
       LicConfirmBt.Enabled:=false;
    end;
    CaptionLabel.Caption:=LicenseCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Caption:=LicenseDeskriptionLabelCaption;
    DeskriptionLabel.Width:=SelectProgTree.Width ;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
   end else SelectProgMemo.Visible:=ShowState;
end;


procedure TNewProcessFm.ShowSelector(ShowState: boolean);
begin
   SelectProgTree.Visible:=ShowState;
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   CheckAllBt.Visible:=ShowState;
   CheckNoneBt.Visible:=ShowState;
   CheckDefBt.Visible:=ShowState;
   FastSelectLabel.Visible:=ShowState;
   PrevBt.Visible:=ShowState and (LicenseCheckNeedet or EnableWelcomeDlg or (StartTimerTime > 0));
   NextBt.Visible:=ShowState;
   ExpandBt.Visible:=ShowState;
   CollapseBt.Visible:=ShowState;
   if ShowState then begin
    PrevBt.Enabled:=true;
    NextBt.Caption:=SelectorNextBtCaption;
    NextBt.Hint:=SelectorNextBtHint;
    CaptionLabel.Caption:= SelectorCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Caption:=SelectorDeskriptionLabelCaption;
    DeskriptionLabel.Width:=RightPaneWidth - XSpacer*4;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
    FastSelectLabel.Caption:=FastSelectCaption;
    SelectProgTree.SetFocus;
   end;
end;

procedure TNewProcessFm.ShowPrepare(ShowState: boolean);
begin
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   SelectProgMemo.Visible:=ShowState;
   PrevBt.Visible:=ShowState;
   NextBt.Visible:=ShowState;
   CheckRebootBt.Visible:=ShowState;
   CheckPoweroffBt.Visible:=ShowState;
   CheckCloseBt.Visible:=ShowState;
   FastSelectLabel.Visible:=ShowState;
   if ShowState then begin
    PrevBt.Enabled:=true;
    NextBt.Caption:=ConfirmNextBtCaption;
    NextBt.Hint:=ConfirmNextBtHint;
    SelectProgMemo.Lines.BeginUpdate;
    try
     SelectProgMemo.WordWrap:=false;
     MakeSelectLog(SelectProgMemo.Lines);
     SelectProgMemo.UpdateText(false);
    finally
     SelectProgMemo.Lines.EndUpdate;
    end;
    CaptionLabel.Caption:= ConfirmCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
    DeskriptionLabel.Caption:=ConfirmDeskriptionLabelCaption;
    DeskriptionLabel.Width:=SelectProgTree.Width;
    FastSelectLabel.Caption:=RebotModeCaption;
    CheckRebootBt.Enabled:= not PeMode;
    CheckPoweroffBt.Enabled:= not PeMode;
    if RebootFlag then begin
         CheckRebootBt.Checked:=true;
         CheckPoweroffBt.Checked:=false;
         CheckCloseBt.Checked:=false;
         LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[4];
    end else
    if PowerOffFlag then begin
         CheckRebootBt.Checked:=false;
         CheckPoweroffBt.Checked:=true;
         CheckCloseBt.Checked:=false;
         LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[5];
    end else begin
         CheckRebootBt.Checked:=false;
         CheckPoweroffBt.Checked:=false;
         CheckCloseBt.Checked:=true;
         LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[6];
      end;
   end;
end;

procedure TNewProcessFm.ShowPreInstall(ShowState: boolean);
begin
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   ScipBt.Visible:=ShowState;
   ScipMi.Visible:=ShowState;
   ItemImage.Visible:=false;
   ScrShot.Visible:=false;
   if ShowState then begin
    DeskriptionLabel.Caption:= PreInstallDeskriptionLabelCaption;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer*2;
    DeskriptionLabel.Width:= SelectProgTree.Width;
    CaptionLabel.Caption:= PreInstallCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
   end;
end;

procedure TNewProcessFm.ShowInstall(ShowState: boolean);
begin
   AllLabel.Visible:=ShowState;
   GrpLabel.Visible:=ShowState;
   AllPrBar.Visible:=ShowState;
   GrpPrBar.Visible:=ShowState;
   MemoLabel1.Caption:='';
   MemoLabel1.Visible:=ShowState;
   MemoLabel2.Caption:='';
   MemoLabel2.Visible:=ShowState;
   ScrShot.Visible:=ShowState and ShowSkreenShots;
   CaptionLabel.Visible:=ShowState;
   DeskriptionLabel.Visible:=ShowState;
   ScipBt.Visible:=ShowState;
   ScipMi.Visible:=ShowState;
   ItemImage.Visible:=ShowState;
   if ShowState then begin
    if RestartInstall then CaptionLabel.Caption:= ShowProgressCaptionLabelRestartCaption
                        else CaptionLabel.Caption:= ShowProgressCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Caption:= '';
    ItemImage.Left:= LeftPaneWidth+XSpacer*2;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer*3 + 32;// + 10;
    DeskriptionLabel.Width:=RightPaneWidth - XSpacer*3 -32 ;
   end;
end;


procedure TNewProcessFm.ShowPostInstall(ShowState: boolean);
begin
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   ScipBt.Visible:=ShowState;
   ScipMi.Visible:=ShowState;
   ItemImage.Visible:=false;
   ScrShot.Visible:=false;
   if ShowState then begin
    CaptionLabel.Caption:= PostInstallCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Caption:=PostInstallDeskriptionLabelCaption;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer*2;
    DeskriptionLabel.Width:=RightPaneWidth - XSpacer*4 ;
   end;
end;

procedure TNewProcessFm.ShowFinish(ShowState: boolean);
begin
   DeskriptionLabel.Visible:=ShowState;
   CaptionLabel.Visible:=ShowState;
   ItemImage.Visible:=false;
   FinishBt.Visible:=ShowState and (not AutoClose);
   if ShowState then begin

    CaptionLabel.Caption:= FinishCaptionLabelCaption;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    if (not AutoClose) and ShowLog then begin
      SelectProgMemo.Lines.BeginUpdate;
      try
        SelectProgMemo.WordWrap:=false;
        SelectProgMemo.LoadText(GetLogFileName);
        SelectProgMemo.Hint:=LogMemoHint;
        SelectProgMemo.Visible:=true;
      finally
        SelectProgMemo.Lines.EndUpdate;
      end;
     DeskriptionLabel.Caption:=FinishLogDeskriptionLabelCaption;
     DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
     DeskriptionLabel.Width:=RightPaneWidth - XSpacer*2;
    end else begin
      SelectProgMemo.Visible:=false;
      DeskriptionLabel.Caption:=FinishDeskriptionLabelCaption;
      DeskriptionLabel.Left:=LeftPaneWidth+XSpacer*2;
      DeskriptionLabel.Width:=RightPaneWidth - XSpacer*4;
    end;
    CloseBt.Enabled:=false;
    TrayBt.Enabled:=false;
    //ProgressImg.Visible:=false;
   end else SelectProgMemo.Visible:=false;
end;

procedure TNewProcessFm.ShowReboot(ShowState: boolean);
begin
   RebootMsgLabel.Visible:=ShowState;
   RebootPrBar.Visible:=ShowState;
   NoRebootBt.Visible:=ShowState and not RebootSheduled;
   CaptionLabel.Visible:=ShowState;
   DeskriptionLabel.Visible:=ShowState;
   ItemImage.Visible:=false;
   if ShowState then begin
    CloseBt.Enabled:=false;
    RebootPrBar.MaxValue:=100;
    RebootPrBar.Progress:=RebootPrBar.MaxValue;
    if RebootSheduled then begin
       RebootTimer.Interval:=100;
       CaptionLabel.Caption:= RebootCaptionLabelCaptionReboot;
       RebootMsgLabel.Caption:=RebootMsgLabelRebootCaption;
       DeskriptionLabel.Caption:= RebootDeskriptionLabelContinueCaption;
    end else
    if RebootFlag  then begin
       CaptionLabel.Caption:= RebootCaptionLabelCaptionEnd;
       RebootMsgLabel.Caption:=RebootMsgLabelRebootCaption;
       DeskriptionLabel.Caption:= RebootDeskriptionLabelFinalCaption;
    end else
    if  PowerOffFlag then begin
       RebootMsgLabel.Caption:=RebootMsgLabelPowerOffCaption;
       DeskriptionLabel.Caption:=RebootDeskriptionLabelCaption;
       NoRebootBt.Caption:=NoPowerOffBtCaption;
       NoRebootBt.Hint:= NoPowerOffBtHint;
    end;
    CaptionLabel.Left:=LeftPaneWidth + (RightPaneWidth  - CaptionLabel.Width ) div 2;
    DeskriptionLabel.Left:=LeftPaneWidth+XSpacer;
    DeskriptionLabel.Width:=SelectProgTree.Width ;
   end;
end;

procedure TNewProcessFm.StartDelayTimerTimer(Sender: TObject);
begin
  StartDelayTimer.Enabled:=false;
  SetInstallState(isStartup);
end;

procedure TNewProcessFm.StartupProc;

  procedure UpdateFinishState;
  begin
   if PeMode then begin
      RebootFlag:=false;
      PowerOffFlag:=false;
   end;
   if RebootFlag then LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[4] else
   if PowerOffFlag then LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[5] else
   LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[6];
  end;

  procedure CheckTestMode(Mode:boolean);
  begin
   TestMode:=Mode;
   PeMode:=IsPeMode;
   if PeMode then TestModeLabel.Caption:= TestLabelCaption + ' PE mode'
             else TestModeLabel.Caption:=TestLabelCaption;
   TestModeLabel.Visible:=TestMode;
  end;

  procedure ContinueInstall;
  begin
     RestartInstall:=LoadInstallLog;
     if RestartInstall then ReloadLog;
     CheckTestMode(TestMode);
     SetInstallState(isPreInstall);
  end;

  procedure WrongIni;
  begin
    MessageBoxEx(Handle,PChar(NoConfigMsg),
              PChar(ConfigErrorCaption), MB_OK or MB_ICONERROR,LangId);
    //AddDebugMsg('Missing or invalid config file!');
    //AddDebugMsg('Fatal error, program termnnated.');
    ExitCode:= WRONG_INI;
    Application.Terminate;
    Abort;
  end;

  procedure WrongConfig;
  begin
    MessageBoxEx(Handle,PChar(NoAttdMsg),
                 PChar(ConfigErrorCaption),
                 MB_OK or MB_ICONERROR,LangId);
    AddDebugMsg('Missing or invalid anserver file!');
    AddDebugMsg('Fatal error, program termnnated.');
    ExitCode:= WRONG_SET;
    Application.Terminate;
    Abort;
  end;

  procedure CheckAdmin;
  begin
  if AdminRightsRequired and (not IsAdminLoggedOn) then
    begin
           MessageBoxEx(Handle,PChar(NoAdminRightsMsg),
                      PChar(NoAdminRightsCaption), MB_OK or MB_ICONERROR,LangId);
           AddDebugMsg('Admin Rights Required!');
           AddDebugMsg('Process run under not Admin Rights!');
           AddDebugMsg('Fatal error, program termnnated.');
           ExitCode:= WRONG_RIGHTS;
           Application.Terminate;
           Abort;
    end;
  end;

  procedure SetTray;
  begin
    if not PeMode and IsExplorerRuning then begin;
       TrayPresent:=true;
       TrayBt.Enabled:=true;
       TrayStage:=0;
       SetTrayIcon;
       TaskbarRestarted := RegisterWindowMessage('TaskbarCreated');
       if StayOnTop and FullScreenMode then begin
          ShowWindow(FindWindow('Shell_TrayWnd',''), SW_HIDE);
       end;
    end;
  end;

  procedure CheckLicenseViolated;
  begin
    if not CheckLicense then begin
                             MessageBox(Handle,PChar('License file (license.txt) not found in program dir.'#13#10'License violated!'#13#10#13#10'Program terminated!'),
                                        PChar('Fatal error'), MB_OK or MB_ICONERROR);
                             AddDebugMsg('Missing License file (license.txt)!');
                             AddDebugMsg('Fatal error, program termnnated.');
                             ExitCode:= WRONG_LIC;
                             Application.Terminate;
                             Abort;
                           end;
   if not CheckReadMe  then begin
                            MessageBox(Handle,PChar('Readme file (readme.txt) not found in program dir.'#13#10'License violated!'#13#10#13#10'Program terminated!'),
                                        PChar('Fatal error'), MB_OK or MB_ICONERROR);
                            AddDebugMsg('Missing Readme file (readme.txt)!');
                            AddDebugMsg('Fatal error, program termnnated.');
                            ExitCode:= WRONG_LIC;
                            Application.Terminate;
                            Abort;
                           end;
  end;

  procedure PlayMidi;
  begin
    if FileExists(SkinFolder + MIDI_BACKMIDI) then begin
           MidiPlay.MidiFile:=SkinFolder + MIDI_BACKMIDI;
           MidiPlay.Open;
           MidiPlay.Play(0,0);
     end;
  end;

begin
  if CheckCmdParam('force') then begin
     CheckTestMode(CheckCmdParam('test'));
     if CheckCmdParam('rest') then MainIni:= GetLastMainIni
                              else MainIni:= GetMainIni;
     if ValidateSetIni(MainIni) then begin
        GroupsLoadFromIni(MainIni);
        OpenLog(GetLogFileName,'Boa Software Post Installer V'+PrgVer,not CheckCmdParam('rest'));
        CheckLicenseViolated;
        InitInstallList;
        CheckAdmin;
        CleanRun;
        if not CheckCmdParam('rest') then AddCommonInfo;
        UpdateFinishState;
        BlockUserInput(EnableUserInput);
        AutoClose:=true;
        if CheckInstallLog and CheckCmdParam('rest')
         then
          begin
           PlayMidi;
           ContinueInstall;
          end
         else
            if ValidateConfig(GetConfigFile) and LoadConfig(GetConfigFile)
               then
                 begin
                  RestartInstall:=false;
                  PlayMidi;
                  SetInstallState(isPreInstall);
                 end
               else WrongConfig;
     end else WrongIni;
  end else begin
    MainIni:= GetLastMainIni;
    if (MainIni <> '') and (CheckCmdParam('rest') or
       (MessageBoxEx(Handle,
                     PChar(ConfirmRestartInstallMsg),
                     PChar(ConfirmRestartInstallCaption),
                     MB_YESNO	or MB_ICONQUESTION,
                     LangId) = IDYES)) then begin
       if ValidateSetIni(MainIni) then begin
          GroupsLoadFromIni(MainIni);
          OpenLog(GetLogFileName,'Boa Software Post Installer V'+PrgVer, false);
          CheckLicenseViolated;
          CheckTestMode(CheckCmdParam('test'));
          InitInstallList;
          CheckAdmin;
          CleanRun;
          UpdateFinishState;
          SetTray;
          PlayMidi;
          ContinueInstall;
      end else WrongIni;
    end else begin
      MainIni:= GetMainIni;
      if ValidateSetIni(MainIni) then begin
         GroupsLoadFromIni(MainIni);
         OpenLog(GetLogFileName,'Boa Software Post Installer V'+PrgVer, true);
         CheckLicenseViolated;
         CheckTestMode(CheckCmdParam('test'));
         InitInstallList;
         CheckAdmin;
         CleanRun;
         AddCommonInfo;
         UpdateFinishState;
         SetTray;
         LicenseCheckNeedet:=(LicenseTxt <> '');// and FileExists(ExpandEnvString(LicenseTxt));
         DeleteInstallLog;
         PrepareUserButton;
         PlayMidi;
         if (StartTimerTime > 0) and
            (not LicenseCheckNeedet) then SetInstallState(isWait)
                                     else if EnableWelcomeDlg
                                             then SetInstallState(isWelcome)
                                             else if LicenseCheckNeedet
                                                     then SetInstallState(isLicenseConfirm)
                                                     else SetInstallState(isSelectProg);
      end else WrongIni;
    end;
  end;
end;


procedure TNewProcessFm.PreInstallProc;
begin
  TrayTimer.Enabled:=true;
  LogSelectedItems;
  if not RestartInstall then  Preinstall;
  SetInstallState(isInstallProg);
end;

procedure TNewProcessFm.InstallProc;
var
  G,I,N,M:integer;
  TmpGroup:PInstallGroup;
  TmpItem:PInstallItem;
  ShotFile:string;
  ItemCount:integer;
  CurrentShotName:string;


  function GetGroupItemCount(AGroup:PInstallGroup):integer;
  var
    i:integer;
    ATmpItem:PInstallItem;
  begin
    result:=0;
    for I:=0 to AGroup.ItemList.Count-1 do begin
       ATmpItem:= PInstallItem(TmpGroup.ItemList[I]);
       if  ATmpItem^.Selected  then Inc(result);
    end;
  end;

  function GetGroupInstalledItemCount(AGroup:PInstallGroup):integer;
  var
    i:integer;
    ATmpItem:PInstallItem;
  begin
    result:=0;
    for I:=0 to AGroup.ItemList.Count-1 do begin
       ATmpItem:= PInstallItem(TmpGroup.ItemList[I]);
       if  ATmpItem^.Selected and ATmpItem^.Installed then Inc(result);
    end;
  end;

begin
   AllPrBar.MaxValue:= GetSelGroupCount;
   AllPrBar.Progress:= GetInstalledGroupCount;
   CurrentShotName:='';
   N:=GetInstalledGroupCount;
   for G:=0 to GetGroupCount-1 do begin
    if EndInstallProcess then exit;
    if RebootSheduled then break;
    TmpGroup:=GetGroupFromId(G);
    if (TmpGroup<> nil) and
       (GetGroupItemCount(TmpGroup) > 0 ) and
       (GetGroupItemCount(TmpGroup)> GetGroupInstalledItemCount(TmpGroup))
       then begin
     MemoLabel1.Caption:=SafeFormat('%s'#13#10'%s',[MemoLabel1Caption, TmpGroup^.Group]);
     GrpPrBar.MaxValue:=GetGroupItemCount(TmpGroup);
     GrpPrBar.Progress:=GetGroupInstalledItemCount(TmpGroup);
     M:=0;
     ItemCount:= GetGroupItemCount(TmpGroup);
     for I:=0 to TmpGroup.ItemList.Count-1 do begin
       if EndInstallProcess then exit;
       TmpItem:= PInstallItem(TmpGroup.ItemList[I]);
       if TmpItem^.Fixed then TmpItem^.Selected:= TmpItem^.SelectDefault;
       if  TmpItem^.Selected and not TmpItem^.Installed then begin
         WriteLog('');
         WriteLog(TimeToStr(Now)+ ' '+TmpItem^.Caption);
         WriteLog('- begin -------------------------------------------------------------------------');
         WriteLog('');
         if DetaliseLog then begin
           WriteLog('Shot file name ' + GetShotFile(TmpItem));
           if TmpItem^.IconFileName <> '' then  WriteLog('Icon file name ' + TmpItem^.IconFileName)
                                          else  WriteLog('Icon file name ' + CommonIconLibFile);
           WriteLog('Icon numer ' + IntToStr(TmpItem^.IconNumber));
           WriteLog('ImageId in small list ' + IntToStr(TmpItem^.ImageId));
           WriteLog('ImageId in big list ' + IntToStr(TmpItem^.ImageIdBig));
         end;
         MemoLabel2.Caption:=SafeFormat('%d %s %d', [N+1, MemoLabel2Caption, GetSelGroupCount]); //GetGroupCount]);
         DeskriptionLabel.Caption:= SafeFormat('%s %s'#13#10#13#10'%s',[InstallProcDeskriptionLabelCaption, TmpItem^.Caption, DelToLf(TmpItem^.Description)]);
         DeskriptionLabel.Width:=SelectProgTree.Width - (DeskriptionLabel.Left - SelectProgTree.Left);
         DestroyIcon(ItemImage.Picture.Icon.Handle);   // Fix small GDI Leak !!!
         BigImg.GetIcon(TmpItem^.ImageIdBig, ItemImage.Picture.Icon);
         if ShowSkreenShots then begin
          try
           ShotFile:=GetShotFile(TmpItem);
           if ShotFile <> '' then begin if FileExists(ShotFile) then begin
                                   if CurrentShotName <> ShotFile then
                                     ScrShot.Picture.LoadFromFile(ShotFile);
                                   end else begin
                                     ScrShot.Picture:=nil;
                                     WriteLog('Warning! Shot file ' + ShotFile +' not found.');
                                     ShotFile:='';
                                   end;
                                  end
                            else  ScrShot.Picture:=nil;
           CurrentShotName:= ShotFile;
           except
            WriteLog('Warning! Shot file ' + ShotFile +' is bad image.');
           end;
         end;
         GrpPrBar.AddProgress(1);
         if M = ItemCount -1 then
           AllPrBar.Progress:= GetInstalledGroupCount +1;
         WriteLog('');  
         InstallItemInstall(TmpItem);
         WriteLog('- end ---------------------------------------------------------------------------');
         Inc(M);
         if RebootSheduled then break;             
       end;
     end;
     Inc(N);
    end;
    AllPrBar.Progress:= GetInstalledGroupCount;
  end;
  if RebootSheduled then SetInstallState(isReboot)
                    else SetInstallState(isPostInstall);
end;

procedure TNewProcessFm.PostInstallProc;
begin
  PostInstall;
  TrayTimer.Enabled:=false;
  TrayStage:=0;
  ModifyTrayIcon(TrayStage);
  if (RebootFlag or PowerOffFlag) and not PeMode then SetInstallState(isReboot)
                                                 else SetInstallState(isFinish);
end;

procedure TNewProcessFm.SetInstallState(State: TInstallState);
var
  I:TStageLabels;
begin
 if (InstallState = State) and (InstallState <> isStartup) then exit;
 Application.CancelHint;

 InstallState:=State;

 case InstallState of

   isStartup   :  begin
                    HelpIndex:=0;
                    StartupProc;
                  end;


   isWait      :  begin
                    HelpIndex:=0;
                    BeginUpdate;
                    try
                     StartinstallDelay:=StartTimerTime*100;
                     StartDefautInstallTimer.Enabled:=true;
                     ShowWait(true);
                    finally
                     EndUpdate;
                    end;
                  end;

   isWelcome   :  begin
                    HelpIndex:=0;
                    BeginUpdate;
                    try
                     ShowSelector(false);
                     ShowLicense(false);
                     ShowWelcome(true);
                    finally
                     EndUpdate;
                    end;
                  end;

   isLicenseConfirm: begin
                     HelpIndex:=0;
                     BeginUpdate;
                     try
                      LeftLabels[Ord(slSelect)].CheckState:=csCurrent;
                      StartDefautInstallTimer.Enabled:=false;
                      ShowWait(false);
                      ShowWelcome(false);
                      ShowSelector(false);
                      ShowLicense(true);
                     finally
                      EndUpdate;
                     end;
                  end;

   isSelectProg:  begin
                    HelpIndex:=1;
                    BeginUpdate;
                    try
                     LeftLabels[Ord(slSelect)].CheckState:=csCurrent;
                     StartDefautInstallTimer.Enabled:=false;
                     ShowLicense(false);
                     ShowWelcome(false);
                     ShowWait(false);
                     if SelectProgTree.Items.Count = 0 then FillTreeView(SelectProgTree, true, true);
                     ShowPrepare(false);
                     ShowSelector(true);
                    finally
                     EndUpdate;
                    end;
                  end;

   isPrepare:     begin
                    HelpIndex:=2;
                    BeginUpdate;
                    try
                     LeftLabels[Ord(slSelect)].CheckState:=csCurrent;
                     ShowSelector(false);
                     ShowPrepare(true);
                    finally
                     EndUpdate;
                    end;
                  end;

   isPreInstall:  begin
                    HelpIndex:=3;
                    BeginUpdate;
                    try
                     for i:=slSelect to slSelect do
                         LeftLabels[Ord(I)].CheckState:=csAfter;
                     LeftLabels[Ord(slPrepare)].CheckState:=csCurrent;
                     ShowWelcome(false);
                     ShowWait(false);
                     ShowPrepare(false);
                     ShowSelector(false);
                     ShowPreInstall(true);
                    finally
                     EndUpdate;
                    end;
                    PreinstallProc;
                   end;


   isInstallProg: begin
                    HelpIndex:=3;
                    BeginUpdate;
                    try
                     for i:=slSelect to slPrepare do
                         LeftLabels[Ord(I)].CheckState:=csAfter;
                     LeftLabels[Ord(slInstall)].CheckState:=csCurrent;
                     ShowPreInstall(true);
                     ShowInstall(true);
                    finally
                     EndUpdate;
                    end;
                    InstallProc;
                  end;

   isPostInstall: begin
                    HelpIndex:=4;
                    BeginUpdate;
                    try
                     for i:=slSelect to slInstall do
                         LeftLabels[Ord(I)].CheckState:=csAfter;
                     LeftLabels[Ord(slCleanup)].CheckState:=csCurrent;
                     ShowInstall(false);
                     ShowPostInstall(true);
                    finally
                     EndUpdate;
                    end;
                    PostInstallProc;
                  end;

   isReboot:      begin
                    HelpIndex:=5;
                    BeginUpdate;
                    try
                     for i:=slSelect to slCleanup do
                         LeftLabels[Ord(I)].CheckState:=csAfter;
                     LeftLabels[Ord(slFinish)].CheckState:=csCurrent;
                     if RebootSheduled then ShowInstall(false);
                     ShowPostInstall(false);
                     ShowReboot(true);
                    finally
                     EndUpdate;
                    end;
                    if not RebootSheduled then PlaySnd(SkinFolder+ SND_DONE, false);
                    RebootTimer.Enabled:=true;
                    LeftLabels[Ord(slFinish)].CheckState:=csAfter;
                  end;

   isFinish:        begin
                     Closelog(true);
                     HelpIndex:=6;
                     BeginUpdate;
                     try
                      for i:=slSelect to slCleanup do
                          LeftLabels[Ord(I)].CheckState:=csAfter;
                      LeftLabels[Ord(slFinish)].CheckState:=csCurrent;
                      ShowPostInstall(false);
                      ShowFinish(true);
                     finally
                      EndUpdate;
                     end;
                     PlaySnd(SkinFolder+ SND_DONE,AutoClose);
                     LeftLabels[Ord(slFinish)].CheckState:=csAfter;
                     if AutoClose then close;
                  end;
 end;
end;

procedure TNewProcessFm.CloseClick(Sender: TObject);
begin
 StartDefautInstallTimer.Enabled:=false;
 if EnableCloseMsg and
    (MessageBoxEx(Handle,
                  PChar(NoCloseDlgMsg),
                  PChar(HelpMbCaption),
                  MB_YESNO	or MB_ICONQUESTION, LangId) <> mrYES) then begin
 end else begin
     EndInstallProcess:=true;
   if InProgress then begin
     KillItem;
     Delay(100);
   end;
   if RebootSheduled or InProgress then begin
     ExitCode:=BREAK_INSTALL;
     AddDebugMsg('');
     AddDebugMsg('Installation is terminated manually!!!');
   end else begin
    ExitCode:=CANCEL_EXIT;
    AddDebugMsg('');
    AddDebugMsg('Installation is cancelled manually!!!');
   end;
   NewProcessFm.Update;
   Application.ProcessMessages;
   PlaySnd(SkinFolder+ SND_BREAK,true);
   Close;
  end
end;


procedure TNewProcessFm.ScipBtClick(Sender: TObject);
begin
   KillItem;
end;


procedure TNewProcessFm.TrayClick(Sender: TObject);
begin
    DrawAnimation(NewProcessFm.Visible);
end;

procedure TNewProcessFm.HelpClick(Sender: TObject);
begin
   MessageBoxEx(Handle,PChar(HelpTexts[HelpIndex]),
              PChar(HelpMbCaption), MB_OK or MB_ICONINFORMATION,LangId);
end;

procedure TNewProcessFm.TrayMenuClick(Sender: TObject);
begin
   DrawAnimation(NewProcessFm.Visible);
end;

procedure TNewProcessFm.NoRebootClick(Sender: TObject);
begin
   RebootTimer.Enabled:=false;
   AddDebugMsg('');
   AddDebugMsg('Shutdown process terminated manually');
   Close;
end;

procedure TNewProcessFm.ExpandClick(Sender: TObject);
begin
   SelectProgTree.FullExpand;
   if SelectProgTree.Items.Count>0 then
   SelectProgTree.Items[0].MakeVisible;
   StartDefautInstallTimer.Enabled:=false;
end;

procedure TNewProcessFm.CollapseClick(Sender: TObject);
begin
   SelectProgTree.FullCollapse;
   StartDefautInstallTimer.Enabled:=false;
end;


procedure TNewProcessFm.RebootTimerTimer(Sender: TObject);
begin
   if RebootPrBar.Progress = 0 then begin
    RebootTimer.Enabled:=false;
    if not EndInstallProcess and RebootSheduled then AddRunOnce;
    if TestMode then Close else
    if PeMode then Close else
    if RebootSheduled then RebootSystem else
    if PowerOffFlag then ShutdownSystem else
    if RebootFlag then RebootSystem;
   end else
   RebootPrBar.Progress:= RebootPrBar.Progress - 5;
end;


{


procedure TNewProcessFm.NodeStateChange(Node:TTreeNode);
var
  ParentNode: TTreeNode;
  I:integer;
  Intermediate: boolean;
  AStateIndex:integer;

  function SetSelection(ANode: TTreeNode; AIndex: integer):boolean;
   var
     TempState:boolean;
     ChangeState:boolean;
  begin
  result:=true;
  ChangeState:=true;
  if (ANode.Level = 1) and
     (ANode.Data <> nil)  then begin
       if PInstallItem(ANode.Data)^.Fixed then begin
                                                result:= ANode.StateIndex = AIndex+3 ;
                                                ChangeState:=false

                                          end else begin
          TempState:= AIndex=2;
          if TempState <> PInstallItem(ANode.Data).Selected then begin
              PInstallItem(ANode.Data).Selected:= TempState;
              if TempState then CheckExclude(PInstallItem(ANode.Data));
              CheckDepends(PInstallItem(ANode.Data));
          end;
       end;
      end
   else
     if (ANode.Level = 0) and
        (ANode.Data <> nil) then begin
           result:=not PInstallGroup(ANode.Data)^.Fixed;
           if result then PInstallGroup(ANode.Data).Selected:=AIndex-1;
        end;
     if result and ChangeState then ANode.StateIndex:=AIndex;
  end;

begin
 if (Node<> nil) then begin
         if (Node.StateIndex = 1) then AStateIndex:=2
                                  else AStateIndex:=1;

    if SetSelection(Node, AStateIndex) then begin
     if Node.Count > 0 then
     begin
        Intermediate:=false;
        for i:=Node.Count-1  downto 0 do SetSelection(Node.Item[I], AStateIndex);
        for i:=0 to Node.Count-1 do begin
         if AStateIndex <> Node.Item[I].StateIndex then
         begin
           Intermediate:=true;
           Break;
         end;
       end;
       if Intermediate then SetSelection(Node, 3);
     end;

     ParentNode:=Node.Parent;
     if ParentNode<> nil then begin
       Intermediate:=false;
       for i:=0 to ParentNode.Count-1 do begin
         if AStateIndex <> ParentNode.Item[I].StateIndex then
         begin
           Intermediate:=true;
           Break;
         end;
       end;
       if Intermediate then SetSelection(ParentNode, 3)
                       else SetSelection(ParentNode, AStateIndex);
     end;
   end;
 end;
end;
}

procedure TNewProcessFm.NodeStateChange(Node:TTreeNode);
var
  I:integer;
  AStateIndex:integer;
  IGroup: PInstallGroup;
  IItem: PInstallItem;

begin
//SelectProgTree.Items.BeginUpdate;
//try
 if (Node<> nil) and (Node.Data <> nil)then begin
   if Node.Level = 0 then  begin
      IGroup:= PInstallGroup(Node.Data);
      if IGroup.Fixed then exit;
      IGroup.St3Checked:= not IGroup.St3Checked;
      AStateIndex:= IGroup.Selected;
      if IGroup.Selected =1 then IGroup.Selected :=0
      else if IGroup.Selected = 0 then IGroup.Selected :=1;
      AStateIndex:=SetGroupSelected(IGroup,IGroup.St3Checked);
      IGroup.INode.StateIndex:= AStateIndex +1;
      IItem:=nil;
   end else begin
      IItem:= PInstallItem(Node.Data);
      if IItem.Fixed then exit;
      IGroup:= PInstallGroup(IItem.Parent);
      IItem.Selected:= not IItem.Selected;
      CheckExclude(IItem);
      CheckDepends(IItem);
   end;

   for I := 0 to IGroup.ItemList.Count - 1 do  begin
     if PInstallItem(IGroup.ItemList[i]).Visible then begin
        AStateIndex:= 1+Ord(PInstallItem(IGroup.ItemList[i]).Selected);
        if PInstallItem(IGroup.ItemList[i]).Fixed then AStateIndex:=AStateIndex+3;
        if PInstallItem(IGroup.ItemList[i]).INode <> nil then PInstallItem(IGroup.ItemList[i]).INode.StateIndex:= AStateIndex;
      end;
   end;

   AStateIndex:=CheckGroupSelected(IGroup);
   IGroup.Selected:= AStateIndex;
   if AStateIndex < 2 then  IGroup.St3Checked:= AStateIndex =1;
   
   if IGroup.Fixed then AStateIndex:=AStateIndex+3;
   IGroup.INode.StateIndex:= AStateIndex +1;
 end;
//finally
  //SelectProgTree.Items.EndUpdate;
//end;
end; 


procedure TNewProcessFm.SelectProgTreeClick(Sender: TObject);
var
  Node: TTreeNode;
  P:TPoint;
  HT: THitTests;
begin
 GetCursorPos(P);
 P:=SelectProgTree.ScreenToClient(P);
 Node:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 if (Node<> nil) and
    (htOnStateIcon in HT) then begin
                                   NodeStateChange(Node);
                                   PlaySnd(SkinFolder+SND_CLICK,false);
                               end else

  if (Node<> nil) and
     (htOnIcon	in HT) and
      GlobalNoCollapseNode then begin
      if Node.Expanded then Node.Collapse(false)
                       else Node.Expand(false)
  end;;
end;


procedure TNewProcessFm.SelectProgTreeExpanding(Sender: TObject;
  Node: TTreeNode; var AllowExpansion: Boolean);
var
  ANode: TTreeNode;
  P:TPoint;
  HT: THitTests;
begin
 GetCursorPos(P);
 P:=SelectProgTree.ScreenToClient(P);
 ANode:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 AllowExpansion:= not( (ANode<> nil) and (htOnStateIcon in HT) );
end;


procedure TNewProcessFm.SelectProgTreeCollapsing(Sender: TObject;
  Node: TTreeNode; var AllowCollapse: Boolean);
var
  ANode: TTreeNode;
  P:TPoint;
  HT: THitTests;
  Prevent:boolean;
begin
 GetCursorPos(P);
 Prevent:=false;
 P:=SelectProgTree.ScreenToClient(P);
 ANode:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) then begin
   Prevent:=PInstallGroup(Node.Data)^.Blocked;
 end;
 AllowCollapse:= not( ((ANode<> nil) and (htOnStateIcon in HT)) or Prevent);
end;

procedure TNewProcessFm.SelectProgTreeExpanded(Sender: TObject;
  Node: TTreeNode);
begin
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) and
  (PInstallGroup(Node.Data)^.Blocked) then begin
   Node.ImageIndex:=2;
   Node.SelectedIndex:=2;
  end else begin
   Node.ImageIndex:=1;
   Node.SelectedIndex:=1;
  end
end;

procedure TNewProcessFm.SelectProgTreeCollapsed(Sender: TObject;
  Node: TTreeNode);
begin
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) and
  (PInstallGroup(Node.Data)^.Blocked) then begin
   Node.ImageIndex:=2;
   Node.SelectedIndex:=2;
  end else begin
   Node.ImageIndex:=0;
   Node.SelectedIndex:=0;
  end
end;


procedure TNewProcessFm.NavigateClick(Sender: TObject);
begin
   if (TComponent(Sender).Tag = 1) then begin
       if (InstallState = isPrepare)
            then SetInstallState(isSelectProg)
       else if (InstallState = isSelectProg) and LicenseCheckNeedet
            then SetInstallState(isLicenseConfirm)
       else if (InstallState = isLicenseConfirm) and (EnableWelcomeDlg or (StartTimerTime > 0))
            then SetInstallState(isWelcome)
       else if (InstallState = isSelectProg) and (EnableWelcomeDlg or (StartTimerTime > 0))
            then SetInstallState(isWelcome);
   end;
   if (TComponent(Sender).Tag = 2) then begin
       if LicenseCheckNeedet and (InstallState = isWelcome)
            then SetInstallState(isLicenseConfirm)
       else if (InstallState = isLicenseConfirm)
            then begin
                   if LicConfirmBt.Checked then SetInstallState(isSelectProg)
                                           else if MessageBoxEx(Handle,
                                                                PChar(CheckLicenseLicenseDlgMsg),
                                                                PChar(HelpMbCaption),
                                                                MB_YESNO	or MB_ICONQUESTION,
                                                                LangId) = mrYES then begin
                                                                                       AddDebugMsg('EULA not assepted.');
                                                                                       AddDebugMsg('Fatal error, program termnnated.');
                                                                                       ExitCode:= NOT_LICASSEPTED;
                                                                                       Close;
                                                                                     end;
                 end
       else if (InstallState = isWelcome)
            then SetInstallState(isSelectProg)
       else if (InstallState = isWait)
            then SetInstallState(isSelectProg)
       else if (InstallState = isSelectProg)
            then SetInstallState(isPrepare)
       else if (InstallState = isPrepare)
            then SetInstallState(isPreInstall);
   end
end;

procedure TNewProcessFm.UserFuncClick(Sender: TObject);
begin
  with UserButton[TComponent(Sender).Tag] do
   StartItem(Self,RootInstallDir,Folder,Caption,Command,Text);
end;

procedure TNewProcessFm.CheckSelectClick(Sender: TObject);
 var
  Node: TTreeNode;
  I:Integer;

  procedure SetDefaultSelection(ANode: TTreeNode);
   var
    SelIndex: Integer;
  begin
  SelIndex:=Node.StateIndex;
  if (ANode.Level = 1) and
       (ANode.Data <> nil)
         then begin
               SelIndex:=ord(PInstallItem(ANode.Data)^.Selected)+1;
               if PInstallItem(ANode.Data)^.Fixed then inc(SelIndex,3);
         end
   else
     if (ANode.Level = 0) and
        (ANode.Data <> nil)
           then begin
              SelIndex:=PInstallGroup(ANode.Data)^.Selected+1;
              if PInstallGroup(ANode.Data)^.Fixed then  inc(SelIndex,3);
           end;
     Node.StateIndex:=SelIndex;
  end;

begin
  case TComponent(Sender).Tag of
   1: SetState(true);
   2: SetState(false);
   3: SetDefault;
  end;
  for I:=0 to SelectProgTree.Items.Count-1 do begin
    Node:=SelectProgTree.Items[I];
    SetDefaultSelection(Node);
  end;
end;

procedure TNewProcessFm.CheckFinishModeClick(Sender: TObject);
begin
 case TComponent(Sender).Tag of
   1: begin
         RebootFlag:= true;
         PowerOffFlag:=false;
         CheckRebootBt.Checked:=true;
         CheckPoweroffBt.Checked:=false;
         CheckCloseBt.Checked:=false;
      end;
   2: begin
         RebootFlag:= false;
         PowerOffFlag:=true;
         CheckRebootBt.Checked:=false;
         CheckPoweroffBt.Checked:=true;
         CheckCloseBt.Checked:=false;
       end;
   3: begin
         RebootFlag:= false;
         PowerOffFlag:=false;
         CheckRebootBt.Checked:=false;
         CheckPoweroffBt.Checked:=false;
         CheckCloseBt.Checked:=true;
      end;
  end;
  if RebootFlag then LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[4] else
  if PowerOffFlag then LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[5] else
  LeftLabels[High(LeftLabels)].Caption:= LabelCaptions[6];
end;

procedure TNewProcessFm.SelectProgTreeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  NewHint:string;
  Node:TTreeNode;
  Temp:string;
begin
 Node:=SelectProgTree.GetNodeAt(X, Y);
 if Node <> nil then begin
    if (Node.Level = 1) and
      (Node.Data <> nil) then begin
                            NewHint:=DelToLf(PInstallItem(Node.Data)^.Description);
                            if GlobalExtendInfo then begin
                              if PInstallItem(Node.Data)^.Fixed then NewHint:= NewHint+#13#10+HintNoChangeSelect;
                              if PInstallItem(Node.Data)^.RebootNeed then NewHint:= NewHint+#13#10+ HintNeedReboot;
                              Temp:=GetExcludeString(Node.Data);
                              if Temp<> '' then  NewHint:= NewHint+ #13#10+ HintExcludeItems + #13#10+ Temp;
                              Temp:=GetDependsString(Node.Data);
                              if Temp<> '' then  NewHint:= NewHint+ #13#10+ HintDependsItems + #13#10+ Temp;
                            end;
                         end
   else
   if (Node.Level = 0) and
      (Node.Data <> nil) then NewHint:=DelToLf(PInstallGroup(Node.Data)^.Description)
   else NewHint:='';
 end else NewHint:='';
 if SelectProgTree.Hint <> NewHint then begin
    SelectProgTree.Hint:=NewHint;
    Application.CancelHint;
 end;
end;

procedure TNewProcessFm.SelectProgTreeKeyPress(Sender: TObject;
  var Key: Char);
  var 
      Msg:TMessage;
begin
 if (Key = ' ') or (Key = #13) then begin
    Key:=#0;
    NodeStateChange(SelectProgTree.Selected);
 end;
end;


procedure TNewProcessFm.SelectProgTreeCustomDrawItem(
  Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState;
  var DefaultDraw: Boolean);
begin
  if  Node.Level = 0 then begin
     Sender.Canvas.Font.Color:= TreeFontGroupColor;
     //Sender.Canvas.Font.Size:= SelectProgTree.Font.Size+1;
     Sender.Canvas.Font.Style:= Sender.Canvas.Font.Style +[fsBold];
   end else begin
     //Sender.Canvas.Font.Size:= SelectProgTree.Font.Size-1;
     Sender.Canvas.Font.Style:= Sender.Canvas.Font.Style -[fsBold];
   end;
  DefaultDraw:=true;
end;

procedure TNewProcessFm.StartDefautInstallTimerTimer(Sender: TObject);
var
 Sek,Min:integer;
begin
   dec(StartinstallDelay,10);
   if StartinstallDelay < 0 then begin
    StartDefautInstallTimer.Enabled:=false;
    AddDebugMsg('Wait time is out. Start install to default settings');
    AddDebugMsg('');
    SetInstallState(isPreInstall);
   end else begin
     Min:=Trunc(StartinstallDelay / 6000);
     Sek:=Trunc((StartinstallDelay - Min*6000) /100);
     TimerMsg.Caption:=SafeFormat('%2.2d:%2.2d',[Min,Sek]);
   end;
end;


procedure TNewProcessFm.FinishClick(Sender: TObject);
begin
  Close;
end;

procedure TNewProcessFm.CopyRightLabelClick(Sender: TObject);
begin

  MessageBoxEx(NewProcessFm.Handle,PChar(GetAboutInfo),
             PChar(AboutCaption), MB_OK or MB_ICONINFORMATION, LangId);
end;

procedure TNewProcessFm.TrayTimerTimer(Sender: TObject);
begin
   inc(TrayStage);
   if TrayStage > TrayIconImageList.Count-1 then TrayStage:=1;
   ModifyTrayIcon(TrayStage);
end;

procedure TNewProcessFm.LicConfirmBtClick(Sender: TObject);
begin
  LicConfirmBt.Checked:=not LicConfirmBt.Checked;
    if LicConfirmBt.Checked then begin
        NextBt.Caption:=SelectorNextBtCaption;
        NextBt.Hint:=SelectorNextBtHint;
      end
      else begin
        NextBt.Caption:=CheckLicenseCancelBtCaption;
        NextBt.Hint:=CheckLicenseCancelBtHint;
      end;
 // NextBt.Enabled:=LicConfirmBt.Checked;
end;

procedure TNewProcessFm.FormShortCut(var Msg: TWMKey;
  var Handled: Boolean);
var
  TmpShot:TBitmap;
  MyShot:TJpegImage;
  ShotName:string;
  DeskTopDC:HDC;
  DeskTopCanvas: TCanvas;
  DeskTopRect:TRect;
  ImgRect:TRect;
begin
  if  (Msg.CharCode = VK_F10) and
       MakeShotsEnable then begin

  TmpShot:=TBitmap.Create;
  TmpShot.PixelFormat:= pf32bit;
  MessageBeep(MB_ICONQUESTION	);
  try
    if AlphaBlendLevel = 255 then  DeskTopDC := GetDC(GetDeskTopWindow)
                             else  DeskTopDC := GetDC(Handle);
    DeskTopCanvas := TCanvas.Create;
    try
      DeskTopCanvas.Handle := DeskTopDC;
      DeskTopRect := Rect(NewProcessFm.Left,
                          NewProcessFm.Top,
                          NewProcessFm.Left + NewProcessFm.Width,
                          NewProcessFm.Top + NewProcessFm.Height);
      TmpShot.Height:= NewProcessFm.Height;
      TmpShot.Width := NewProcessFm.Width;
      ImgRect:=Rect(0,0,TmpShot.Width,TmpShot.Height);
      TmpShot.Canvas.CopyRect(ImgRect, DeskTopCanvas, DeskTopRect);
      if AlphaBlendLevel = 255 then  ReleaseDC(GetDeskTopWindow, DeskTopDC)
                               else  ReleaseDC(Handle, DeskTopDC);
    finally
      DeskTopCanvas.Free;
    end;
    MyShot:=TJpegImage.Create;
    try
     ShotName:= 'Shots_'+DateToStr(Now)+'_'+TimeToStr(Now);
     ShotName:=StringReplace(ShotName,':','',[rfReplaceAll, rfIgnoreCase]);
     ShotName:=StringReplace(ShotName,'.','',[rfReplaceAll, rfIgnoreCase]);
     ShotName:=ExtractFilePath(Application.ExeName)+ ShotName +'.jpg';
     MyShot.CompressionQuality:=80;
     MyShot.Assign(TmpShot);
     MyShot.Compress;
     try
       MyShot.SaveToFile(ShotName);
     except
     end
    finally
      MyShot.Free;
    end;
  finally
    TmpShot.Free;
  end;
  handled:=true;
  end else handled:= false;
end;

procedure TNewProcessFm.SelectProgMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (InstallState = isWait) and
     StartDefautInstallTimer.Enabled then EndWait;
end;

procedure TNewProcessFm.SelectProgMemoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if (InstallState = isWait) and
      StartDefautInstallTimer.Enabled then EndWait;
end;

procedure TNewProcessFm.MiMeasureItem(Sender: TObject;
  ACanvas: TCanvas; var Width, Height: Integer);
begin
  Width:=Width+LeftMargin.Width+8;
  if TMenuItem(Sender).Caption <> '-' then Height:=TrayImg.Height + 4;
end;

procedure DoDrawText(Item: TMenuItem;ACanvas: TCanvas; const ACaption: string;
  var Rect: TRect; Selected: Boolean; Flags: Longint);
var
  Text: string;
  R: TRect;
begin
  Text := ACaption;
  if (Flags and DT_CALCRECT <> 0) and ((Text = '') or
    (Text[1] = cHotkeyPrefix) and (Text[2] = #0)) then Text := Text + ' ';
  with ACanvas do
  begin
    if Text = cLineCaption then
    begin
      if Flags and DT_CALCRECT = 0 then
      begin
        R := Rect;
        Inc(R.Top, 4);
        DrawEdge(Handle, R, EDGE_ETCHED, BF_TOP);
      end;
    end
    else
    begin
      Brush.Style := bsClear;
      if Item.Default then
        Font.Style := Font.Style + [fsBold];
      if not Item.Enabled then
      begin
        if not Selected then
        begin
          OffsetRect(Rect, 1, 1);
          Font.Color := clBtnHighlight;
          DrawText(Handle, PChar(Text), Length(Text), Rect, Flags);
          OffsetRect(Rect, -1, -1);
        end;
        if Selected and (ColorToRGB(clHighlight) = ColorToRGB(clBtnShadow)) then
          Font.Color := clBtnHighlight else
          Font.Color := clBtnShadow;
      end;
      DrawText(Handle, PChar(Text), Length(Text), Rect, Flags);
    end;
  end;
end;                

procedure TNewProcessFm.TrayMenuDrawItem(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; State: TOwnerDrawState);
  
const
  Alignments: array[TPopupAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
  EdgeStyle: array[Boolean] of Longint = (BDR_RAISEDINNER, BDR_SUNKENOUTER);
var
  Alignment: TPopupAlignment;
  DrawGlyph: Boolean;
  GlyphRect, SaveRect: TRect;
  DrawStyle: Longint;
  Offset:integer;

  Selected: Boolean;

  procedure NormalDraw(Item: TMenuItem);
  begin
    with ACanvas, Item do
    begin
      begin
        if (odSelected in State) or (odHotLight in State) then
        begin
            Brush.Color := clMenuHighlight;
            Font.Color := clHighlightText;
        end
      end;
      SaveRect.Left := ARect.Left;
      SaveRect.Top := ARect.Top;
      SaveRect.Bottom := ARect.Bottom;
      SaveRect.Right := ARect.Right;

      SaveRect.Left := SaveRect.Left + Offset;
      FillRect(SaveRect);
      Alignment := paLeft;
      GlyphRect.Left := SaveRect.Left + 4;
      GlyphRect.Right := SaveRect.Left + 4 + TrayImg.Width;
      GlyphRect.Top := SaveRect.Top + 2;
      if Caption = cLineCaption then
      begin
        FillRect(SaveRect);
        GlyphRect.Left := 0;
        GlyphRect.Right := Offset;
        DrawGlyph := false;
      end
      else
      begin
           DrawGlyph := true;
           if (ImageIndex > -1) and (ImageIndex < TrayImg.Count) then
              TrayImg.Draw(ACanvas, GlyphRect.Left, GlyphRect.Top, ImageIndex, Enabled);
          if Checked then
          begin
            Dec(GlyphRect.Right);
            Dec(GlyphRect.Bottom);
          end;
      end;
      if DrawGlyph then SaveRect.Left := GlyphRect.Right + 6;
      Inc(SaveRect.Left, 1);
      Dec(SaveRect.Right, 1);
      DrawStyle := DT_EXPANDTABS or DT_SINGLELINE or Alignments[Alignment];
      if odDefault in State then
        Font.Style := [fsBold];
      DoDrawText(Item, ACanvas, Caption, SaveRect, Selected, DrawStyle or DT_CALCRECT or DT_NOCLIP);
      OffsetRect(SaveRect, 0, ((ARect.Bottom - ARect.Top) - (SaveRect.Bottom - SaveRect.Top)) div 2);
      DoDrawText(Item, ACanvas, Caption, SaveRect, Selected, DrawStyle);
      ACanvas.Draw(0,0, LeftMargin.Picture.Bitmap);
    end;
  end;

begin
   Offset:=LeftMargin.Width+1;
   NormalDraw(TMenuItem(Sender));
end;

end.



