{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{                                                                             }
{  BS Post Installer -  Program for automated installation of applications    }
{                                                                             }
{  Copyright  2005-2007 Yuri Safonow aka Boa aka BoaSoft                     }
{  Kursk, Russia.                                                             }
{  @-mail:  boa@kursknet.ru                                                   }
{  My home page :  http://www.kursknet.ru\~boa                                }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  This software absolutely free. BS Post Installer it is distributed         }
{  "as is", without what or obligations and support for my part.              }
{                                                                             }
{  This program is distributed in the hope that it will be useful,            }
{  but WITHOUT ANY WARRANTY; without even the implied warranty of             }
{  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       }
{                                                                             }
{ --------------------------------------------------------------------------- }
{                                                                             }
{  For additional information, please contact me:                             }
{   primary mail :     boa@kursknet.ru                                        }
{   or second mail:    boasoftware@narod.ru                                   }
{                                                                             }
{  My home page :                                                             }
{   http://www.kursknet.ru\~boa                                               }
{                                                                             }
{ --------------------------------------------------------------------------- }

unit SelectForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ImgList, GlobalConst;

type
  TConfigState = (csStartup, csSelectProg, csPrepare, csCopyProg, csDone, csNone);



  TSelectFm = class(TForm)
    Bevel1: TBevel;
    SelectTreeImg: TImageList;
    SelectTreeStateImg: TImageList;
    WizardPages: TNotebook;
    ModeLabel: TLabel;
    Panel1: TPanel;
    HelpBt: TButton;
    Panel2: TPanel;
    CancelBt: TButton;
    NextBt: TButton;
    PrevBt: TButton;
    Panel3: TPanel;
    FastSelect: TRadioGroup;
    Panel4: TPanel;
    SelectProgTree: TTreeView;
    Splitter1: TSplitter;
    Panel5: TPanel;
    LogMemo: TMemo;
    Panel6: TPanel;
    PowerOffCb: TCheckBox;
    Panel7: TPanel;
    CopyLabel: TLabel;
    WizardImage: TImage;
    Panel8: TPanel;
    FinishLabel: TLabel;
    Panel9: TPanel;
    WelcomeLabel: TLabel;
    Panel10: TPanel;
    HelpMemo: TMemo;
    Splitter2: TSplitter;
    TopLogoImage: TImage;
    SellMemo: TMemo;
    procedure SelectProgTreeClick(Sender: TObject);
    procedure SelectProgTreeExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure SelectProgTreeCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure SelectProgTreeExpanded(Sender: TObject; Node: TTreeNode);
    procedure SelectProgTreeCollapsed(Sender: TObject; Node: TTreeNode);
    procedure FastSelectClick(Sender: TObject);
    procedure CancelBtClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SelectProgTreeChange(Sender: TObject; Node: TTreeNode);
    procedure NextBtClick(Sender: TObject);
    procedure HelpBtClick(Sender: TObject);
    procedure SelectProgTreeMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SelectProgTreeKeyPress(Sender: TObject; var Key: Char);
    procedure SelectProgTreeCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure LogoImageClick(Sender: TObject);
    procedure PrevBtClick(Sender: TObject);
    procedure TopLogoImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TopLogoImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TopLogoImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private declarations }
    IniName:string;
    CfgDir:string;
    DestDir:string;
    SourceDir:string;
    CurrentState: TConfigState;
    Moving:boolean;
    OldLeft:integer;
    OldTop:integer;
    SaveOk:boolean;
    procedure NodeStateChange(Node:TTreeNode);
    procedure SaveSelectResult;
    procedure SetConfigState(State: TConfigState);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public declarations }
  end;

var
  SelectFm: TSelectFm;

implementation

uses
  CommonProc, CommonCtrl, Hints;

 {$R *.dfm}

{
procedure TSelectFm.NodeStateChange(Node:TTreeNode);
var
  ParentNode: TTreeNode;
  I:integer;
  Intermediate: boolean;
  AStateIndex:integer;

  function SetSelection(ANode: TTreeNode; AIndex: integer):boolean;
   var
     TempState:boolean;
     ChangeState:boolean;
  begin
  result:=true;
  ChangeState:=true;
  if (ANode.Level = 1) and
     (ANode.Data <> nil)  then begin
       if PInstallItem(ANode.Data)^.Fixed then begin
                                                result:= ANode.StateIndex = AIndex+3 ;
                                                ChangeState:=false

                                          end else begin
          TempState:= AIndex=2;
          if TempState <> PInstallItem(ANode.Data).Selected then begin
              PInstallItem(ANode.Data).Selected:= TempState;
              if TempState then CheckExclude(PInstallItem(ANode.Data));
              CheckDepends(PInstallItem(ANode.Data));
          end;
       end;
      end
   else
     if (ANode.Level = 0) and
        (ANode.Data <> nil) then begin
           result:=not PInstallGroup(ANode.Data)^.Fixed;
           if result then PInstallGroup(ANode.Data).Selected:=AIndex-1;
        end;
     if result and ChangeState then ANode.StateIndex:=AIndex;
  end;

begin
 if (Node<> nil) then begin
    if (Node.StateIndex = 1) then AStateIndex:=2
                             else AStateIndex:=1;

    if SetSelection(Node, AStateIndex) then begin
     if Node.Count > 0 then
     begin
        Intermediate:=false;
        for i:=Node.Count-1  downto 0 do SetSelection(Node.Item[I], AStateIndex);
        for i:=0 to Node.Count-1 do begin
         if AStateIndex <> Node.Item[I].StateIndex then
         begin
           Intermediate:=true;
           Break;
         end;
       end;
       if Intermediate then SetSelection(Node, 3);
     end;
     
     ParentNode:=Node.Parent;
     if ParentNode<> nil then begin
       Intermediate:=false;
       for i:=0 to ParentNode.Count-1 do begin
         if AStateIndex <> ParentNode.Item[I].StateIndex then
         begin
           Intermediate:=true;
           Break;
         end;
       end;
       if Intermediate then SetSelection(ParentNode, 3)
                       else SetSelection(ParentNode, AStateIndex);
     end;
   end;
   FastSelect.ItemIndex:=3;
   SellMemo.Text:= SafeFormat(ConfigAllSelectCaption +#13#10+ ConfigGroupSelectCaption + #13#10,[GetAllSelectCount, GetAllItemCount,GetSelGroupCount, GetUsedGroupCount]);
 end;
end;   }

procedure TSelectFm.NodeStateChange(Node:TTreeNode);
var
  I:integer;
  AStateIndex:integer;
  IGroup: PInstallGroup;
  IItem: PInstallItem;

begin
//SelectProgTree.Items.BeginUpdate;
//try
 if (Node<> nil) and (Node.Data <> nil)then begin
   if Node.Level = 0 then  begin
      IGroup:= PInstallGroup(Node.Data);
      if IGroup.Fixed then exit;
      IGroup.St3Checked:= not IGroup.St3Checked;
      AStateIndex:= IGroup.Selected;
      if IGroup.Selected =1 then IGroup.Selected :=0
      else if IGroup.Selected = 0 then IGroup.Selected :=1;
      AStateIndex:=SetGroupSelected(IGroup,IGroup.St3Checked);
      IGroup.INode.StateIndex:= AStateIndex +1;
      IItem:=nil;
   end else begin
      IItem:= PInstallItem(Node.Data);
      if IItem.Fixed then exit;
      IGroup:= PInstallGroup(IItem.Parent);
      IItem.Selected:= not IItem.Selected;
      CheckExclude(IItem);
      CheckDepends(IItem);
   end;

   for I := 0 to IGroup.ItemList.Count - 1 do  begin
     if PInstallItem(IGroup.ItemList[i]).Visible then begin
        AStateIndex:= 1+Ord(PInstallItem(IGroup.ItemList[i]).Selected);
        if PInstallItem(IGroup.ItemList[i]).Fixed then AStateIndex:=AStateIndex+3;
        if PInstallItem(IGroup.ItemList[i]).INode <> nil then PInstallItem(IGroup.ItemList[i]).INode.StateIndex:= AStateIndex;
      end;
   end;

   AStateIndex:=CheckGroupSelected(IGroup);
   IGroup.Selected:= AStateIndex;
   if AStateIndex < 2 then  IGroup.St3Checked:= AStateIndex =1;
   
   if IGroup.Fixed then AStateIndex:=AStateIndex+3;
   IGroup.INode.StateIndex:= AStateIndex +1;
   FastSelect.ItemIndex:=3;
   SellMemo.Text:= SafeFormat(ConfigAllSelectCaption +#13#10+ ConfigGroupSelectCaption + #13#10,[GetAllSelectCount, GetAllItemCount,GetSelGroupCount, GetUsedGroupCount]);

 end;
//finally
  //SelectProgTree.Items.EndUpdate;
//end;

end; 



procedure TSelectFm.SelectProgTreeClick(Sender: TObject);
var
  Node: TTreeNode;
  P:TPoint;
  HT: THitTests;
begin
 GetCursorPos(P);
 P:=SelectProgTree.ScreenToClient(P);
 Node:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 if (Node<> nil) and
    (htOnStateIcon in HT) then NodeStateChange(Node);
end;



procedure TSelectFm.SelectProgTreeExpanding(Sender: TObject;
  Node: TTreeNode; var AllowExpansion: Boolean);
var
  ANode: TTreeNode;
  P:TPoint;
  HT: THitTests;
begin
 GetCursorPos(P);
 P:=SelectProgTree.ScreenToClient(P);
 ANode:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 AllowExpansion:= not( (ANode<> nil) and (htOnStateIcon in HT) );
end;


procedure TSelectFm.SelectProgTreeCollapsing(Sender: TObject;
  Node: TTreeNode; var AllowCollapse: Boolean);
var
  ANode: TTreeNode;
  P:TPoint;
  HT: THitTests;
  Prevent:boolean;
begin
 GetCursorPos(P);
 Prevent:=false;
 P:=SelectProgTree.ScreenToClient(P);
 ANode:=SelectProgTree.GetNodeAt(P.X, P.Y);
 HT := SelectProgTree.GetHitTestInfoAt(P.X, P.Y);
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) then begin
   Prevent:=PInstallGroup(Node.Data)^.Blocked;
 end;
 AllowCollapse:= not( ((ANode<> nil) and (htOnStateIcon in HT)) or Prevent);
end;

procedure TSelectFm.SelectProgTreeExpanded(Sender: TObject;
  Node: TTreeNode);
begin
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) and
  (PInstallGroup(Node.Data)^.Blocked) then begin
   Node.ImageIndex:=2;
   Node.SelectedIndex:=2;
  end else begin
   Node.ImageIndex:=1;
   Node.SelectedIndex:=1;
  end
end;

procedure TSelectFm.SelectProgTreeCollapsed(Sender: TObject;
  Node: TTreeNode);
begin
 if (Node<> nil) and
  (Node.Level = 0) and
  (Node.Data <> nil) and
  (PInstallGroup(Node.Data)^.Blocked) then begin
   Node.ImageIndex:=2;
   Node.SelectedIndex:=2;
  end else begin
   Node.ImageIndex:=0;
   Node.SelectedIndex:=0;
  end
end;

procedure TSelectFm.FastSelectClick(Sender: TObject);
 var
  Node: TTreeNode;
  I:Integer;

  procedure SetDefaultSelection(ANode: TTreeNode);
   var
    SelIndex: Integer;
  begin
  SelIndex:=0;
  if (ANode.Level = 1) and
       (ANode.Data <> nil)
         then begin
               SelIndex:=ord(PInstallItem(ANode.Data)^.Selected)+1;
               if PInstallItem(ANode.Data)^.Fixed then inc(SelIndex,3);
         end
   else
     if (ANode.Level = 0) and
        (ANode.Data <> nil)
           then begin
              SelIndex:=PInstallGroup(ANode.Data)^.Selected+1;
              if PInstallGroup(ANode.Data)^.Fixed then  inc(SelIndex,3);
           end;
     Node.StateIndex:=SelIndex;
  end;
  
begin

  case FastSelect.ItemIndex of
   0: SetDefault;
   1: SetState(true);
   2: SetState(false);
  end;

  for I:=0 to SelectProgTree.Items.Count-1 do begin
    Node:=SelectProgTree.Items[I];
    SetDefaultSelection(Node);
  end;

  SellMemo.Text:= SafeFormat(ConfigAllSelectCaption +#13#10+ ConfigGroupSelectCaption + #13#10,[GetAllSelectCount, GetAllItemCount,GetSelGroupCount, GetUsedGroupCount]);
end;

procedure TSelectFm.FormCreate(Sender: TObject);
var
 I:integer;
 ResImg:TBitmap;
 Alpha:Byte;
begin
  SaveOk:=false;
  CreateInstallList; 
  GetSelfFolder;
  SkinIni:=GetSkinIni;
  SkinFolder:=GetSkinFolder;
  if not ValidateSkin(SkinIni) then begin
      MessageBox(Handle,PChar('Skin configuration file not found,'#13#10'wrong (mismatch) version or structure corrupt.'#13#10'Please, check skin.ini file.'#13#10#13#10'Program terminated!'),
                 PChar('Fatal error'), MB_OK or MB_ICONERROR);
      ExitCode:= WRONG_SKIN;
      Application.Terminate;
      Exit;
   end;
   if not CheckLicense then begin
                             MessageBox(Handle,PChar('License file (license.txt) not found in program dir.'#13#10'License violated!'#13#10#13#10'Program terminated!'),
                                        PChar('Fatal error'), MB_OK or MB_ICONERROR);
                             AddDebugMsg('Missing License file (license.txt)!');
                             AddDebugMsg('Fatal error, program termnnated.');
                             ExitCode:= WRONG_LIC;
                             Application.Terminate;
                             Exit;
                           end;
  if not CheckReadMe  then begin
                            MessageBox(Handle,PChar('Readme file (readme.txt) not found in program dir.'#13#10'License violated!'#13#10#13#10'Program terminated!'),
                                        PChar('Fatal error'), MB_OK or MB_ICONERROR);
                            AddDebugMsg('Missing Readme file (readme.txt)!');
                            AddDebugMsg('Fatal error, program termnnated.');
                            ExitCode:= WRONG_LIC;
                            Application.Terminate;
                            Exit;
                           end;
  LoadLocalisedConfigForm(SkinIni);
  LoadLocalisedCommon(SkinIni);
  LoadInterfaceSetting(SkinIni);
  //if StayOnTop then FormStyle:=fsStayOnTop else FormStyle:=fsNormal;
  PeMode:= IsPeMode;
  BigIconList:=nil;
  SelectFm.Font.Name:=CommonFont;
  SelectFm.Font.Charset:=CommonCharSet;
  Screen.HintFont.Name:=HintFont;
  Screen.HintFont.Charset:=CommonCharSet;
  SmallIconList:=SelectTreeImg;
  if FileExists(SkinFolder + TOPWIZ_LOGO) then  TopLogoImage.Picture.LoadFromFile(SkinFolder + TOPWIZ_LOGO);
  if FileExists(SkinFolder + LEFTWIZ_LOGO) then  WizardImage.Picture.LoadFromFile(SkinFolder + LEFTWIZ_LOGO);
   ResImg:=TBitmap.Create;
   try
     if FileExists(SkinFolder + GROUP_SMALL) then
     ResImg.LoadFromFile(SkinFolder + GROUP_SMALL);
     if not ResImg.Empty then  begin
      SelectTreeImg.Clear;
      SelectTreeImg.Height:=ResImg.Height;
      SelectTreeImg.Width:=ResImg.Width div 4;
      SelectTreeImg.AddMasked(ResImg,ResImg.Canvas.Pixels[0,ResImg.Height-1]);
     end;
   finally
     ResImg.Free;
   end;
   ResImg:=TBitmap.Create;
   try
     if FileExists(SkinFolder + TREESEL_SMALL) then
     ResImg.LoadFromFile(SkinFolder + TREESEL_SMALL);
     if not ResImg.Empty then begin
      SelectTreeStateImg.Clear;
      SelectTreeStateImg.Height:=ResImg.Height;
      SelectTreeStateImg.Width:=ResImg.Width div 7;
      SelectTreeStateImg.AddMasked(ResImg,ResImg.Canvas.Pixels[0,ResImg.Height-1]);
     end;
   finally
     ResImg.Free;
   end;
  HelpMemo.Hint:=ConfigHelpMemoHint;
  HelpBt.Caption:=ConfigHelpBtCaption;
  PowerOffCb.Caption := ConfigPowerOffCbCaption;
  PowerOffCb.Hint := ConfigPowerOffCbHint;
  PowerOffCb.Visible:= not  PeMode;
  if PeMode then ModeLabel.Caption:= ModeLabel.Caption + ' (PE mode)';
  NextBt.Caption:= ConfigNextBtCaption;
  NextBt.Hint:= ConfigNextBtHint;
  PrevBt.Caption:= ConfigPrevBtCaption;
  PrevBt.Hint:= ConfigPrevBtHint;
  CancelBt.Caption:=ConfigCancelBtCaption;
  CancelBt.Hint:=ConfigCancelBtHint;

  FastSelect.Caption:=ConfigFastSelectCaption;
  FastSelect.Items.Text:=ConfigFastSelectItems;
  FastSelect.Hint:=ConfigFastSelectHint;
  FastSelect.Controls[FastSelect.ControlCount-1].enabled:=false;

  Application.HintHidePause:=MyHintHidePause;
  Application.HintPause:=MyHintPause;
  Application.HintShortPause:=MyHintShortPause;
  IconBackColor:= SelectProgTree.Color;
  Alpha:=255;
  if (AlphaBlendLevel <> 255) and
      (not IsPeMode) and
      IsExplorerRuning then begin
      AlphaBlendValue:=AlphaBlendLevel;
      Alpha:=AlphaBlendLevel;
      AlphaBlend:=true;
  end;
  SetHintStyle( hsRoundRect,3, true, taLeftJustify, Alpha);
  for i:=0 to SelectFm.ControlCount -1 do  begin
     THackControl(SelectFm.Controls[i]).font.Name:=CommonFont;
     THackControl(SelectFm.Controls[i]).font.Charset:=CommonCharSet;
  end;
  Application.CancelHint;

  CfgDir:=GetCmdParam('cfg:');
  DestDir:=GetCmdParam('dest:');
  SourceDir:=GetCmdParam('source:');

  if DestDir <> '' then begin
    Caption:=ConfigFormCaptionAdm;
    WelcomeLabel.Caption:=WelcomeLabelCaptionAdm;
    CopyLabel.Caption:= CopyLabelCaptionAdm;
    FinishLabel.Caption:= FinishLabelCaptionAdm;
    ModeLabel.Caption:=ConfigFormCaptionAdm;
  end else begin
    Caption:=ConfigFormCaption;
    WelcomeLabel.Caption:=WelcomeLabelCaption;
    CopyLabel.Caption:= CopyLabelCaption;
    FinishLabel.Caption:= FinishLabelCaption;
    ModeLabel.Caption:=ConfigFormCaption;
  end;

  IniName := GetMainIni;
  if FileExists(IniName)then begin
    GroupsLoadFromIni(IniName);
    FillTreeView(SelectProgTree,true,true);
    FastSelect.ItemIndex:=0;
  end else begin
    MessageBox(Handle,PChar(NoConfigMsg),
               PChar(ConfigErrorCaption),
               MB_OK or MB_ICONERROR);
    ExitCode:=WRONG_INI;
    Application.Terminate;
  end;
  if not ShortSelect then begin
  CurrentState:=csNone;
  SetConfigState(csStartup);
  end else begin
    CurrentState:=csStartup;
    SetConfigState(csSelectProg);
  end;
end;

procedure TSelectFm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style:= Params.Style or WS_THICKFRAME or WS_BORDER;
end;

procedure TSelectFm.SelectProgTreeChange(Sender: TObject; Node: TTreeNode);
var
  NewHint:string;
  Temp:string;
  TmpGroup:PInstallGroup;
begin
   NewHint:='';
   TmpGroup:=nil;
   if (Node.Level = 1) and
      (Node.Data <> nil) then begin
                                NewHint:=PInstallItem(Node.Data).Description;
                                TmpGroup:=PInstallItem(Node.Data).Parent;
                                if GlobalExtendInfo then begin
                                  if PInstallItem(Node.Data)^.Fixed then NewHint:= NewHint+#13#10 + HintNoChangeSelect;
                                  if PInstallItem(Node.Data)^.RebootNeed then NewHint:= NewHint+#13#10+HintNeedReboot;
                                  Temp:=GetExcludeString(Node.Data);
                                  if Temp<> '' then  NewHint:= NewHint+#13#10+Temp;
                                  Temp:=GetDependsString(Node.Data);
                                  if Temp<> '' then  NewHint:= NewHint+#13#10+Temp;
                                end;
                              end
   else
   if (Node.Level = 0) and
      (Node.Data <> nil) then begin
        NewHint:=PInstallGroup(Node.Data).Description;
        TmpGroup:=PInstallGroup(Node.Data);
       end
   else
       NewHint:='';
   HelpMemo.Text:= DelToLf(NewHint);
end;

procedure TSelectFm.SaveSelectResult;
begin
 try
 if CfgDir <> '' then begin
    if not DirectoryExists(ExpandEnvString(CfgDir)) then ForceDirectories(ExpandEnvString(CfgDir));
    SaveConfig(NormaliseAllSlash(ExpandEnvString(CfgDir)) + 'PRESETUP.SET');
    CopyFile(PChar(IniName), PChar(NormaliseAllSlash(ExpandEnvString(CfgDir)) + 'PRESETUP.INI'), false);
  end else
  if DestDir <> '' then begin
    if not DirectoryExists(ExpandEnvString(DestDir)) then ForceDirectories(ExpandEnvString(DestDir));
    SaveConfig(NormaliseAllSlash(ExpandEnvString(DestDir)) + 'PRESETUP.SET');
    GroupsSaveToIni(NormaliseAllSlash(ExpandEnvString(DestDir)) + 'PRESETUP.INI', true);
    CopyFile(PChar(Application.ExeName), PChar(NormaliseAllSlash(ExpandEnvString(DestDir)) + ExtractFileName(Application.ExeName)), false);
    CopyDir(ExtractFilePath(Application.ExeName)+ '\skin', NormaliseAllSlash(ExpandEnvString(DestDir)) +  'skin',Handle, false);
    SelectFm.Enabled:=false;
    try
     CopySet(ExpandEnvString(SourceDir),ExpandEnvString(DestDir),true,Handle, false);
    finally
    SelectFm.Enabled:=true;
    end;                            
  end else
  SaveConfig(ChangeFileExt(GetMainIni,'.SET'));
 except
  SetConfigState(csDone);
 end;
 SetConfigState(csDone);
end;

procedure TSelectFm.CancelBtClick(Sender: TObject);
begin
 ExitCode:=CANCEL_EXIT;
 Close;
end;

procedure TSelectFm.PrevBtClick(Sender: TObject);
begin
 SetConfigState(TConfigState(Ord(CurrentState)-1));
end;

procedure TSelectFm.NextBtClick(Sender: TObject);
begin
 SetConfigState(TConfigState(Ord(CurrentState)+1));
end;

procedure TSelectFm.HelpBtClick(Sender: TObject);
var
  help:string;
begin
  if  DestDir <> '' then Help:=ConfigHelpTextsAdm[WizardPages.PageIndex]
                    else Help:=ConfigHelpTextsNorm[WizardPages.PageIndex];
  if PeMode then  Help:=ConfigHelpTextsPe[WizardPages.PageIndex];

  MessageBoxEx(Handle,PChar(Help),
             PChar(ConfigHelpMbCaption),
             MB_OK or MB_ICONINFORMATION,
             LangId);
end;                               

procedure TSelectFm.SelectProgTreeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  NewHint:string;
  Node:TTreeNode;
begin
 Node:=SelectProgTree.GetNodeAt(X, Y);
 if Node <> nil then begin
    if (Node.Level = 1) and
      (Node.Data <> nil) then begin
                            NewHint:=DelToLf(PInstallItem(Node.Data)^.Description);
                            if PInstallItem(Node.Data)^.Fixed then NewHint:= NewHint+#13#10+HintNoChangeSelect;
                            if PInstallItem(Node.Data)^.RebootNeed then NewHint:= NewHint+#13#10+HintNeedReboot;
                         end
   else
   if (Node.Level = 0) and
      (Node.Data <> nil) then NewHint:=DelToLf(PInstallGroup(Node.Data)^.Description)
   else
       NewHint:='';
 end else NewHint:='';

 if SelectProgTree.Hint <> NewHint then begin
    Application.CancelHint;
    SelectProgTree.Hint:=NewHint;    
 end;
end;

procedure TSelectFm.SelectProgTreeKeyPress(Sender: TObject; var Key: Char);
begin
 if (Key = ' ') or (Key = #13) then begin
    Key:=#0;
    NodeStateChange(SelectProgTree.Selected);
 end;
end;

procedure TSelectFm.SelectProgTreeCustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  //if  Node.Level = 0 then if cdsSelected in State then  Sender.Canvas.Font.Color:= clAqua
  //                                                else  Sender.Canvas.Font.Color:= clBlue;

  if  Node.Level = 0 then  Sender.Canvas.Font.Style:= Sender.Canvas.Font.Style  +[fsBold]
                     else  Sender.Canvas.Font.Style:= Sender.Canvas.Font.Style  -[fsBold];
end;

procedure TSelectFm.LogoImageClick(Sender: TObject);
begin
  MessageBoxEx(SelectFm.Handle,PChar(GetAboutInfo),
             PChar(AboutCaption), MB_OK or MB_ICONINFORMATION, LangId);
end;

procedure TSelectFm.SetConfigState(State: TConfigState);
begin
  if CurrentState <> State then begin
     CurrentState:= State;
     WizardPages.PageIndex:= Ord(State);
     if not ShortSelect then begin
       PrevBt.Enabled:=(State > csStartup) and (State < csCopyProg);
       NextBt.Enabled:=(State < csCopyProg);
       if (State < csDone) then CancelBt.Caption:= ConfigCancelBtCaption
                           else CancelBt.Caption:= ConfigFinishBtCaption;
       case State of
         csStartup:;
         csSelectProg:;
         csPrepare:begin
                     LogMemo.Lines.BeginUpdate;
                     try
                       MakeSelectLog(LogMemo.Lines);
                       LogMemo.SelStart:=0;
                       LogMemo.SelLength:=1;
                    finally
                      LogMemo.Lines.EndUpdate;
                    end;
                   end;
         csCopyProg: SaveSelectResult;
         csDone: begin
                    ExitCode:=OK_EXIT;
                    SaveOk:=true;
                 end;
       end;
     end else begin
        PrevBt.Visible:=false;
        NextBt.Enabled:=true;
        NextBt.Caption:=ConfigSaveBtCaption;
        NextBt.Hint:= ConfigSaveBtHint;
        CancelBt.Caption:=ConfigCancelBtCaption;

        if State = csPrepare then begin
           SaveSelectResult;
           ExitCode:=OK_EXIT;
           SaveOk:=true;
           Close;
        end;
     end;
  end;
end;



procedure TSelectFm.TopLogoImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) then begin
    SetCapture(SelectFm.Handle);
    OldLeft := X;
    OldTop := Y;
    Screen.Cursor:=crSizeAll;
    Moving := True;
  end;
end;

procedure TSelectFm.TopLogoImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if Moving then begin
     SelectFm.SetBounds(SelectFm.Left+X-OldLeft,
                        SelectFm.Top+Y-OldTop,
                        SelectFm.Width,
                        SelectFm.Height);
  end;
end;

procedure TSelectFm.TopLogoImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) then begin
    ReleaseCapture;
    if (SelectFm.Left <> SelectFm.Left+X+OldLeft) or
       (SelectFm.Top <> SelectFm.Top+Y-OldTop) then
         SelectFm.SetBounds(SelectFm.Left+X-OldLeft,
                            SelectFm.Top+Y-OldTop,
                            SelectFm.Width,
                            SelectFm.Height);
    Screen.Cursor:=crDefault;
    Moving := False;
  end;
end;

procedure TSelectFm.FormShow(Sender: TObject);
 var
  WStr,HStr, LStr, TStr :string;
  TW, TH, Tl, TT:integer;
begin
  WStr:=GetCmdParam('w:');
  HStr:=GetCmdParam('h:');
  if (WStr<>'') and (HStr <> '') then begin
    TW:= StrToIntDef(WStr,640);
    TH:= StrToIntDef(HStr,480);
    SelectFm.Width:=Max(TW,640);
    SelectFm.Height:=Max(TH,480);
    SelectFm.Width:=Min(TW,Screen.Width);
    SelectFm.Height:=Min(TH,Screen.Height);
    LStr:=GetCmdParam('l:');
    TStr:=GetCmdParam('t:');
    if (LStr<>'') and (TStr <> '') then begin
     TL:= StrToIntDef(LStr,0);
     TT:= StrToIntDef(TStr,0);
     SelectFm.Left:=Min(TL,Screen.Width-10);
     SelectFm.Top:=Min(TT,Screen.Height-10);
     SelectFm.Left:=Min(TL,Screen.Width-Width);
     SelectFm.Top:=Min(TT,Screen.Height-Height);
    end else
    begin
     SelectFm.Left:=(Screen.Width - SelectFm.Width) div 2;
     SelectFm.Top:=(Screen.Height - SelectFm.Height) div 2;
    end;
  end else begin
   SelectFm.Left:=(Screen.Width - SelectFm.Width) div 2;
   SelectFm.Top:=(Screen.Height - SelectFm.Height) div 2;
  end;
end;

procedure TSelectFm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not SaveOk and (ExitCode = 0) then  ExitCode:=CANCEL_EXIT;
end;

end.





